/*--------------------------------------------------------------*
 | File:	filter.c					|
 | Function:	conversion of characters			|
 | Programmer	J.D.J. Derksen jr/ E. J. M. Visschedijk		|
 | Date:	11-10-87					|
 | Version:	V1.0						|
 *--------------------------------------------------------------*/

#include stdio.h

#define TRUE	1

main(argc,argv)
int argc,argv[];
{
	FILE in,out;
	char c;

	switch(argc)
	{
		case 1:
			in=stdin;
			out=stdout;
			break;
		case 2:
			if ((in=fopen(argv[1],"r"))==NULL){
				printf("Can't open %s for read\n",argv[1]);
				exit(ERR);
			}
			out=stdout;
			break;
		case 3:
			if ((in=fopen(argv[1],"r"))==NULL){
				printf("Can't open %s for read\n",argv[1]);
				exit(ERR);
			}
			if ((out=fopen(argv[2],"w"))==NULL){
				printf("Can't open %s\n for write",argv[1]);
				exit(ERR);
			}
			break;
		default:
			printf("Usage: filter [infile [outfile]]\n");
			exit(ERR);
	}

	while(TRUE)
	{
		if((c=getc(in))==EOF)
			break;

/*	Insert your own algorithm here.					*/

		/* convert to upper case characters	*/

		fprintf(out, "%c", toupper(c));

	}
	fclose(in);
	fclose(out);
}
