HEX
VOCABULARY ASSEMBLER IMMEDIATE ASSEMBLER DEFINITIONS
 
' (LOOP)  1+   C@       CONSTANT XSAVE
' LIT     1+   C@       CONSTANT IP
' LIT   22 +   C@       CONSTANT W
' COLD  16 +   C@       CONSTANT UP
' EXECUTE NFA 6 - C@ 1+ CONSTANT N
' (DO)  0E +            CONSTANT POP
' (DO)  0C +            CONSTANT POPTWO
' LIT   13 +            CONSTANT PUT
' LIT   11 +            CONSTANT PUSH
' LIT   18 +            CONSTANT NEXT
' EXECUTE NFA 11 -      CONSTANT SETUP

0 VARIABLE INDEX -2 ALLOT
  0909  ,  1505  ,  0115  ,  8011  ,
  8009  ,  1D0D  ,  1219  ,  8080  ,
  0080  ,  1404  ,  8014  ,  8080  ,
  8080  ,  1C0C  ,  801C  ,  2C3C  ,

2 VARIABLE MODE 

: .A    0 MODE ! ;
: #     1 MODE ! ;
: MEM   2 MODE ! ;
: ,X    3 MODE ! ;
: ,Y    4 MODE ! ;
: X)    5 MODE ! ;
: )Y    6 MODE ! ;
: Z)    D MODE ! ;
: )X    E MODE ! ;
: )     F MODE ! ;

: BOT   ,X    0 ;
: SEC   ,X    2 ;
: RP)   ,X  101 ;

: ASMERROR  MEM CR LATEST ID. 3 ERROR ;

: UPMODE  IF MODE @ 8 AND 0= IF 8 MODE +! ENDIF ENDIF
           1 MODE @ 0F AND -DUP IF 0 DO DUP + LOOP ENDIF
            OVER 1+ @ AND 0= ;

: CPU  <BUILDS  C, DOES> C@ C, MEM ;

  00 CPU BRK,  18 CPU CLC,  D8 CPU CLD,  58 CPU CLI,
  B8 CPU CLV,  CA CPU DEX,  88 CPU DEY,  E8 CPU INX,
  C8 CPU INY,  EA CPU NOP,  08 CPU PHP,  48 CPU PHA,
  DA CPU PHX,  5A CPU PHY,  68 CPU PLA,  28 CPU PLP,
  FA CPU PLX,  7A CPU PLY,  40 CPU RTI,  60 CPU RTS,
  38 CPU SEC,  F8 CPU SED,  78 CPU SEI,  AA CPU TAX,
  A8 CPU TAY,  BA CPU TSX,  8A CPU TXA,  9A CPU TXS,
  98 CPU TYA,  3A CPU DEA,  1A CPU INA,

: M/CPU   <BUILDS C, , DOES> DUP 1+ @ 80 AND 
           IF 10 MODE +! ENDIF
          OVER FF00 AND UPMODE UPMODE IF ASMERROR ENDIF
           C@ MODE C@ INDEX + C@ + C, MODE C@ 7 AND
          IF MODE C@ 0F AND DUP 7 < SWAP D = OR
           IF C, ELSE , ENDIF  ENDIF  MEM ;
 
  3C6E 60 M/CPU ADC,  3C6E 20 M/CPU AND,  3C6E C0 M/CPU CMP,
  3C6E 40 M/CPU EOR,  3C6E A0 M/CPU LDA,  3C6E 00 M/CPU ORA,
  3C6E E0 M/CPU SBC,  3C6C 80 M/CPU STA,  0D0D 01 M/CPU ASL,
  0C0C C1 M/CPU DEC,  0C0C E1 M/CPU INC,  0D0D 41 M/CPU LSR,
  0D0D 21 M/CPU ROL,  0D0D 61 M/CPU ROR,  0414 81 M/CPU STX,
  0486 E0 M/CPU CPX,  0486 C0 M/CPU CPY,  1496 A2 M/CPU LDX,
  0C8E A0 M/CPU LDY,  048C 80 M/CPU STY,  0480 14 M/CPU JSR,
  C480 40 M/CPU JMP,  0484 10 M/CPU TRB,  0484 00 M/CPU TSB,

: M2/CPU  <BUILDS , , , DOES> MODE @ DUP 0= SWAP 3 > OR
          IF ASMERROR ENDIF OVER FF00 AND
          IF MODE @ 1 = 0= 
          IF 2 MODE +! ENDIF ENDIF 
          MODE @ + C@ DUP 0= IF ASMERROR ENDIF
          C, MODE @ 4 < IF C, ELSE , ENDIF MEM ;
 
  3C2C 3424 8900  M2/CPU BIT,
  9E9C 7464 0000  M2/CPU STZ,

  00 CONSTANT M0   10 CONSTANT M1  20 CONSTANT M2
  30 CONSTANT M3   40 CONSTANT M4  50 CONSTANT M5
  60 CONSTANT M6   70 CONSTANT M7

: BITGEN  C@ + OVER FF00 AND MODE @ 2 = 0= OR
                  IF ASMERROR ENDIF ;

: M3/CPU   <BUILDS C, DOES> BITGEN C, C, ;

  07 M3/CPU RMB,   87 M3/CPU SMB,

: M4/CPU <BUILDS C, DOES> BITGEN C, ;

  0F M4/CPU SET    8F M4/CPU CLR

: BEGIN,   HERE 1 ; IMMEDIATE
: UNTIL,   ?EXEC >R 1 ?PAIRS R> C, HERE 1+ - C, ; IMMEDIATE

: IF,      C, HERE 0 C, 2 ; IMMEDIATE
: THEN,    ?EXEC 2 ?PAIRS HERE OVER C@ 
             IF SWAP ! ELSE OVER 1+ - SWAP C! ENDIF ; IMMEDIATE
: ELSE,    2 ?PAIRS HERE 1+ 1 JMP, SWAP HERE OVER
                                     1+ - SWAP C! 2 ; IMMEDIATE

: NOT 20 + ;

  90 CONSTANT CS
  D0 CONSTANT 0=
  10 CONSTANT 0<
  90 CONSTANT >=
  50 CONSTANT VS

: ALABEL <BUILDS , DOES> @ ;

: END-CODE  CURRENT @ CONTEXT ! ?EXEC ?CSP SMUDGE ; IMMEDIATE

FORTH DEFINITIONS DECIMAL

: CODE   ?EX