( *****************FORTH EXTENTIONS******************* )

HEX

6 USER SO
: JSR    HERE ! SP@ SO C! HERE ' LIT 17 + >R EXECUTE  SP! 9E SO C! ;

: U.    0 D.  ;

: DEPTH    9E SP@ - 2 / ;
: .S     CR  DEPTH IF SP@ 2 - A0 2 - DO I @ U. -2 +LOOP 
                   ELSE  ." EMPTY "   THEN ;

DECIMAL

: DUMP1       0 DO DUP I + C@ 3 .R LOOP DROP ;

HEX

: ?NON-PRINTING     DUP 20 < SWAP 7E > OR ;
: &TYPE    0 DO DUP I + C@ DUP ?NON-PRINTING 
                   IF DROP 2E THEN EMIT LOOP DROP ;
: A-LINE   CR DUP 0 6 D.R SPACE 10 OVER OVER DUMP1 2 SPACES &TYPE ;
: DUMP     0 DO DUP I + A-LINE 10 +LOOP DROP ;


: REVID   1B EMIT  69 EMIT ;
: VID     1B EMIT  6E EMIT ;
: CURON    0A E140 C!    09 E141 C! ;
: CUROFF   0A E140 C!    29 E141 C! ;
: CLS    0C EMIT ;
: BEL    07 EMIT ;


: BIN 2 BASE ! ;

: <CMOVE     -DUP IF >R R + 1 - SWAP 1 - R> OVER + DO I C@ 
             OVER C! 1 - -1 +LOOP DROP ELSE DROP DROP THEN ;

: CASE     ?COMP CSP @ !CSP 4 ; IMMEDIATE
: OF       4 ?PAIRS COMPILE OVER COMPILE = COMPILE 0BRANCH
            HERE 0 , COMPILE DROP 5 ; IMMEDIATE
: ENDOF    5 ?PAIRS  COMPILE BRANCH HERE 0 , SWAP 2 [COMPILE] THEN
            4 ; IMMEDIATE
: ENDCASE    4 ?PAIRS COMPILE DROP BEGIN SP@ CSP @ = 0= WHILE
              2 [COMPILE] THEN REPEAT CSP ! ; IMMEDIATE

: TEXT     HERE C/L 1+ BLANKS WORD HERE PAD C/L 1+ CMOVE ;
: LINE    DUP FFF0 AND 17 ?ERROR SCR @ (LINE) DROP ;

: 2DROP    DROP DROP ;
: 2SWAP    ROT >R ROT R> ;

: TRHU     1+ SWAP DO I LOAD LOOP ;

: WHERE   DUP B/SCR / DUP SCR ! ." SCR # " DECIMAL . SWAP C/L 
           /MOD C/L * ROT BLOCK + CR C/L TYPE CR HERE C@ - 
            SPACES 5E EMIT [COMPILE] QUIT ;

: COPY    B/SCR * OFFSET @ + SWAP B/SCR * B/SCR OVER + SWAP 
             DO DUP I BLOCK 2 - ! 1+ UPDATE LOOP 
          DROP FLUSH ;


: PRT-ON     C0 E710 C! ;
: PRT-OFF    80 E710 C! ;

: 0:    0 3695 C! 0 3613 C! ;
: 1:    1 3695 C! 1 3613 C! ;


0 VARIABLE PRV

: UPD-4    9170 PRV ! 
            4 0 DO PRV @ @ 8000 OR PRV @ ! 104 PRV +! LOOP ;

: BACKUP   1+ SWAP DO I LIST UPD-4 0: FLUSH 1: LOOP ;

: @2KEY      KEY 30 - 0A * KEY 30 -  + ;
: TIME       @2KEY E782 C! @2KEY E783 C! 0 E784 C! ;
: DATE       @2KEY E77F C!  @2KEY E780 C! @2KEY E781 C! FF E77E C! ;


FORTH DEFINITIONS DECIMAL
LATEST      12 +ORIGIN !   (  TOP NFA )
HERE        28 +ORIGIN !   ( FENCE SET FOR LAST WORD )
HERE        30 +ORIGIN !   ( DICTIONAIRY POINTER )
HERE             FENCE !
1           26 +ORIGIN !   ( WARNING SET FOR DISK )
' FORTH 6 + 32 +ORIGIN !   ( VOCABULARY LINK )
