
{$C6000} {$X+} {$F+} {$G+} {$D+}
program CambridgetoBBC (input,output,in_file,out_file);
{This program reads in an Acorn Pascal editor file and outputs it
 in 32016 editor format}

type  string=packed array[1..20] of char;
    
 var
    ip                                               :char;
    in_file,out_file                                 :text;
    name_in,name_out                                 :string;
    no_error                                         :boolean;

procedure get_name(var s:string;var b:boolean);
var    i, k                   :integer;
       f                      :boolean;
begin;
i:=1;
s:='                    ';
f:=false;
 repeat
   repeat
   k:=inkey(10);
   until ((k>27) and (k<128)) or (k=13);
  case k of
  127:if i>1 then 
      begin;
      i:=i-1;
      s[i]:=' ';
      write(chr(127):1);
      end;
  13 :f:=true;
  end

  otherwise if i<20 then
  begin;
  s[i]:=chr(k);
  i:=i+1;
  write(chr(k):1);
  end;

 until f;
 if i>1 then b:=true else b:=false;

end;

begin;{main program}
mode(3);
writeln('Program to convert Acorn Pascal Editor files to 32016 Editor format');
writeln;
write('Enter name of input file ');
repeat
 get_name(name_in,no_error);
until no_error;
writeln;
write('Enter a different name for the output file ');
repeat
 get_name(name_out,no_error);
until no_error;
writeln;
writeln;
reset(in_file,name_in);
rewrite(out_file,name_out);

repeat
 read(in_file,ip);
 if (ip=chr(13)) or (ord(ip)>31) then
 begin;
  if ip=chr(13) then writeln else write(ip);
  if ip=chr(13) then write(out_file,chr(10)) else write(out_file,ip);
 end;
until eof(in_file);
writeln;
writeln('**************************************************************');
writeln;
writeln('***************** PROCESSING COMPLETE ************************');
end.
