 	Viditel manual                                        Pagina  1


*********************** USERS GUIDE VIDITEL-65 ************************

by B. de Bruine				       Viditel V2.2, june 1987.

Nor  waranty  of the software, nor of the accuracy of the documentation
surrounding  it  is  expressed  or  implied, and neither the author nor
distributor   acknowledge  any  liability  resulting  from  program  or
documentation errors. Special care is taken to avoid errors.
 	Viditel manual                                        Pagina  2


		TABLE OF CONTENTS
		=================

file summary
ordering information

 1. Introduction
 2. Terminology
 3. Installation
 4. Starting the Viditel-65 program
 5. The Prestel standard
    5.1 History
    5.2 Numerical search and tree structure
	5.2.1 Systematic search following the tree structure
	5.2.2 Search with an alphabethical list of catchwords
	5.2.3 Searching by way of a list of information suppliers
	5.2.4 Multi-criteria search
	5.2.5 Direct access to a page.
    5.3 The protocoltable
 6. Commands main mode
 7. Commands terminal mode
 8. The statuslines
    8.1 The statusline of the mainmode
    8.2 The statusline of the terminalmode
    8.3 The statusline of the autodialer
 9. How to use Viditel-65
10. Help utilities
11. Health effects of VDUs
12. Literature Videotex

APPENDICES:
The appendices are written in the Dutch language.

I.    Configuratie
II.   Configuratievariabelen
III.  Lijst met te definieren toetsen
IV.   Geheugenindeling
V.    Automatisch bellen
VI.   RS 232
VII.  Foutmeldingen
VIII. Verschillen met vorige versies
IX.   Commandotabel en Prestel codetabel


FILE SUMMARY
++++++++++++
The disk contains:
VIDITEL-65: Main program
VIDITEL.cfg: System dependent values.
VIDITEL.man: Manual Viditel. (this file)
MANUAL.vid: Manual in Dutch.
DEMO.vid:   demo file to show the graphic possibilities of videotex.
CHARGVIDx.rom: Videotex charactergenerator VDU-card.
VITEL.dir: Telephone directory.
MCONFIG:   configuration program.
VIDUMP:	Dumps a videotexfile, showing controlchar and escape seq.
 	Viditel manual                                        Pagina  3



ORDERING INFORMATION
++++++++++++++++++++
The  Viditel-65  software  is  free and available to all. But to defray
costs  of  media,  postage, etc, the distributor may ask for a moderate
donation.  Everyone  who  own  Viditel-65  is free to redistribute this
software  to  any  person.  Please, do not distribute this program with
self-made  changes.  If you think youre located a bug, or find a way to
improve this software, send your contribution to:
Bram Bruine, fido Middelburg msgarea #1, or write to St. Joostdijk 23,
4307 AR Oosterland, ref. 'DOS-65'.

To  order  Viditel-65  or  Astrid(*)  from the editorial office, send a
letter, with a complete description of your wishes to:

R.Vleesch Dubois
Florence Nightingalestraat 212,
2037 NG Haarlem
The Netherlands

Pleace reference:
Diskformat (SS/SD):
O 80 Tr.
O 40 Tr.


Name: ....................
Address: .................  
Zip/City: ..../...........

*NOTE:  Astrid is a public-domain communication program wich allows you
to  let  your computer act as a terminal, and to up/download with ascii
and xmodem.

1. INTRODUCTION
===============

Videotex,  Viewdata  or  Viditel (from now called Videotex) is a medium
for communication of alphanumerical and graphical information. Videotex
embodies a set of rules for displaying graphic or alphanumeric code. To
communicate  with  a  Videotex host, you need a Videotex-terminal. This
manual  describes  the  program, ambigiously also called Viditel, which
let your DOS-65 computer act as a real Videotex terminal.

Now it is possible to access all Videotex hosts, which means that a lot
of  information  is available. There are many information suppliers who
delivers  information  about  education, travelling, (KLM-reservations,
Holland  International)  law  and  order, (Kluwer justitiele databank),
subsidies,  exchange  quotations,  (Beurs  Amsterdam,  Tijl data, Stock
data) vacatures, nightlife, tourist information, auction prices, (Tele-
fleur,  Hobaho)  hobbies  (Hobbytel) and many others. As an overlap the
Dutch  PTT  has  Viditel*,  which  contains  all  kind  of information.
(umbrella function)
 	Viditel manual                                        Pagina  4


The  program  Viditel-65 is based on the international Prestel standard
for  monochrome  displays.  Unfortunately  not  the  entire standard is
implemented:    -The   hardware   does   not   support  double  height.
-It is impossible to create seperate graphics with the DOS-65 hardware.

The  reason to make a Videotex terminal program was the absence of this
kind  of  programs  for  Elector  computers.  So,  I started to write a
Videotex  program,  without any documentation. After a while my program
produced  a  formatted  screen  with  only  ascii characters. A graphic
character  was  converted to a space in inverse video. It was an usable
solution,  but it would be nice to draw some pictures. Fortunately Coen
Boltjes,  a  member  of  'the  6502 kenners' wrote an excellent article
about  this  subject  for  an EC-65 computer. Anyway, Dos-65 Viditel is
based  on  the  EC-65  programme.  Only a few modifications are made to
convert  the  Videotexprogram to DOS-65. Now can both Elector computers
communicate  with  f.e.  Electors  databank,  even  if  Elector did not
provide their own computers with Videotex software.

The  program  is  written  for  everyone who like to communicate with a
Videotexhost. With MCONFIG the program can be configurated for any par-
ticular modem. Any modem is suitable.

This  manual  contains  a  fully description how to use Viditel-65. The
real 'datacommunication-freak' can satisfy his/her needs by reading the
appendices.  Dutch users can load the file manual.vid. This is a manual
in  the Dutch language, conform the Prestel standard. The file demo.vid
demonstrate the graphic possibilities of Videotex.

2. TERMINOLOGY
==============
There's  always  a lot of confusion about terms like Viditel, viewdata,
Videotex(t)  and  teletex(t). The table below eliminates the confusion.

host:	   The remote databank you are connected with.
Videotex:  Or  interactive Videotex is a medium which can show informa-
           tion on a terminal. The user can control the flow of
           information.
Viditel:   Dutch name for Videotex. Also the database of the Dutch PTT.
Viewdata:  Other name for Viditel.
Teletekst: Dutch  name  for a telecommunication system who is transmit-
           ting  textual  information  using  a television transmitter.
           Everyone  who owns a TV-set with teletekst capabilities, can
           decode the teletex messages.
 	Viditel manual                                        Pagina  5


3. INSTALLATION
===============

Viditel-65 is written in standard 6502 machine language.
Assemblerformat: DOS-65 assembler.

3.1 HARDWARE

- DOS 65/IO 65 V2.01 with memorymapped VDU.
- Viditel character generator VDU-card.

3.2 CONFIGURATION
With MCONFIG VIDITEL <CR>
the configuration of Viditel-65 is started. 
For more information read appendix I.

4. STARTING THE VIDITEL-65 PROGRAM
==================================

There are several ways to start:
a.) With  option  -M  first the communicationparameters can be changed,
    or the autodialer can be called. (M = Main Menu)
    VIDI -M <CR>
b.) Without any option, the terminalmode is entered directly.
    VIDI <CR>

If a filename is specified, this file is loaded, if found.
f.e.: VIDI -M DEMO <CR>
      VIDI DEMO <CR>
The file DEMO.vid is loaded.

The program is restartable (after Q or E exit) with:
LC  (Last Command), or
G A000, or
G 1000.
A restart after a "Q"-exit ignores the filename.
 	Viditel manual                                        Pagina  6


5. THE PRESTEL STANDARD
=======================

5.1 HISTORY

The development of Videotex started in the period of the mainframes and
"mini's".  Microcomputers weren't not yet a common property. Datacommu-
nicaton  was reserved for a select group of computer specialists. There
was  a need for a communication medium according to a uniform standard.
In  the  labs of British Telecom programmers start working to develop a
protocol  for  datacommunication. The target was a cheap, userfriendly,
common-used  medium, which everyone can use. They tried to get datacom-
munication  out  of  the  select  circuit  of  specialist,  and make it
accessible  for  the ordinary man/ woman. This point means a limitation
for  the  designers.  Not  every  citizen  has  a  (micro)computer. The
decision  to use a modificated TV in combination with a telephone and a
control-unit  was  made  only  to  reach  more  users. The menus of the
Videotex  concept  can  be  entered  with  only numerical values. It is
enough  to  type  the  pagenumber of the page the user want to see. The
headdesigner  Sam  Fedida  finished  the development of Videotex in the
late seventies. After British Telecom (Prestel-standard), the Dutch PTT
started  with Viditel. The French created their own standard, (Teletel)
just as the German PTT, who developed Bildschirmtext.

5.2 NUMERICAL SEARCH AND TREE-STRUCTURE

Videotex  is  page-oriented.  This means that every time when a page is
printed,  the remote expect some activity from the user. (Thats why its
called INTERACTIVE Videotex)
The  remote mostly wanted an customernumber, accesnumber and a personal
identification number. (PIN-code)
After  the  log  in  procedure  a  menu is printed. The user can make a
choice of the presented possibilities, but more experienced users could
access the page direct.
Every  informationpage  has  a number. (3 to 9 digits) The numbering is
conform  the  principle  of the tree structure. There is a trunk (base)
from  where  grows many twigs. (sub pages, also called follow-up pages)
Every  information supplier in a Videotex remote has a 3 digit starting
page. (Trunkpage or base) For example the Dutch Postbank has in Viditel
as  startingpage  number 501. This is the trunkpage at the third level.
Totally  there  are nine levels. On every level it is possible to add 9
new  pages. (including trunk: 10 pages) On level four (4) the numbering
starts  at  5010  and ended with 5019. Every page can have 26 subpages.
(a..z) Page 501 is, properly writed, page 501a.
Continuing  our  example, the postbanks trunkpage is 501a, page 501211a
describe  paysystems,  page  501113  gives information about mortgages,
etc.  The   user  does  not  notice  this functional grouping with tree
structure,  because  the menu's lead the user always to the right page.
The  next paragraphs describes the various search/access possibilities.

fig. xx scheme tree-structure Videotex.
 	Viditel manual                                        Pagina  7


5.2.1 Systematic search following the tree structure
====================================================
This  method  is  used, if you are not familiar with a certain Videotex
host.  By  answering  the questions of the host the desired information
comes available. Starting at the trunk, you reached at the end the twig
with the wanted information. This method takes much time.

Assume,  you  are connected with the hypothetical host "Hypo", and your
looking  for  information  about  datacommunication  with  an  Atari-ST
computer. The Host yet printed the following menu:

   hypo			0a		0c
   ------------------------------------------
-->1. Systematic search
   2. Catchwords (trefwoorden)
   3. Information suppliers (IL's)
   4. New in HYPO
   5. General info

After making choice 1. the host prints:

   hypo			10a		0c
   ------------------------------------------
   1. Information about Hypo
   2. How to be a member of Hypo
-->3. Software
   4. Bulletinboard members (prikbord)
   5. Bulletinboard guests
   6. Supply and demand

   hypo			103a		0c
   ------------------------------------------
   Software for:
   1. IBM PC XT/AT
-->2. ATARI ST
   3. CBM-64
   4. BBC A/B
   5. ATARI 800 XL
   6. MSX

   hypo			1036a		0c
   ------------------------------------------
	Software ///Atari ST///
   1. Text editing
   2. Spreadsheets and calculation prgrms
   3. Games
-->4. Datacommunication
   5. "C"-programs
   6. New programs

Notice the changes in the pagenumbers. We are getting deeper and deeper
in the tree! After making choice 4 in the last printed menu, probably a
list  with  available datacommunication programs is printed. As you see
this method is a cumbersome manner.
 	Viditel manual                                        Pagina  8


5.2.2 Search with an alphabethical list of catchwords
=====================================================
Again  we are connected with the HYPO Videotex host. now we make choice
2. of the menu on page 0.a.
--> 2. Catchwords

The host respond with:
hypo			2989c
-------------------------------------
	Catchword encyclopedie
	 ** ** ** ** ** ** ** 
11. A	17. G	23. M	29. S	35. Y
12. B	18. H	24. N	30. T	36. Z
13. C	19. I	25. O	31. U
14. D	20. J	26. P	32. V
15. E	21. K	27. Q	33. W
16. F	22. L	28. R	34. X

If you want information about communication, just type:
[1][3][2][5]. (this is CO)
Now the host can print all keywords who starts with CO:

hypo		xxxx		xx
------------------------------------------
		encyclopedie
CO-				 *pagenr.#
Comedy stories.................. 28147
Commodore computers............. 19782
Communication................... 28937
Computers....................... 4359
Concert review.................. 1876


This  method  results in a pagenumber, where the information is placed.
This  page  is  directly  accesible  with  the directmode. (see chapter
5.2.5) To access the startingpage about communication, enter:
*28937#.
This  method  is faster then systematical search, and also a handy tool
to check if information about a certain subject is available.
Of  course  you can enter the whole word where you are looking for, but
mostly  this  is  not necessary. Also you can enter only one character.
e.g. If you only type 11, the complete list of Catchwords starting with
an "A" is printed.

5.2.3. Searching by way of a list of information suppliers
==========================================================
This  method  is  the same as Catchwordsearch, but only informationsup-
pliers are inserted in the list.

hypo		xxxxx			yy
------------------------------------------
A   *Information suppliers*   *pagenr#

Aeg-telefunken................ 230901
Agfa Geveart.................. 455454
Air France.................... 869756
etc.
 	Viditel manual                                        Pagina  9


5.2.4. Multi-criteria search
============================
Videotex  hosts who has this utility makes it easy to search an object.
First you must enter the searchpage, who is always like this:

hypo		xxxxxx			yy
------------------------------------------
	** Search menu **
Give one or more keywords, followed by #.
1.<			(<=cursor)
2.
3.
4.
5.

0=index, [1,5]enter reply, 9=search.

For  example:  To  search  information  about  datacommunication for an
Atari, we can search with the catchwords Atari and Datacom.

1.Atari
2.Datacom
3.
4.
5.

0=index, [1,5]enter reply, 9=search.

It  is  allowed  to shorten the catchwords, e.g. Atari as Ata. The host
starts  searching  for  an  subject  which contains both catchwords. If
there are more subjects, a choice via submenus can be made to reach the
wanted page.

5.2.5. Direct access to a page.
===============================
If  you  know which pagenumber contains the wanted information, you can
enter that page simply by entering:
*pagenr#
This  method  is  the  most  fasted  method, and is used by experienced
users.

The Videotex commands to reach a certain page are:
# 	 To next follow-up page.
* 	 Delete previous command after error.
*# 	 Get previous page.
*pagenr# Get page with specified number. f.e.: *501# shows page 501a on
         the terminal.
*0# 	 Back to the startpage.
*00	 Send  same  page again. Sometimes there is a distortion in the
	 telephone  connection.  If there are strange characters on the
	 screen, just ask the remote to send the page again.
*90# 	 Logging off. Disconnect and leave the Videotex remote.

Note:  Some Videotex systems are not completely standard Videotex. Some
       of them have a limited commandset, others have extensions. (e.g:
       some  hosts allows you to access subpages direct, like: *2323k#)
  						                    =
 	Viditel manual                                        Pagina 10

 
5.3 THE PRESTEL CODETABLE
This  table  shows  all the codes who are used by the Videotexprotocol.
F.e.:  ESC  A  changes  the colour for alphanumerical data in red. With
help  of the utility VIDUMP the protocolcodes are showed on the screen.
(e.g.: Vidump demo.vid, shows the controlcodes of the file demo.vid)

table Prestel codes

6. COMMAND SUMMARY MAINMODE
===========================

HELP
Shows helpinformation.

MENU
Print the available commands.

NEW
Destroy  filename,  (if  exists) clear all pointers and print the menu.
After  this  command  Viditel-65 is in the same position as starting up
with VIDI -M. The transferparameters are not affected.

CONNECT
Go in Videotex terminalmode.

ON HOOK
Disconnect. (DTR and PB6 in idle position)

AUTODIAL
After  entering  the  "A"command  the file VITEL.dir is loaded from the
systemdrive.  Select  with  the  showed  cursorkeys a number, Quit with
breakkey,  or  dial with spacebar. If ^M is entered, a telephone number
can be typed manual.

REDIAL
Dial the last chosen number again.

TRANSFERPARAMETERS
Although  Videotex  works  always  with 1200/75 Baud, 7E1, full duplex,
there is a tendency to increase the baudrate in the future to 1200/1200
or  even  to 2400/2400. Anyway, Viditel-65 is ready for the future. Any
baudrate  can  be programmed. De "dos-defined" choice copies the DOS-65
values for RS-232 to the ACIA. With the program RS232 it is possible to
change  this values. With the breakkey you can leave this menu, without
changing  any  parameter.  If the spacebar is entered, the marked para-
meters are programmed. Half-duplex is usable as demo-mode.

LOAD
Load a file. Because there is yet not a Videotex-editor available it is
possible  to  look  at a file. Also pages to transmit to the remote are
loaded with this command.
Example: To load the file DEMO.vid, type: L DEMO <CR>

SAVE
If  there one or more pages are saved in memory with ^S, the collection
of  these  pages  can  be transferred from memory to disk with the save
command.
 	Viditel manual                                        Pagina 11


DISKLOGGING
This  utility  is  not a real Videotex part. Also it is a handy tool to
save  all  pages  that  appeared on the screen to disk. This utility is
similar  to  ascii  download in the astrid program. Take care: The last
page  that  fits in the storage memory is destroyed! Disklogging can be
terminated with the break key.
Attention:  Some Videotexhosts transmit first a lot of <CR>'s and form-
feeds.  (e.g.  the  Elector  databank) If you are allready in the 'log-
mode'  all  these  data  is stored. If you look later in that file, the
first  20  (or  up) pages are empty, and ^Z shows no visible changes on
the screen. In that case you must enter 20 times ^Z. But a better solu-
tion is to use the ^B command and step backwards. Smart users activates
disklogging after the first page is displayed on the screen.

EXIT
Leave Viditel-65 and return to DOS-65.

QUIT
As  EXIT  but  the  modem  is  still on. Simply return to Viditel-65 by
typing  G  1000  (-M).  The purpose of Quit is to execute a doscommand.
Dos utilities destroy the autodialer!


7. COMMAND SUMMARY TERMINALMODE
===============================

^H: Prints the commandsummary. (Help)

^K: After  entering ^K, the value of the next key is transmitted to the
    remote.  The code of a controlkey, which is also a command, can now
    be send to the remote. E.g. to send ^H ($08) just type ^K^H.
    To  transmit the value of the breakkey, enter: ^K*. If the breakkey
    is pressed, always a return to the menumode is forced.
    Note: DEL sends the same code to the remote as ^K^H.

^Y: Enables  or  disables  the  paritycheck  on  received characters. A
    parity error results in printing a blockcharacter ($7F) in stead of
    the wrong character.

The  next four commands are editcommands. With these commands a page is
selected from the workmemory and placed in the pagebuffer.
^B: Place  last  page (bottompage) in the pagebuffer and list this page
    on the screen.
^T: Get  the first page. (top) Store it in the pagebuffer, and print it
    on the screen.
^W: Place the previous page in the pagebuffer, and list the page.
^Z: Place the next page in the pagebuffer, and list that page.

^L: List the current page on the screen.

^R: Show  conceiled  information, if there is no conceiled information,
    list the screen. (Retype)
    This  function  works  only  in the manual revealmode. In the auto-
    revealmode  conceiled  characters are always visible on the screen.
    With MCONFIG the selection of auto/manual reveil is made.

^E: Erase the pagebuffer and the screen.
 	Viditel manual                                        Pagina 12


^S: Save  the  page  that  is  currently  in  the pagebuffer in storage
    memory.
    
^P: Put a page to the remote. Select with the editcommands a page. This
    page  is  automatically  placed in the pagebuffer and listed on the
    screen. Typing ^P transmits the selected page to the remote.
    Warning:  Sending  a page in originate mode (75 Baud) to the remote
    costs appr. 2 minutes and 40 seconds! (1 kByte)

^O: Log  out. Sends the codestring *90# to the remote. With this string
    the  remote  is attended that you will leave the system. The remote
    prints his logging-off message and terminate the connection.

^A: Shows statusinfo. Read chapter 8.

Pressing the breakkey results in entering the mainmode. It is also pos-
sible to transmit four predefined textstrings. With the macro-enter key
(2nd  =  ^N) followed by the macro choice key, the selected macro shall
be transmitted. The macro's can be defined with MCONFIG.
Other special keys are the Return-, the #- and the DELete (RUB)key.
The code of the carriage return and the "#" are converted to the under-
score code. ($0D,$23 to $5F)
The DELcode is converted to the backspacecode. ($7F to $08)
Note: DEL sends the same code to the remote as ^K^H.

8. THE STATUSLINES
==================

Viditel-65  has  three statuslines, one for the autodialer, one for the
menumode,  and one for the terminalmode. The statusline of the menumode
is always visible on the screen. The terminal statusline is switched on
with  ^A  and switched off with ^E or any other command that generate a
formfeed.

8.1 THE STATUSLINE OF THE MAINMODE
----------------------------------
This line shows information about - the current time;
				  - the transmitting speed;
				  - the wordformat;
				  - full or half duplex;
				  - answer or orginate;
				  - the name of a file if a file is
       				    loaded.
 	Viditel manual                                        Pagina 13


8.2 THE STATUSLINE OF THE TERMINALMODE
--------------------------------------
^A  shows statusinformation about the current settings of the following
options:

1. a) Auto reveal:     All  conceiled  information shall be visiualised
		       on the screen automatic.
   b) Manual reveal:   Conceiled information is showed after typing ^R.

2. a) Parity check:    Every received character is checked on the right
                       parity.  Detection  of a parity-error results in
                       printing a blockcharacter.
   b) No parity check: The  paritybit is stripped from incoming charac-
                       ters and ignored. No paritycheck is done.

3. a) Disk storage:    If  disklogging is selected, automatic disk sto-
                       rage is displayed.
   b) No storage:      No automatic storage. Use ^S to store pages.

8.3 THE STATUSLINE OF THE AUTODIALER
------------------------------------
This  line  shows functional information about which keys are usable to
select  a  number,  how to dial a number manual, how to quit, and which
page of the telephone directory Vitel.dir is displayed.

9. HOW TO USE VIDITEL-65
========================
Dial  the  number  of  your  favourite  remote.  When the connection is
present,  type  your accesscodes. (clever users sends the macrostrings)
If  you like a page, and you want to store this, press ^S. ^S saves the
page  in  the storage-memory. If the storagememory is full, the message
'MEMORY  FULL'  is  printed. After this message it is impossible to use
the  ^S  command. Go back to the menumode and save the data of the sto-
ragememory on disk. Now ^S is again usable.

Another  possibility  of  storing  pages is disklogging. Any page which
appear  on  the screen is saved. If the storagememory is full, the data
is  automatic  saved on disk. Use this command with care, the last page
is destroyed when the diskdrive motor started spinning.

10. HELP UTILITIES
==================
Creative  Videotex  users need some tools to display and edit Videotex-
pages.
VIDUMP:  Dumps  a  Viditelpage  on  the  screen,  showing  the control-
         characters.
VIPRINT: Prints  Videotexpages  with  a  matrixprinter. The software is
         printerdependend.  A  solution  is  written in 6502 kenner nr.
         47/page 45.
VIDED:	 Viditel editor, to create and repair Videotexpages.
The  utility  Vidump  V1.0 is now ready for use. None of the othemen de software zelf in zijn bezit
krijgen dan zal dat van een databank geladen moeten worden. Programma's
uit  de  bovengenoemde  bladen zijn terug te vinden op alle Fido's. Het
voordeel  hiervan is dat men geen programma's meer hoeft over te tikken
uit  hobbybladen. De andere kant van de medaille is dat degene die geen
toegang heeft tot een dergelijke databank, uit de boot valt, en niet zo
gemakkelijk meer aan software kan komen. Al deze factoren in aanmerking
genomen is er wel degelijk een behoefte aan communicatieprogrammmatuur.
Mede  doordat  modems steeds goedkoper worden, en het aantal databanken
nog steeds groeiende is.

Iedereen die datacommunicatie wil toepassen kan Astrid daarvoor gebrui-
ken. Zowel dataoverdracht via de telefoon met een modem, als direct van
computer naar computer is mogelijk.

Deze  manual  geeft  een complete gebruiksaanwijzing voor het programma
Astrid. De bijlagen completeren het geheel, en zijn bedoeld voor degene
die zich grondig wil verdiepen in deze materie.

	Astrid manul T&O, jan. 1986. 2e druk.
C. Boltjes: "Videotexprogramme for the junior/octopus"
	    Gepubliceerd in 'De 6502 kenner' nr 47/48, feb 1987.
D. de Grooff: "Praktijkboek Videotex"
	      Kluwer, 1984. ISBN 90 6215 102 7
H. Wagenaar, A. Eliens: "progbus", "Beebtel en vidicode"
			artikels in asterisk 3-3 en 3-4. (BBC-club)
J. Bouman: "On-line handboek"
	   Aula-pocket, Het spectrum 1986.
R. Koelink: "Knoop uw computer aan de telefoon"
	    Communicatienummer HCC-nieuwsbriefnr. 86, okt 1986.

The books/articles are mentioned according to the importancy level.
Appendices Viditel-65 Version 2.2
This appendices describe the program detailed and gives some background
information  about  installing/configurating  the software, also how to
made the right connection bean worden
    3)  een zogenaamd terminal programma om met Fido te kunnen communi-
       ceren.  Een  zogenaamd  'download'  protocol dat op Fido past is
       handig  als  U  files of programma's naar U toe wilt halen of op
       Fido  wilt  zetten.  Voor  de  in  Fido aanwezige protocols, zie
       verder.

1.2 Het Inloggen op een Fidosysteem:
    -------------------------------

    1) draai het Fido telefoonnummer
    2) wacht tot U de pieptoon van het modem hoort
    3) schakel uw modem 'on-line'
    4) druk op RETURN of ENTER tot Fido het welkomsbeeld laat zien
Fido manual                                                  Pagina 15


1.3 De eerste maal Inloggen
    -----------------------

    Hoe  U de eerste keer moet inloggen hangt af van de wijze waarop de
    Sysop  (beheerder  van  Fido)  het  systeem heeft opgezet. In ieder
    geval moet U ingeven:
   
    1) Uw voornaam (1 woord)
    2) Uw achternaam (1 woord, b.v. van_der_Broek)
    3) De plaats waar u woont
    4) Een paswoord.

    Het  is belangrijk Uw naam juist te spellen, omdat prive boodschap-
    pen  op  naam  op  het  systeem staan. Een ander kan ze niet lezen,
    maar U ook niet als U Uw naam niet goed hebt ingetoetst.


1.4 Commando's aan Fido
    -------------------

    Commands  bedoeld  die op een andere snelheid zenden als ontvangen.
    Het  gaat dan altijd om de V23 norm van 1200/75 Baud. Het PTT Vidi-
    modem  en  de  Elektuur Polyphemus zijn hier voorbeelden van. Bezit
    je  een  dergelijk modem, dan zul je PB7 van VIA 2 moeten verbinden
    met pen 5 RxC van de ACIA, omdat het receiverclock signaal opgewekt
    wordt  door  Via 2. Om enige vorm van standaardisatie te verkrijgen
    is het aan te bevelen om dit als in onderstaand schemaatje te doen:

=====						     RS 232
    |PB7					  18
V   |-------------------------------------------------*   *--|
I   |						  17	     |
A   |						|-----*	  *--|
    |						|
=====						| chas    conn
						|
						|
=====						|
    |RxC					|
A   |-------------------------------------------|
C   |
I   |
A   |
    |
=====

De signalen PB7 en RxC worden naar buiten gevoerd via het D-chassisdeel
van  de RS232. In de modemconnector worden pen 18 en 17 met elkaar ver-
bonden.  Zodra de modemconnector ingeplugd is, komt het signaal van PB7
op  de receiverclock ingang van de ACIA. LET OP: Voer de draden van pen
17  en  18 niet door naar het modem zelf. Je weet maar nooit of er iets
op  aangesloten zit ! Bezitters van een modem die naast 1200/75 ook nog
300/300  of 1200/1200 kunnen, kunnen de verbinding PB7-RxC rustig laten
zitten,  want  bij  iedere  andere  baudrate  dan 1200/75 wordt PB7 als
ingang geschakelt.
Fido manual                                                  Pagina 16

 
Ad. 4.
Er  zijn  modems die zelf het receiverclocksignaal genereren, zodat het
communicatieprogramma  dat  niet  meer hoeft te doen. Een voorbeeld van
een zelfbouwmodem die een receiverclock uitgang heeft, staat beschreven
in  de  6502  kenner nr. 49, blz 41 e.v. (gemodificeerd minimodem) Zorg
ervoor  dat  RxC(ACIA) aan pen 17 v/d RS232 zit. Nu is  het mogelijk om
via  de RS232 kabel het clocksignaal van het modem aan te bieden aan de
ACIA. Controleer wel of het signaal op TTL niveau ligt.


Behalve  het  instellen  van de parameters voor een bepaald type modem,
zorgt het configuratieprogramma ook voor:

- Aanpassing  aan de systeemclock van uw systeem. Default is 1 Mhz. Let
  wel  op  dat bij configuratie voor een hogere frequentie dan 1 Mhz er
  aangenomen  wordt  dat  de  real-time clock gemodificeerd is voor die
  frequentie. Het gaat er om dat Hours, minutes, seconds en Viavra zich
  inderdaad gedragen als resp. uurteller, minutenteller, secondenteller,
  en  viavra  als  teller die elke seconde verlaagt wordt met 1. Is dit
  niet  het  geval  dan  zal  de knipperfrequentie niet exact 1 seconde
  zijn. (Dit gebeurt mbv VIAVRA)

- Tijdmelding op statusregel aan/uit schakelen.

- Het zetten van de default waarden. 

- Het  definieren  van  de  speciale  toetsen. In te stellen zijn welke
  toets men als breektoets wil gebruiken, welke als 2nd macro en macro-
  keuze,  en  welke voor cursorsturing. Voor de cursorbesturing kan men
  het  beste  dezelfde  toetsen nemen als in de Editor gebruikt worden.
  Zorg  er wel voor dat er geen toetsen worden gekozen die noodzakelijk
  zijn  om  een  bulletin board te besturen. Het ligt op het eerste ge-
  zicht  voor  de  hand om ^C als breektoets te definieren. Toch is dit
  niet  aan te bevelen omdat veel databanken ook ^C als breek zien. Zou
  men  in zo'n geval dan een ^C geven dan wordt teruggesprongen naar de
  menumode  van  Viditel,  terwijl het de bedoeling was om te 'quitten'
  uit een bepaald programmaonderdeel van de databank. De canceltoets is
  niet  te  veranderen,  omdat  alle  databanken  ^X  als cancel waarde
  accepteren.

- Het definieren van vier macro's.

- Het definieren van de besturingsstrings voor een hayes modem.
Fido manual                                                  Pagina 17


Gebruiksaanwijzing en voorbeelden van configuratie met Mconfig.
==============================================================

Voordat  met de configuratie begonnen wordt is  het verstandig om eerst
een  backup  te maken van het huidige programma. Normaal zal Viditel en
Viditel.cfg op drive 0 staan. 

MCONFIG VIDITEL <CR>

Het programma meld zich dan met het volgende menu:

CONFIGURATION VIDITEL COMMUNICATION PROGRAM
by B. de Bruine (C) xx xxxxx 1987 V2.1


*I* Instructions
*A* show Actual configuration
*C* Configurate for a certain modem/system
*H* change Hayes strings
*M* change Macro strings
*D* change Default parameters
*K* change control-Keys
*Q* Quit to DOS-65
*E* Exit, creating new VIDITEL.cfg

                CHOICE [I,A,C,H,M,D,K,Q,E]

Om er in te komen proberen we I(nstructions):

INSTRUCTIONS
============

With * it is possible to skip a part.
Typing <CR> immediately holds the original value.

Input controlcharacters:
a) For control keys only the ascii value must be given.
   f.e: Type M in stead of ^M.
b) In strings a controlchar must be preceeded with
   a '\' mark. f.e: \M = <CR>.


Het programma is opgebouwd uit vijf blokken:
1. Configureren voor een bepaald systeem/modem.
2. Wijzig default parameters.
3. Wijzig speciale toetsen.
4. Wijzig Hayesstrings.
5. Wijzig macrostrings.
Fido manual                                                  Pagina 18


Met "*" is het mogelijk om een blok over te slaan. Wil men de defaults,
hayesstrings  en  macrostrings wijzigen, maar niet de speciale toetsen,
dan wordt een "*" ingetikt en dat blok wordt overgeslagen.
Wil  men bv. alleen de defaults wijzigen dan kiest men in het menu voor
"D",  en  wordt  alleen dat blok afgehandeld. Keuze "C" is bedoeld voor
configureren  voor de allereerste keer. Hier worden vragen gesteld over
uw  systeem  en uw modem. Aan de hand van uw antwoorden worden de para-
meters  berekend  die  noodzakelijk zijn voor uw configuratie. Eveneens
worden  alle  andere  blokken doorlopen (indien relevant) waar ook weer
naar  eigen  wens  veranderingen aan te brengen zijn. Wil men een para-
meter niet veranderen dan moet <CR> ingetikt worden.

Met  keuze "A" kan men alle configuratie mogelijkheden bekijken. Dit is
een  soort luxe hexdump met verklaring. Schrik niet als bv een autodial
vlag  aangeeft dat automatisch bellen niet mogelijk is, terwijl u juist
geprogrammeerd had dat dit wel tot de mogelijkheden behoorde.
Het is heel goed mogelijk dat die vlag voor uw systeemconfiguratie niet
van belang is, en een dummy waarde aangeeft.
"A" wijzigt niets. Het laat alleen de huidige instelling zien.

Met  "Q"  wordt  MCONFIG  verlaten zonder dat er een nieuwe Viditel.cfg
gesaved wordt.
Met  "E"xit  wordt  de nieuw Viditel.cfg op disk opgeslagen, geconfigu-
reerd volgens de gegevens die u ingevoerd heeft.


Toelichting "C"onfiguratie:

Iedere vraag kan beantwoordt worden met een enkele toetsaanslag.
bv "1" voor de clockfrequentie of "Y" op de vraag of er een
interspeeder aanwezig is.   	Dus NIET: 1<CR> of Y<CR>!!      <--Fout


CONFIGURATION VIDITEL COMMUNICATION PROGRAM
by B. de Bruine (C) 30 may 1987 V2.1

*I* Instructions
*A* show Actual configuration
*C* Configurate for a certain modem/system
*H* change Hayes strings
*M* change Macro strings
*D* change Default parameters
*K* change control-Keys
*Q* Quit to dos-65
*E* Exit, creating new VIDITEL.CFG

                CHOICE [I,A,C,H,M,D,K,Q,E]
Fido manual                                                  Pagina 19

    ***CONFIGURATION***

What is the clockfrequency of your system ?
CLOCKFREQ:  1,2,3 of 4 MC/S.
[Er kan een keuze gemaakt worden uit bovengenoemde vier waarden.]

Contains your modem an interspeeder ? (Y/N)
[Een interspeeder converteert 75 Bd naar 1200 Bd en vice versa.]
INTERSPEEDER				SPLIT SPEED
					Is  an  external receiver clock
					for  the acia available ? (Y/N)
					VIA T1 OSC
					EXT. OSC
					[Indien  er geen ext. clock be-
					schikbaar  is,  moet dat clock-
					signaal  van  de  VIA betrokken
     				        worden. Op PB7 (VIA2) staat dit
					clocksignaal.  Zelf moet men er
                                        zorg  voor dragen jdat PB7 ver-
                                        bonden  wordt  met  RxC  van de
					ACIA.  Levert het modem zelf de
					clocksignalen,  dan  kan men de
					vraag bevestigend beantwoorden.
					Er  wordt dan EXT. OSC geprint,
					om aan te geven dat de VIA niet
					als baudrate generator hoeft te
					functioneren.]


Is your modem a Hayes or Hayes compatible modem ? (Y/N)
HAYES MODEM				TRANSPARENT MODEM
Does  your Hayes  modem  need extra     Has   your  modem  an  autodial
initialisation   to  set correct the	facility   ?  Do  you  have  a
wordformat (Y/N)?			Bansoft* dialer ? (Y/N) Support 
NO EXTRA INITIALISATION			your modem RTS-dialing ? (Y/N)  for more information
EXTRA INITIALISATION  [Kunnen gede-	Read themanual for about your particular
finieerd worden in de Hayesstrings]	OWN AUTODIALER
Do you want  pulsedialing  or tone-		BANSOFT DIALER
dialing ? [P,T,sp]  space = default	RTS-DIALER
PULSE DIALING				[Hiermee is de dialmethode
TONE DIALING				gedefinieerd, Er zijn dus 3 moge-
DEFAULT					lijkheden voor transparent modems.]
[Default is de  dialmethode die het	
modem kent na het  opstarten. Mees-
tal zal dat pulskiezen zijn.]		

Viditel faciliteiten:
WHICH VDU CHARGEN. ARE YOU USING ?[1,2,O]
OCTOPUS CHARACTERGENERATOR
DOS-65 VIDCHARGEN V1.0
DOS-65 VIDCHARGEN V2.0
[Er  zijn  helaas vier karaktergeneratoren in omloop. Om gebruikers van
het eerste uur ook blijvend te ondersteunen kan men hier invoeren welke
karakter  generator  men bezit. Dit is van belang voor het programmeren
van  de CRTC. Indien men karaktergenerator V3.0 heeft, moet men keuze 2
maken.]

Do you want autoreveil ? (Y/N)
AUTO REVEAL
MANUAL REVEAL
[Auto  reveal maakt altijd de eventueel verborgen informatie zichtbaar.
Bij  manual  reveil  moet  men  daar de ^R toets (in terminalmode) voor
indrukken.]


Voorbeeld configuratie:

			CURRENT CONFIGURATION:
=======================================================================
|PUTO     |0050 | PULSE DIALING  |CLOCK    |0001 | CLOCKFREQ:  1  MC/S
|PROTOCOL |0002 | VIDITEL	 |SPLIT    |00FF | INTERSPEEDER
|TIMEFLAG |0000 | SHOW TIME	 |HAYES    |0000 | HAYES MODEM
|ECHO     |00FF | FULL DUPLEX	 |EXTRA    |0000 | EXTRA INITIALISATION
|ANSORG   |0000 | ORIGINATE	 |EXTOSC   |00FF | VIA T1 OSC
|DIALFLAG |00FF | NO AUTODIALER	 |CHRGEN   |0032 | Viditel chrgen2
|WORDFOT  |0042 | 7E1		 |MONIT    |0005 | 50 HZ
|BAUDPAR  |0004 | 1200/75 BAUD	 |REVEAL   |00FF | AUTO REVEAL
=======================================================================


THIS  MEANS  THAT   VIDITEL   NOW  IS  USABLE FOR SYSTEMS WITH A CLOCK-
FREQUENCY OF  1  MC/S AND IS CONFIGURATED FOR A HAYES MODEM WITH INTER-
SPEEDER.
Your  modem  needs  EXTRA  INITIALISATION  for  a correct change of the
wordformat.
Time is printed.

THE DEFAULTS ARE: VIDITEL, FULL DUPLEX, ORIGINATE, 1200/75 BAUD, 7E1. 

CURRENT DEFINED KEYS:
***********************
CURSOR UP        | ^K | 
CURSOR DOWN      | ^J | 
CURSOR BACK      | ^H | 
CURSOR FORWARD   | ^I | 
PAGE UP          | ^W | 
PAGE DOWN        | ^Z | 
BREAK KEY        | ^[ | 
ENTER MACRO KEY  | ^N | 
MACRO KEY 1      |  1 | 
MACRO KEY 2      |  2 | 
MACRO KEY 3      |  3 | 
MACRO KEY 4      |  4 | 
***********************

TEXT STRINGS:
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$1 BAUD: AT^M
$2 8N1:  ATS13=0^M
$3 7E1:  ATS13=12^M
$4 ORG:  ^M
$5 ANS:  ATA;^M

MAC1:  KLANTNUMMER#
MAC2:  CODENR.#
MAC3:  PRIVECODE#
MAC4:  Many-used-string^M
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$


    ***CONFIGURATION***
What is the clockfrequency of your system ?
CLOCKFREQ:  1  MC/S
WHICH VDU CHARGEN. ARE YOU USING ?[1,2,O]
VIDITEL CHRGEN V2.0
Do you want autoreveil ? (Y/N)
AUTO REVEAL
Contains your modem an interspeeder ? (Y/N)
SPLIT SPEED
Is an external receiver clock for the ACIA available ? (Y/N)
VIA T1 OSC
is your modem a Hayes or Hayes compatible modem ? (Y/N)
TRANSPARENT MODEM
Has your modem an autodial facility ? (Y/N)
Do you have a Bansoft* dialer ? (Y/N)
Support your modem RTS-dialing ? (Y/N)
read the manual for more information about your particular
OWN AUTODIALER

Voor meer informatie over automatisch bellen, zie bijlage ..

Behalve de macrotoetsen zijn alle andere toetsen controltoetsen.
Deze worden niet als controltoetsen ingevoerd maar als lettertekens. Zo
wordt bv control-N (notatie: ^N) ingevoerd als N.
Het "^" teken word automatisch geprint als er een control karakter
ingevoerd moet worden.

Voorbeeld invoeren van tekststrings

Het invoeren van tekststrings wijkt iets af van de andere blokken.
Het is hier niet mogelijk om met een sterretje "*" een blok over te
slaan. Wel kan met een <CR> een string ongewijzigd blijven.
Het invoeren van besturingskarakters wijkt ook af. Ieder
controlkarakter moet voorafgegaan worden door een schuin streepje "\".
Wil men bv een naamstring invoeren met CRLF dan zou dat als volgt
kunnen gebeuren:
voornaam\Machternaam\M\J
Met <CR> word de string afgesloten en in het geheugen gezet.

LET OP! Bij versie 2.2 en hoger wordt de data die in de tekststrings zijn
opgeslagen, ongewijzigd naar de host verzonden. Dat wil zeggen dat er voor
viditel bijvoorbeeld geen konversie naar speciale karakters meer plaats vind
voor macro's en Hayes strings. Dus <CR> wordt niet omgezet naar het viditel
sluitteken. Om een string af te sluiten met het viditel sluitkarakter moet
het underscore teken (_ $5F) geplaatst worden.

De maximale lengte van de strings zijn opgenomen in onderstaande tabel:
==============================================================================
Stringnaam   Stringlengte	Omschrijving
==============================================================================
Hayes 1		15 kar.		Zet Transmissiesnelheid.
Hayes 2		15 kar.		Zet woordformaat op 8N1.
Hayes 3		15 kar.		Zet woordformaat op 7E1.
Hayes 4		7  kar.		Zet modem in originatemode. (AT O of defauld.)
Hayes 5		7  kar.		Zet modem in answermode (ATR of ATA (autoans))
Macro 1		15 kar.		Vrij te definieren.
Macro 2		15 kar.		Vrij te definieren.
Macro 3		15 kar.		Vrij te definieren.
Macro 4		31 kar.		Vrij te definieren.
==============================================================================

Indien de stringlengte overschreden wordt volgt een foutmelding.
Je moet dan even wachten, totdat de te lange string wordt gewist en de
prompt '>' verschijnt om aan te geven dat de string opnieuw
ingevoerd kan worden.

Hieronder een voorbeeld van gedefinieerde tekst strings:


Indien je geen hayes modem hebt hoef je uiteraard de hayesstrings ook
niet te definieren.

Extra viditelfaciliteiten
=========================

Ia. De karaktergenerator.
Om viditel te bedrijven met een dos-65 computer is een speciale
karaktergenerator voor de vdu-kaart nodig. Inmiddels zijn er drie
verschillende karaktergeneratoren in omloop, en om mensen van het eerste uur
niet te dwingen een nieuwe karaktergenerator te plaatsen, kan men met
MCONFIG aangeven welke karaktergenerator men bezit.
 a. De octopus karaktergenerator. (keuze O) ;8 scan-lines, geen descenders, 
 					    ;geen ESC, FF, LF en CR
 					    ;graphics.
 b. De dos-65 viditel chrgen V1.0. (keuze 1) ;8 scan-lines, geen descenders,
					     ;heeft ESC/FF/LF/CR graphics.
 c. De dos-65 viditel chrgen V2.0/V3.0 (keuze 2) ;9 scan lines, true desc.,
						 ;en de vier voornoemde
						 ;graphics kunnen
						 ;gedisplayed worden. 

Ib. Autoreveal versus manual reveal.
Als de vraag "Do you want autoreveil ? (Y/N)" met Yes beantwoord wordt, zal
alle 'verborgen'-informatie zondermeer gevisualiseerd worden op het
beeldscherm. In de Manualrevealmode moet expliciet een ^R commando gegeven
worden om deze informatie zichtbaar te maken.

Foutmeldingen:
==============
xxxx not found: Filenaamfout. Viditel.cfg is niet geladen. Mogelijk staat
		het programma op een disk in een andere drive.
Configuration impossible: Met MConfig V2 zijn alleen de
		communicatieprogramma's V2.xx te configureren. De
		configuratie van de oudere versies 1.xx is onmogelijk.
Illegal key:	Het is niet toegestaan deze toetswaarde in te voeren.
Same defined keys: Er zijn twee speciale toetsen met dezelfde waarde
		gedefinieerd.
String too long: De maximale lengte die een macro of hayes-string kan
		bevatten is overschreden.

<>


Bijlage II: Overzicht configuratievariabelen
********************************************

De configuratievariabelen bepalen met welk modem er gewerkt word.
Eveneens laten ze zien wat de defaulds (Baudrate, protocol, etc..) zijn
waarmee opgestart word. De configuratievariabelen kunnen aangepast
worden met het programma MCONFIG of met de MONitor.

VIDITEL V2.2 Configurationpage: $0400-$04FF

0400  41 54 0D 00 00 00 00 00 00 00 00 00 00 00 00 00   AT..............
0410  41 54 53 31 33 3D 30 0D 00 00 00 00 00 00 00 00   ATS13=0.........
0420  41 54 53 31 33 3D 31 32 0D 00 00 00 00 00 00 00   ATS13=12........
0430  0D 00 00 00 00 00 00 00 41 54 41 3B 0D 00 00 00   ........ATA;....
0440  4B 4C 41 4E 54 4E 55 4D 4D 45 52 5F 00 00 00 00   KLANTNUMMER_....
0450  43 4F 44 45 4E 52 2E 5F 00 00 00 00 00 00 00 00   CODENR._........
0460  50 52 49 56 45 43 4F 44 45 5F 00 00 00 00 00 00   PRIVECODE_......
0470  4D 61 6E 79 2D 75 73 65 64 2D 73 74 72 69 6E 67   Many-used-string
0480  0D 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ................

0490 7E 28 50	CRTTAB	FCB	$7E,$28,$50,$88,$1E,$00
0493 88 1E 00
0496 19 1C 00		FCB	$19,$1C,$00,$09,$00,$09
0499 09 00 09
049C 00 00 00		FCB	$00,$00,$00,$00,40,$18
049F 00 28 18

		;Configuration flags
04B7 50		PUTO	FCC	'P'		;Pulse, tone or def dialing
04C9 01		CLOCK	RES	1,1		;Processorspeed 1,2,3 & 4 mhz
04CA FF		SPLIT	RES	1,$FF		;Split baud modem 75/1200
04CB 00		HAYES	RES	1,$0		;Zero, if smart modem used
04CC 00		EXTRA	RES	1,$00		;Autobaud modem initialisation
04CD FF		DIALFLG	RES	1,$FF
		;Transp. modem: 00=bansoft dialer
		;		01=own dialer
		;		02=rts-dialer
		;		ff=no autodial
04CE 02		PROTOCO	RES	1,2		;Protocol=videotex (fixed)
04CF 00		TIMFL	RES	1,0		;0=update time, <>0 don't
		;*:*:*:*:* do not change seq table below :*:*:*:*:*
04D0 FF		ECHO	FCB	$FF		;Fullduplex = ff {defauld}
04D1 00		ANSORG	FCB	$0		;Originate = 00 {defauld}
04D2 42		WORDFOT	FCC	'B'		;A=8N1, B=7E1 {defauld}
04D3 04		BAUDPAR	FCB	4		;Baudrate {defauld}
		;1=2400/2400
		;2=1200/1200
		;3= 300/300
		;4=1200/75
		;5=dos specified
		;*:*:*:*:* end table :*:*:*:*:*
04D5 32		CFG2	FCC	'2'		;Version number hi
04D6 FF		EXTOSC	RES	1,$FF		;00=external acia osc
		;Ff=via-osc for acia (only if split=0)
04D7 32		CHRGEN	RES	1,'2'
		;'O'=octopus: (8 sc lines, no d65 conversion)
		;'1'=chrg1: 8 sc lines, 4 reserved.
		;'2'=chrg2: 9 sc lines (lowest extend) 4 res.
04D8 05		MONIT	RES	1,5		;5=50hz,6=60hz,7=71hz
04D9 FF		AUTREV	RES	1,$FF		;Auto reveal on/off

		;Keycodes menu transfer parameters
04DC 0B		KEYUP	FCB	$0B		;^
04DD 0A		KEYDOW	FCB	$0A		;Lf
04DE 08		KEYBAC	FCB	$08		;Bs
04DF 09		KEYFOR	FCB	$09		;Ht
04E0 1B		KEYBRK	FCB	ESC		;Common breakkey
04E1 17		KEYPUP	FCB	$17		;^w page up
04E2 1A		KEYPDO	FCB	$1A		;^z page down
04E3 000000		RES	3,0		;Futural expansion

		;Keycodes macro expansion
04E6 0E		KEYMAC	FCB	$0E		;^n macro-key (2nd)
04E7 20 3BC0	MKHELP	JSR	PRINT
04EA 31		KEYMAC1	FCC	'1'		;Macro 1
04EB 2C			FCC	','
04EC 32		KEYMAC2	FCC	'2'		;Macro 2
04ED 2C			FCC	','
04EE 33		KEYMAC3	FCC	'3'		;Macro 3
04EF 2C			FCC	','
04F0 34		KEYMAC4	FCC	'4'		;Macro 4
04F1 00			FCB	0
04F2 60			RTS
		;---end configuration page---
<>

Bijlage III: Lijst van programmeerbare toetsen.
===============================================
04DC 0B		KEYUP	FCB	$0B		;^
04DD 0A		KEYDOW	FCB	$0A		;Lf
04DE 08		KEYBAC	FCB	$08		;Bs
04DF 09		KEYFOR	FCB	$09		;Ht
04E0 1B		KEYBRK	FCB	ESC		;Common breakkey
04E1 17		KEYPUP	FCB	$17		;^w page up
04E2 1A		KEYPDO	FCB	$1A		;^z page down
04E6 0E		KEYMAC	FCB	$0E		;^n macro-key (2nd)
04EA 31		KEYMAC1	FCC	'1'		;Macro 1
04EC 32		KEYMAC2	FCC	'2'		;Macro 2
04EE 33		KEYMAC3	FCC	'3'		;Macro 3
04F0 34		KEYMAC4	FCC	'4'		;Macro 4

<>

Bylage IV: Geheugenindeling.
***************************

Viditel-65 gebruikt veel geheugen. Men kan files downloaden met de lengte
van de beschikbare diskcapaciteit. Heeft men een lege 80 Tr DS/DD disk,
dan is de maximale filelengte 720 kbyte. Files die men wil uploaden
moeten in het werkgeheugen passen. D.w.z. dat de file niet groter mag
zijn dan ca. 28 kbyte. Dit is geen beperking, want met de talrijke
Dos-65 utilities kan men een grotere file opsplitsen in kleinere files,
en dan bloks gewijs uploaden.

      Memory map Viditel-65 V2.2
0000 ----------------------------
     |		nu		|
     ----------------------------
0090 |				|
     |	  page zero pointers    |
009D |				|
     |--------------------------|
     |		nu		|
0100 |--------------------------|
     |				|
     |		stack		|
     |				|
0200 |--------------------------|
     |				|
     |	    receiverbuffer	|
     |				|
0300 |--------------------------|
     |				|
     |	   transmitterbuffer	|
     |				|
0400 |--------------------------|
     |	   configuration	|
     |	   variables		|
0500 |--------------------------|
     |				|
     |				|
     |		nu		|
     |				|
     |				|
0800 |--------------------------|
     |				|
     |	   Vitel.dir buffer	|
     |				|
1000 |--------------------------|
     |				|
     |		main		|
     |		program		|
     |		(VIDI)		|
     |		*V2.2*		|
     |				|
     |				|
3200 |--------------------------|
     |				|
     |				|
     |				|
     |				|
     |	   storagememory	|
     |				|
     |				|
     |				|
     |				|
     |				|
9C00 |--------------------------|
     |	   pagebuffer 		|
     |				|
A000 |--------------------------|
     |				|
     |	   helpscreentext	|
     |	   and			|
     |	   Autodialer		|
     |				|
A600 |--------------------------|
     |				|
     |	    nu			|
     |				|
AA00 ----------------------------		nu= not used

		;Page zero locations
	  0090	MEM	EQU	$90		;Storage memory pointer
	  0092	POI	EQU	MEM+2		;End of file marker
	  0094	TELTXT	EQU	MEM+4		;Pointer autodialer
	  0096	TEMP	EQU	MEM+6		;Temporary pointer
	  0098	PAG	EQU	MEM+8		;Viditel pagepointer
	  009A	VIM	EQU	PAG+2		;Viditel readpointer
	  009C	PRI	EQU	PAG+4		;Viditel printpage poi


Label table Viditel V2.2: (wijzigingen voorbehouden)

ACCMD     E735	ACCTL     E734	ACIASR    E131	ACICMD    E132	ACICTL    E133
ACIINT    17CA	ACR2      E11B	ADIAL     23D2	ADJUST    2C06	AHOLD     1066
AKEY      156C	ANSO      1993	ANSORG    04D1	AREG      E130	ASAVE     1047
ASCBRK1   2266	ASCBRK2   2397	ASCBRK3   2440	ASCHECK   20B2	ASCOHEX   1033
ASCTEST   2120	ATD       04B4	AUTREV    04D9	AUTTER    10A6	AYS       1F64
BACKBL    2E53	BACKNW    2E59	BACKVIM   2ABE	BANDIAL   A1B2	BAUD      1040
BAUDPAR   04D3	BAUDTAB   198D	BBDIAL    A13F	BEEP      1A55	BEGHI     0032
BEGLO     0000	BELL      2CC3	BOT       1013	BREAK     103E	BRKMENU   238F
BS        2CC6	BS1       2CD4	BS2       2CDC	BUFIN     C029	BYEXT     1030
BYHI      102F	BYLO      102E	BYTES     20A1	C0        2E77	C1        2EB7
C1PRT     2C35	C1PRT1    2C49	C1PRT2    2C4B	CAN       0018	CANFLG    103F
CAPITAL   005F	CDELAY    106C	CDT2H     00F4	CDT2L     0024	CFG1      04D4
CFG2      04D5	CHAPLN    27A0	CHOICE    1399	CHRGEN    04D7	CKEY      15BA
CL1       10A9	CL2       10AE	CL24      2FFD	CL3       10B3	CL4       10B8
CLEAR21   1A92	CLEAR23   1A9F	CLN       2798	CLOCK     04C9	CLODI     1FB1
CLOSE     D048	CLOTEL    2610	CLR       1A7E	CLR23     1A8C	CLRSTAT   F01B
CLS       1ADF	CLSEC     E718	CLSTAT    1AE8	CLSTCON   CA2A	CLT       10A8
COLBAC    27A8	COLCHA    27A7	COLOR     2E20	COLOR1    2E2C	COLUMN    2794
COMBEEP   245A	COMHAND   245D	CONCEAL   2E41	CONDIS    0080	CONEN     0081
CONFLG    27A6	CONTR     102C	COPNUM    2662	CR        000D	CRCOUNT   1098
CREATE    D036	CREDI     1FD7	CRFLG     106F	CRLDN     2C56	CRLF      C02F
CRLUP     2C6B	CRTCAR    E140	CRTCRF    E141	CRTTAB    0490	CURLOAD   1A67
CUROFF    1AC4	CURON     1ABF	CURPX     E704	CURPY     E705	CURSAVE   1A5A
CURSOR    279C	CURUP     1AB5	CW        2937	CZ        2930	CZ0       292D
D65COR    2B91	DCLO      2070	DDRB      E112	DE        007F	DECTXT    25D8
DECVIM    2F90	DEL100    A2D8	DEL1600   A2E1	DEL40     A2CF	DEL60     A2A9
DELAY     106B	DELVAL    10C1	DELX      A2AF	DESTROY   10A0	DH0       1058
DIACOM    A320	DIALBUF   04B8	DIALFLG   04CD	DIAPRES   A2F0	DIERR     10A2
DISDLY    1A33	DKEY      1548	DLOOP     2678	DLYINT    181D	DLYINT1   1836
DM0       1057	DOS       1062	DOSBUF    AA00	DOSCOM    C006	DOSDEF    1927
DOSKEYI   CB3E	DOSMSIO   184B	DREAD     D01B	DTRDIS    00FE	DTREN     0005
DTROFF    179B	DTRON     1790	ECHO      04D0	EFNAME    1EA6	EKEY      15D3
EMPTYM    105B	EN2       17B7	ENDFILE   2107	ENDMEM    009E	EOF       0004
EPAR      0064	ERLIN     2E0A	ERLIN1    2E0F	ERLIN2    2E1F	ERMES     D0B7
ERR       A17C	ERR1      A184	ERRDI     A153	ERTEO1    2DDF	ERTEO2    2DF6
ERTEOL    2DC3	ERTEOS    2DCF	ESC       001B	ESCFLG    27AB	EXECBRK   1857
EXECMAC   1C27	EXSHOW    1CF6	EXSTRI    1061	EXTOSC    04D6	EXTRA     04CC
FF        000C	FF1       2D4E	FIFORM    105A	FILENR    102B	FINISH    1065
FITOLO    2345	FITOP     2A54	FITOPA    2A2C	FITOPAB   2AB9	FITP      2AC3
FLAFLA    289A	FLAFLG    27A5	FLASH     2E35	FLASHT    27AF	FLL       1031
FLN       2796	FNAM      1EE8	FNAM1     1EE3	FNAME     1E96	FNPNT     102A
FREMODE   00C0	FTEST     116A	GET       188A	GETBUF    C02C	GETEV     F009
GETKEY    18A0	GETMOD    176F	GETNAM    1F56	GRAFLG    27A2	GRAHOC    27A4
GRAHOL    2E6B	GRANOR    2E47	GRAREL    2E71	GRASEP    2E4D	H0        1050
HALFBL    105E	HAST      19A4	HAYDIAL   A1A3	HAYES     04CB	HAYSTR    0400
HDEL      A2B9	HEIFLG    27A9	HELP      A007	HELPME    302C	HEXDEC    C044
HEXOUT    C038	HKEY      147C	HLOOP     1B72	HNOUT     C035	HOCAL     1BCA
HOME      1AB0	HOUCON    1B84	HOUR      1055	HOURS     E782	HT        0009
HT1       2CED	HT2       2CF5	IER2      E11E	IGET      1009	IN        C020
INCMEM    2187	INCPAG    2F1C	INCPOI    215E	INCPRI    2F48	INCREM    2170
INCTXT    25CA	INCVIM    2F7D	INITAM    2811	INITIM    27DD	INIVDU    F12C
INLINE    2795	INPUT     1064	INTV15    E76C	INTV6     E75A	INTV9     E760
INVALID   1769	INVVID    1AD8	IRQKEY    183F	ISWAP     1192	JOPT      129F
JVITXT    100F	KBRK      1844	KEYBAC    04DE	KEYBRK    04E0	KEYBUF    E7B8
KEYDOW    04DD	KEYFOR    04DF	KEYMAC    04E6	KEYMAC1   04EA	KEYMAC2   04EC
KEYMAC3   04EE	KEYMAC4   04F0	KEYPDO    04E2	KEYPNT    E7B7	KEYPORT   E101
KEYPUP    04E1	KEYUP     04DC	KSAV      2908	L         29EF	LASTCH    27AD
LASTCLR   1A7B	LASTIME   100C	LASTLIN   1A73	LEMPTY    20D7	LF        000A
LF2       2D08	LF3       2D19	LFCONV    1070	LHAST     19A7	LHOUR     104D
LIN       109C	LIN23     1A84	LIST      29F5	LISTSCR   29F0	LKEY      14E6
LLER      152C	LLN       279A	LMINU     104E	LOAD      2018	LOADIT    14F5
LOADTIM   1C1A	LOADXY    18BC	LOCFG     1071	LOGFLG    10A7	LOGMES    2EE1
LOGOUT    2EDF	LOTI2     182B	LOTRAN    1752	LOUT      2EF6	LPSCR     27A1
LSETEMP   20E5	M0        104F	MACERR    2327	MACHELP   23A8	MACIND    1069
MACRO     1068	MAINMEN   12CA	MARK      275E	MARKB     273F	MARKF     2758
MARKF1    2755	MATCH1    1BC8	MATCHH    1B9E	MAXTRAN   00FF	MC1       0440
MC2       0450	MC3       0460	MC4       0470	MEM       0090	MEMPTY    20C0
MESEMPT   20EE	MESFULL   219F	MESSAGE   26D9	MICAL     1BA3	MIN       1052
MINCON    1BBD	MINLOOP   1BAB	MINUTES   E783	MKEY      14A5	MKHELP    04E7
MOCOM     1041	MOCTR     1042	MODET2    00E3	MOFF      17A6	MON       17AF
MONIT     04D8	MOUT      276F	MOVCRT    27B4	MOVTAB    27C0	MYDI      A32E
NAMB      ABE0	NAMDEF    D122	NAMFO     10A5	NBUF      1016	NEW       1294
NEWNR1    A1C0	NEXPAG    2594	NILL      2D82	NKEY      14AC	NNR       A1BA
NONAM     1F11	NONU      2371	NOPAR     0005	NORVID    1AD1	NR1       A146
NWNR1     A231	OEF       10A3	OKEY      14B8	OOM       105C	OPEN      D03F
OPENTEL   25F2	OPT1      1E23	OPT1200   1DB5	OPT2      1E2B	OPT2400   1DA7
OPT300    1DC3	OPT5      1DF7	OPT6      1DFC	OPT7      1E01	OPT75     1DD1
OPT8      1E06	OPTANS    1E54	OPTDIAL   1D79	OPTE      1E0B	OPTEMFN   1E5F
OPTFN     1E6F	OPTFULL   1E33	OPTHALF   1E3E	OPTMEN    1D92	OPTN      1E1B
OPTNR     1DED	OPTO      1E13	OPTORG    1E49	OPTPAT    10A4	OPTTER    1D67
OPTTIME   1D3A	OPTXXXX   1DDF	OSC       19E3	OSCEN     106D	OSCOFF    1A06
OUT       C023	OUTCTR    C0CC	OUTIO     F000	OWNDIAL   A324	OWNKEY    187B
PAG       0098	PAGE      109D	PAGEM     29B7	PAGEND    00A0	PAGHI     009C
PAGLO     0000	PARCHK    27B0	PARCHO    18D1	PARPROG   1006	PATOFIL   2A16
PFULL     2430	PLIP      29E7	PO15.25   1CFA	PO24.25   1D02	PO37.25   1D0A
PO43.25   1D12	PO48.25   1D1A	PO52.25   1D2A	PO55.25   1D32	PO73.25   1D22
POI       0092	POSIC     F024	PRI       009C	PRIHOUR   1B21	PRIMIN    1B4E
PRINT     C03B	PRINT1    2B7A	PRINT2    2B87	PRINT3    2B8D	PRIPAG    2A03
PRISEC    1B3B	PRITEL    2419	PRNIBL    FF76	PROGAC    19CE	PROTOCO   04CE
PROVIA    19FF	PTIME     1BFC	PUT       2AD0	PUTMES    30E6	PUTO      04B7
PXIT      26C5	PXIT1     26A5	QKEY      1656	QUE       177F	RAMBEG    279E
RAMPTR    00A0	RECBUF    0200	RECPNT    1014	REPO      F027	RESESC    2D7C
RESMO1    2D70	RESMOD    2D6E	RESPONS   1A45	RESTAB    2ED7	RESTART   10A1
RESTORE   18C3	RESTORF   18C8	RESTORT   18CC	RETU      1ABA	RETURN    2D55
REVFLG    27AA	RKEY      15A8	RS        2D67	RSA       2C92	RSB       2CA1
RTSDIAL   A223	RTSEN     0004	RTSHI     A293	RTSLO     A29E	S8N1      1935
SACIINT   1038	SATRAN    16A6	SAVE      1FA7	SAVEA     27B1	SAVER     14DF
SAVETIM   1C0D	SAVEX     27B2	SAVEXY    18B5	SAVEY     27B3	SCAN1     2622
SCANKEY   13CB	SCANX     2401	SCURPX    1045	SCURPY    1046	SDLYINT   103C
SEALCO    2E26	SEAMARK   2745	SEC1D20   E737	SECONDS   E784	SEGRCO    2E2A
SEL1      2702	SEL2      2706	SEL3      270A	SEL4      2711	SELECT    2404
SELEX     265D	SELEX1    265A	SEN2      1003	SEPFLG    27A3	SETBOT    2FB2
SETCUR    1AC7	SETDLY    1A19	SETEMP    20CE	SETMEM    2155	SETPAG    2EFB
SETPOI    214A	SETPRI    2F11	SETTIM    1AF4	SETTXT    25BF	SETVIM    2F06
SHO12     21ED	SHO24     21D4	SHO3      2210	SHO75     2236	SHOAN     227E
SHODOS    224D	SHOFU     21C2	SHOHA     21CB	SHOIT     229C	SHONO     2206
SHOOR     2270	SHOPAR    222C	SHOUR     1056	SHOWOPT   1C52	SKEY      14C5
SKEYINT   103A	SKEYMAC   106E	SMIN      1053	SOPT      C068	SORRY     235F
SPAGE     109E	SPLIT     04CA	SREAD     D000	SSTATOG   1043	STAR      231A
START     10DC	STARX     231C	STATOG    E701	STATUS    D063	STEADY    2E3B
STELTXT   109A	STEST     1162	STIMFL    1063	STOPRXC   003F	STORAGE   1044
STORTEL   261C	STRAN     1034	STTOTE    2789	SUSPEND   1067	SVIDDEC   2AF2
SWAP      1614	SYSKEY    186A	SYSSTAT   F021	T1200     01A1	T12001    01A0
T12002    0341	T12003    04E2	T12004    0683	T19K2     001A	T19K21    0019
T19K22    0033	T19K23    004D	T19K24    0067	T1CH      E115	T1CHL     E117
T1CL      E114	T1CLL     E116	T2CH      E119	T2CL      E118	TELBEG    0800
TELCLOS   109F	TELEND    1000	TELFINR   1099	TELINFO   26F4	TELNAME   108C
TELTXT    0094	TEMP      0096	TERM      15BE	TETOST    277E	TH0       1054
TIM12H    10C0	TIM12L    10BF	TIM1H     1060	TIM1L     105F	TIM75H    10BE
TIM75L    10BD	TIMEX     1B61	TIMFL     04CF	TKEY      169D	TM0       1051
TOBIG     1032	TOLAR     2096	TOP       1012	TOUTFLG   E738	TOUTIL    E772
TOUTL     E774	TPA       16A4	TRANBUF   0300	TRANMOV   1807	TRANPNT   1015
TRANSMT   17EC	TRAPA     21B4	TRASH     16E3	TRLOOP    16E9	TRY1      1059
TSTBG     2D83	TSTBG1    2D96	TSTBG2    2DA6	TSTBG3    2DAA	TVPUT     2BCF
TVPUT1    2C03	TVPUT2    2C05	UNMARK    2773	UPA       105D	UPTIM     1B03
USRSTAT   F01E	VDTCPL    0027	VDTEL     284C	VDTEL1    288C	VDTLPS    0017
VDURES    2C80	VERSION   1440	VI        300C	VIA2      E110	VIAVRA    E71B
VIBANK    27AE	VICR      2D52	VIDDEC    2AFB	VIDEO20   FB2C	VIDEXT    1F5F
VIDI      A000	VIDITEL   27E4	VIDRAM    E800	VIDSTOR   2FCC	VIERR     1F57
VIESC     2D61	VIFF      2D48	VIHOME    2DAB	VIHT      2CDD	VILF      2CF6
VILF1     2CF9	VIM       009A	VIMEND    2F4F	VINDIC    1446	VIPRINT   2B6B
VISTAT    3110	VISUAL    1BCD	VITXT     3006	VIVT      2D20	VLOADIT   14ED
VT        000B	VT1       2D23	VT2       2D30	VT3       2D41	WAI       0002
WAIT2     1A4A	WORDFOT   04D2	WRIDI     1FE9	WRITE     D024	XHOLD     27AC
XQCOR     2BCB	XQDATB    2B15	XQDATC    2B2F	XQDATD    2B37	XQDATE    2B44
XQDATF    2B56	XQDATG    2B5E	XQDATH    2B64	XQDATI    2B67	XQUSER    28CD
XSAVE     1048	XTEMP     104A	XTEMP2    104B	XTEMP3    104C	YESASC    20BA
YHAST     106A	YO        1E89	YSAVE     1049

Bijlage V: Automatisch bellen
******************************

Veel modems hebben de mogelijkheid om automatisch te kunnen bellen. Dit
houd in dat een modem een relais (pulskiezen) of een toongenerator
(toonkiezen) heeft die bestuurd kan worden met de computer. Alleen bij
hayes modems is sprake van standaardisatie. Ieder hayes modem kan
bestuurt worden met dezelfde codes om het modem een nummer te laten
'draaien'. Vele andere modems bezitten ook een autodial optie maar
meestal moet die met speciale software ondersteund worden. Viditel-65
ondersteund alle mogelijke vormen van autodial, onder te verdelen in
vier groepen:

1. Hayes dialer.
2. RTS dialer.
3. Bansoft dialer.
4. Andere dialer.

ad 1: Hayes dialer
Ieder hayes modem bezit standaard een dialer. Zodra de keuze voor
Hayesmodem gemaakt is, is ook meteen de autodialfunctie gedefinieerd.
Met MCONFIG kan men instellen of men puls- of toonkiezen wenst.

ad 2: RTS dialer.
Sommige modems bezitten een lijnrelais dat te bedienen is via het RTS
{Request To Send} signaal van de RS232. Dit relais schakelt in overeen-
stemming met de aangeboden pulsen, en kan dus een nummer kiezen.

ad 3: Bansoft dialer.
Het betreft hier een zelfbouw dialer die toegevoegd kan worden aan een
bestaand modem die geen autodial mogelijkheid bezit. De hardware staat
beschreven in de Elektuur halfgeleidergids van 1986. (pag 79,
schakelingnr. 29) en moet aangesloten worden op uw computer met een
verbinding van PB5 (VIA 2) naar dial-in van de elektuur schakeling.
PB6 wordt gebruikt om het modem op/van de telefoonlijn te schakelen.
De software voor deze schakeling is ontwikkeld door Bansoft uit
Enschede, en is een onderdeel van het viditelprogramma.

ad 4: Andere dialer.
Dit vergt enige zelfwerkzaamheid van de gebruiker. U zult zelf een
programmaatje moeten maken dat de autodialer van uw modem kan besturen.
Het meeste werk is echter al gedaan. Het enige wat u hoeft te doen is
het lezen van het geselecteerde nummer uit DIALBUF en dat om te zetten
naar geschikte signalen die dan via een VIA uitgang naar uw modem
gestuurd worden. De syntax van de data opgeslagen in DIALBUF is de
volgende: kkk,aaa\0
met kkk = kengetal (ascii)
      , = pauzeteken (ascii)
    aaa = abonneenummer (ascii)
     \0 = einde string teken ($00)

Voorbeeld: 01180-34336 staat in dialbuf in hex als:
DIALBUF: 30,31,31,38,30,2C,33,34,33,33,36,00
[Let op: Scheidingsteken is een komma!]

Het programma moet beginnen op adres OWNDIAL+3 met de volgend data:

	ORG	OWNDIAL+3

	JMP	MYDIALER
	FCC	'DIAL'
MYDIALER ....werkelijke programma....

Beschikbare geheugenruimte: OWNDIAL+3 - $A9FF.
De adressen van DIALBUF, OWNDIAL, e.a. vind u in de labeltabel. (bijl. V.)
Meestal zal een dergelijke dialer met een pulstrein conform het te
draaien nummer bestuurd moeten worden.
Het aantal pulsen komt overeen met het getal dat men wil draaien. Het
getal nul bestaat uit tien pulsen. Een puls moet 60 millisec lang zijn.
(contact geopend) Tussen twee onderbrekingen in moet het contact 40
milliseconden gesloten zijn.

Wil men een modem on-/offline schakelen dan kan men daarvoor de
volgende subroutines gebruiken:
DTRON	Activeert RS232-lijn DTR (+12V)
DTROFF	Maakt de RS232-lijn DTR inactief (-12V)
MON	Maakt PB6-VIA2 actief (TTL 0V)
MOFF	Maakt PB6-VIA2 inactief (TTL +5V)
Het verdiend aanbeveling om eerst goed te bekijken of de software
behorende bij de RTS/bansoft dialer ook geschikt is voor uw modem.

Het maken van een file met telefoonnummers voor autodial
--------------------------------------------------------
Met ED kan men een file maken waarin de telefoonnummers van databanken,
medehobbyisten met een modem, e.d. in opgenomen kunnen worden.
De file MOET Vitel.dir heten, en moet alsvolgt opgebouwd worden:
a) Voor ieder telefoonnummer zijn max. 80 karakters beschikbaar. (1
   regel op het scherm)
b) De syntax van een regel is:
   XYZ kkk-aaa ;Commentaar <CR>
   met X = Baudrate parameter. (moet in kolom 1 staan)
       Y = woordformaat. (moet in kolom 2 staan)
       Z = protocol. (moet in kolom 3 staan)
     kkk = het kengetal.
       - = scheidingsteken/pauze teken. (minteken)
     aaa = het abonneenummer.
       ; = commentmarker, geeft aan dat er commentaar komt.
    
c) Lege regels mogen niet voorkomen.
d) Er is geen speciaal file-sluitteken nodig.
e) Spaties en tabs mogen na kolom 3 geplaatst worden.
   
Hoewel het mogelijk is de file vitel.dir zo uitgebreid te maken tot de
maximale capaciteit van een diskette, verdiend het aanbeveling om max.
255 pagina's op te slaan. (dat zijn 5000 nummers) De paginateller telt
namelijk maar tot 255 en begint dan weer bij nul. In de praktijk zullen
een a twee pagina's al voldoende zijn.

*****************************************************************
* Baudrateparam:    *	Woordformaat:	*	Protokol:	*
*****************************************************************
*  X=1: 2400/2400   *	Y=A: 8N1	*	Z=V: Videotex	*
*  X=2: 1200/1200   *	Y=B: 7E1	*			*
*  X=3:  300/300    *	Geen betekenis	*			*
*  X=4: 1200/75	    *	als X=5.	*			*
*  X=5: dos def.    *			*			*
*****************************************************************

Voorbeeld van Vitel.dir:

4BV 078-15600   ;Comnet mt
4BV 035-231513  ;Hobbytel, Hilversum.
4BV 04402-71850 ;Elektuur databank
4BV 04139-3206  ;Manudax visual info system
4BV 015-143842  ;Ecd poseidon
4BV 020-274744  ;Promptnet (alleen buiten kantooruren)
4BV 020-194334  ;Voc bbs data
4BV 010-4332035 ;Velobyte infosystem acorn bbc
4BV 079-413921  ;Vidicode
4BV 023-355949  ;Miamitel
4BV 03402-38264 ;Nova (gebrnr:738001)
4BV 020-434201  ;Klm reserveringen
4BV 05202-19295 ;Kameleon


Overwegingen samenstelling Vitel.dir
------------------------------------
Het minteken is het pauzeteken. Er wordt dan even gewacht voordat het
abonneenummer gedraait word. Voor nationale verbindingen zal 1
pauzeteken in alle gevallen voldoen. Is het noodzakelijk om langer te
wachten, dan kan dat door meerdere pauzetekens op te nemen in de
string. Bijvoorbeeld: 01180---34336. Er wordt nu 3 keer zolang gewacht.

Hoewel het op het eerste gezicht aantrekkelijk lijkt om een alfabetisch
geordende lijst samentestellen, blijkt in de praktijk toch dat men
beter de meestgebruikte nummers op pagina 1 (eerste 20) kan zetten.
Dit bespaard veel zoekwerk, en de hele file Vitel.dir hoeft niet
doorgebladert te worden.
Heeft men een 300/300 en 1200/75 modem dan is het aantrekkelijk om te
downloaden met 1200 Baud en te uploaden met 300 Baud. Neem het
telefoonnummer dan dubbel op in Vitel.dir, met beide baudrates.
<>

Bijlage VI: RS232
*****************

Aansluitmogelijkheden:

uC			modem

a) Volledige implementatie

2            TXD-->        2
----------------------------
3            RXD<--	   3
----------------------------
20           DTR-->	  20
----------------------------
6            DSR<--	   6
----------------------------
4            RTS-->	   4
----------------------------
5            CTS<--	   5
----------------------------
8            DCD<--	   8
----------------------------
7            GND	   7
----------------------------


b) geen besturingssignalen

2            TXD-->        2
----------------------------
3            RXD<--	   3
----------------------------
20 DTR
--------|
6  DSR  |
--------|
4  RTS
--------|
5  CTS  |
--------|
8            DCD<--	   8
----------------------------
7            GND	   7
----------------------------


c) voor smartmodems (Hayes-compatibles)

2            TXD-->        2
----------------------------
3            RXD<--	   3
----------------------------
4            RTS-->	   4 Mag ik (uC) zenden ?
----------------------------
5            CTS<--	   5 Modem is klaar om te gaan zenden
----------------------------
6            DSR<--	   6 Dataset(=modem) ready (dwz actief na power up)
----------------------------
7            GND	   7
----------------------------
8 DCD			     Altijd carrier detect als terminal=ready	
-----|
20   |       DTR-->	  20 Terminal (uC) is klaar om te communiceren
-----|----------------------
22          RING<--	  22 Binnenkomend telefoontje (AA)
----------------------------

***> !Bij een MODEM mogen RxD en TxD elkaar NOOIT kruisen! <***

Aansluitmethode c) verdient enige toelichting. Intelligente modems geven
foutmeldingen en andere meldingen, zoals CONNECT 1200 Baud, CARRIER DETECT,
NO CARRIER, ERROR-COMMAND, etc. De RS232 ontvanger (uC) accepteert alleen
data als DCD actief is. Bij een foutmelding is dit meestal niet het geval.
Vandaar dat DTR (of indien die niet gebruikt wordt RTS) verbonden moet worden

Vandaar dat DTR (of indien die niet gebruikt wordt RTS) verbonden moet worden
met DCD. Bij sommige intelligente modems kan men methode a) aanhouden omdat
die DCD activeren, als het modem iets wil verzenden via de RS232. (meestal
schakelbaar met dipswitch op het modem)
De software van het communicatieprogramma moet er voor zorgen dat dergelijke
foutmeldingen niet in het geheugen of op schijf komen.

Hoewel DOS-65 niet voorschrijft of men een male of een female D-connector
moet gebruiken, is het aan te bevelen om de Rs232c male, en de andere
(keyboard, centronics) female te nemen. Er kan dan nooit abusievelijk +12V of
-12V op TTL apparatuur komen. Bovendien hebben zowel de IBM-PC als de
ATARI-ST een 25 polige male D-connector als modemaansluiting. Heeft men nu
net een female gemonteerd, dan is dat ook geen probleem, want genderchangers
(f/f, m/m) kan men ook heel goed kopen op de HCCdagen. Een modem heeft altijd
een female connector.

Bijlage VII: Foutmeldingen en waarschuwingen.
*********************************************

* Algemene foutmeldingen:
NOT IMPLEMENTED: Utiliteitsprogramma bestaat niet.
MACRO ERROR: Verkeerde macrotoets ingedrukt, macro bestaat niet of de
macro is leeg.

* Foutmeldingen disk i/o:
VIDITEL.CFG NOT FOUND: File niet aanwezig op de systemdrive S. Dit
	is de enige fout die tot gevolg heeft dat naar dos-65 wordt
	teruggekeert.
FILENAME TOO LONG: Een filenaam mag uit maximaal 15 karakters bestaan.
FILENAME NEEDED: Er moet een filenaam ingevoerd worden.
FILE TOO LARGE: File is te groot om in het geheugen te zetten.
DISK FULL: De diskette is vol. Downloading wordt voortgezet. Als de
	file in het werkgeheugen past, kan men de data met het
	doscommando "SAVE" naderhand op disk zetten. Is het een file
	die niet in het werkgeheugen past, dan moet men het downloaden
	afbreken.
DRIVE x NOT READY: Boot uw systeem opnieuw op. Save de
	gedownloade data vanuit dos-65.

* Foutmeldingen dialer:
NUMBER TOO LONG: Een telefoonnummer mag max. 17 karakters lang zijn.
INPUT ERROR: Het telefoonnummer bestaat uit vreemde symbolen.
DIAL ERROR: Incorrect nummer/parameters. Bellen is niet mogelijk.
	    Deze fout komt voor indien in Tel.dir niet de voorge-
	    schreven kolomindeling wordt aangehouden.
S:VITEL.DIR NOT FOUND: File niet aanwezig op drive S.
NO NUMBER SELECTED: Er is geen telefoonnummer gekozen.
OWN DIALER NOT PRESENT. Autodial faciliteit niet aanwezig.

* Waarschuwingen en meldingen Videotex terminalmode *
MEMORY FULL: Werkgeheugen is vol. Na deze melding zal de data die zich
	in het werkgeheugen bevind automatisch op disk gezet worden,
	waarna het werkgeheugen weer te gebruiken is. (gaat automatisch)
PAGEBUFFER FULL: Het paginabuffer is vol. Na deze melding wordt automatisch
		 het pagebuffer gewist, en ieder volgend karakter wordt weer
		 boven aan de pagina geprint. Deze fout komt voor als de
		 ontvanger een formfeed mist, of als er erg veel foutmeldingen
		 van de videotexhost achter de pagina ontvangen worden.
MEMORY EMPTY: Er zijn geen pagina's in het 'storage memory' opgeslagen, en
	      er kan dus ook niks op disk gezet worden.
PAGEBUFFER EMPTY: Er is geen pagina in het 'pagebuffer' opgeslagen.
CANCEL, CANCELED BY, TRANSFER TERMINATED: Na het geven van een
	cancelopdracht door de remote of de local is de dataoverdracht
	gestaakt.

Bijlage VIII: Verschillen astrid v1.0 met Viditel V2.2
******************************************************
-Clocksignaal nu op PB7 i.pv. CB1 voor splitspeedmodems.
-Zet achtergrondkleur ESC ] verbeterd.
-Uitbreiding commandoset.

Bijlage IX: Specificaties
*************************

Appendix X: Commandsummary Viditel-65 V2.2
******************************************

MAINMODE:
=========
H: Help information.
M: Print the menu.
N: Clear pointers. (NEW)
C: Connect (go in terminalmode)
O: On hook. (switch modem off-line)
A: Autodial. (Enter autodialmode)
R: Redial last number again.
T: Define transferparameters.
L: Load a file from disk.
S: Save a file on disk.
D: Store all to be received data on disk.
E: Back to dos-65 definitely.
Q: Execute a dos-command. Return to viditel with G 1000.

TERMINALMODE:
=============
^H: Help.
^K: Transmit code of key, entered after ^K, e.g. ^K^Y transmits ^Y.
^Y: Dis/enable paritycheck.
^B: Get bottompage.
^T: Get toppage.
^W: Get previous page.
^Z: Get next page.
^L: List the page who is in the pagebuffer.
^R: Retype the page, showing the conceiled information. (Reveal)
^E: Erase pagebuffer.
^S: Save a page in storagememory.
^P: Transmit a page to the remote.
^O: Leave the remote. (Log out)
^A: Show status information.
^[: To mainmode.
^N1,2,3,4: Execute a macro.

AUTODIALER:
===========
^K: To previous number,
^L: To next number,
^W: To previous page,
^Z: To next page,
sp: Dial the marked number,
^M: Dial a number manual,
^[: Return to the menumode.

<>
