



                                                                      



        AAA         SSSSSSSSSSS  TTTTTTTTTTTTTTT  RRRRRRRRRRR  II  DDDDDDDD
       AA AA        SS           TTTTTTTTTTTTTTT  RR       RR  II  DDDDDDDDD
      AA   AA       SS                 TT         RR      RR   II  DD      DD
     AA     AA      SS                 TT         RRRRRRRRR    II  DD       DD
    AA       AA     sSSSSSSSSSS        TT         RRR          II  DD        DD
   AAAAAAAAAAAAA             SS        TT         RR RR        II  DD       DD
  AA           AA            SS        TT         RR   RR      II  DD      DD
 AA             AA           SS        TT         RR     RR    II  DDDDDDDDD
AA               AA SSSSSSSSSSS        TT         RR       RR  II  DDDDDDDD (C)

* * * * * * * *        D A T A C O M M U N I C A T I E       * * * * * * * *

				   V 2.2






















		***************************************
		*  Handleiding communicatieprogramma  *
 		*  voor een DOS/IO 65 systeem V2.01   *
		***************************************

	Astrid manual					       Pagina 1


			 INHOUD:
			=*=*=*=*=
              
	       Inhoudsopgave....................................pag.  1
Hoofdstuk  1 : Inleiding........................................pag   3
Hoofdstuk  2 : Terminologie.....................................pag.  4
Hoofdstuk  3 : Installatie......................................pag.  4
Hoofdstuk  4 : Het starten van het programma....................pag.  5
Hoofdstuk  5 : Communicatieprotocollen..........................pag.  5
               Het Asciiprotocol................................pag.  6
	       Het Xmodemprotocol...............................pag.  6
	       Het Kermitprotocol...............................pag.  6
Hoofdstuk  6 : De modes van Astrid..............................pag.  7 
Hoofdstuk  7 : De mainmode......................................pag.  7
               Help.............................................pag.  8 
               Menu.............................................pag.  8
               New..............................................pag.  8
               Connect..........................................pag.  8
               Verbreek de verbinding...........................pag.  8
               Automatisch bellen...............................pag.  9
               Bellen van het laatst gekozen nummer.............pag.  9
               Transferparameters...............................pag. 10
               Protocolkeuze....................................pag. 10
               Download.........................................pag. 11
               Het opgeven van de filenaam......................pag. 11 
               Het diskformaat..................................pag. 11
               Algemeen.........................................pag. 11
               Upload...........................................pag. 11
               Linefeed toevoeging aan CR bij upload............pag. 11 
               Exit.............................................pag. 12 
               Quit.............................................pag. 12
Hoofdstuk  8 : Terminalmode.....................................pag. 12
Hoofdstuk  9 : De udomode.......................................pag. 12
Hoofdstuk 10 : De statusregel...................................pag. 13 
Hoofdstuk 11 : Voorbeelden up/download..........................pag. 14 
               Ascii download...................................pag. 14
               Ascii upload.....................................pag. 15
               Xmodem up/download...............................pag. 16
               Kermit download..................................pag. 16 
               Kermit upload....................................pag. 16
Hoofdstuk 12 : Voorbeeld van een fido-sessie....................pag. 16
               De eerste verbinding.............................pag. 17
               Geavanceerd gebruik van fido.....................pag. 18

Bijlagen:
---------

   I. Configuratie..............................................pag. 19
  II. Configuratievariabelen....................................pag. 26
 III. Lijst programmeerbare toetsen.............................pag. 27
  IV. Geheugenindeling..........................................pag. 27
   V. Automatisch bellen........................................pag. 31
  VI. RS232.....................................................pag. 34
 VII. Foutmeldingen Astrid......................................pag. 35
VIII. Verschillen Astrid v1.0 met Astrid v2.0./v2.1/v2.2........pag. 37
  IX. Specificaties.............................................pag. 37
   X. Commandotabel.............................................pag. 38
	Astrid manual					       Pagina 2


Astrid-communicatie is ontwikkeld door :	Bram de Bruine
						St.Joostdijk 23,
						4307 AR Oosterland.

Deze manual is geschreven door :		Bram de Bruine

Voor de Astrid programmatuur evenals deze manual geldt :
Copyright (c) 1987 Bram de Bruine
	Astrid manual					       Pagina 3



1. INLEIDING
============

Astrid  is  een  public-domain  communicatieprogramma  dat het mogelijk
maakt om -al dan niet via een modem- informatie uit te wisselen met een
andere computer, met de volgende mogelijkheden:
- Terminal-emulatie,
- Asynchrone data overdracht volgens Ascii (Wait/Stop,^S/^Q), Xmodem en
  Kermitprotocol,
- Autodialfaciliteit,
- Macro-expansie.

Dit   programma  is  gemaakt  omdat  er  voor  DOS-65  nog  geen  enkel
communicatieprogramma beschikbaar was, terwijl de databanken letterlijk
als   paddestoelen  uit  de  grond  rijzen.  Denk  maar  eens  aan  het
HCC-fidonet,  en de vele databanken van (computer)gebruikersgroepen. In
bladen  als  de  HCC-nieuwsbrief  en  Byte  vind  hoofdzakelijk nog een
bespreking  van software plaats. Wil men de software zelf in zijn bezit
krijgen dan zal dat van een databank geladen moeten worden. Programma's
uit  de  bovengenoemde  bladen zijn terug te vinden op alle Fido's. Het
voordeel  hiervan is dat men geen programma's meer hoeft over te tikken
uit  hobbybladen. De andere kant van de medaille is dat degene die geen
toegang heeft tot een dergelijke databank, uit de boot valt, en niet zo
gemakkelijk meer aan software kan komen. Al deze factoren in aanmerking
genomen is er wel degelijk een behoefte aan communicatieprogrammmatuur.
Mede  doordat  modems steeds goedkoper worden, en het aantal databanken
nog steeds groeiende is.

Iedereen die datacommunicatie wil toepassen kan Astrid daarvoor gebrui-
ken. Zowel dataoverdracht via de telefoon met een modem, als direct van
computer naar computer is mogelijk.

Deze  manual  geeft  een complete gebruiksaanwijzing voor het programma
Astrid. De bijlagen completeren het geheel, en zijn bedoeld voor degene
die zich grondig wil verdiepen in deze materie.

	Astrid manual					       Pagina 4


Hoofdstuk 2. TERMINOLOGIE
=========================

LOCAL:	     Indien  twee machines gekoppeld zijn via een RS232 verbin-
             ding, dan verstaan we onder de LOCAL die machine die u als
	     terminal gebruikt.
REMOTE:	     Dat  is de machine die 'ver weg' staat. In de regel zal de
	     REMOTE een databank zijn.
HOST:	     Gastcomputer.  In  deze  manual  word  de term HOST alleen
	     gebruikt voor een databank. De HOST is dus de REMOTE.
FIDO:	     Communicatieprogramma  dat  PC's  omvormt  tot een datanet
             eenheid.  Fido  word  meestal in de betekenis van databank
             gebruikt.  In Nederland is er een groot datanet van Fido's
             van  de  HCC. Alle Fido's staan in verbinding met een cen-
             trale  computer,  het knooppunt in het net. (de zgn. fido-
             node)  De  fidonode  verzamelt  via echomail de berichten,
             sorteert  en verspreid ze weer. De HCC-fido's bevatten ook
             veel informatiegebieden van gebruikersgroepen en uiteraard
             een enorme sortering aan software voor een groot scala van
             computers.
PC:	     Personal Computer.
ASTRID:	     (A)synchronous  (S)erial (T)ransmitter/(R)eceiver (I)nter-
             faceprogram  for  (D)atacommunication.  De  naam  van  het
	     communicatieprogramma dat deze handleiding beschrijft.
AUTODIAL:    Mogelijkheid  om  automatisch het modem een telefoonnummer
             te laten draaien.
REDIAL:	     Kiezen  van het laatstgekozen nummer. Als een remote bezet
             is,  kan men na verloop van tijd proberen of hij misschien
             weer  al  te bereiken is. Dit gaat sneller met een redial-
             mogelijkheid,  dan  het  helemaal  opnieuw  kiezen van een
             nummer.
HAYESMODEM:  Een  intelligent  modem  met  een  microprocessor  die een
 	     gestandaardiseerde  commandoset  kent.  Die commandoset is
	     ontwikkelt  door  D.C.  Hayes. Hij zette daarmee een stan-
             daard. Vandaar  dat  een intelligent modem genoemd is naar
             Hayes.
UPLOAD:	     Het overdragen van data van de Local naar de REMOTE.
DOWNLOAD:    Het overdragen van data van de REMOTE naar de LOCAL.

Hoofdstuk 3. INSTALLATIE
========================

Astrid  is  geschreven in machinetaal voor een standaard 6502 micropro-
cessor. Het sourceformaat is volgens de DOS-65 assembler.

Hardware eisen
--------------
- DOS65/IO 65 systeem V2.01, volledige implementatie.
- Viditel  karaktergenerator  voor  de  VDU-kaart. Ook met de standaard
  DOS-65  karaktergenerator  kan  met Astrid gewerkt worden. Alleen zal
  men dan een paar vreemde graphics in de statusregel zien verschijnen.

Software configuratie
---------------------
Astrid  is  niet  zondermeer te gebruiken. (zie bijlage I configuratie)
Met  het  programma MCONFIG is het mogelijk Astrid aan te passen aan uw
eigen modem en systeem.
	Astrid manual					       Pagina 5


Hoofdstuk 4. HET STARTEN VAN HET PROGRAMMA
==========================================

Het  hoofdprogramma  ASTRID heeft twee hulpfiles nodig, die allen op de
systeemdrive  moeten  staan.  Zodra  ASTRID  opgestart  is zal hij gaan
zoeken naar Astrid.cfg. Deze file bevat de variabelen die nodig zijn om
met een bepaald modem te werken, en zijn dus modemafhankelijk.
Gebruikt  men  de  autodialfaciliteit  dan  zal de file tel.dir geladen
worden.

Astrid moet aanwezig zijn op de systeemdrive.
Helpinformatie kan men opvragen met:

HELP ASTRID <CR>

Het programma kan men starten door de naam in te tikken:

ASTRID <CR>

Als  het programma eenmaal geladen is, en niet overschreven is door een
utiliteitsprogramma, dan kan men het herstarten met:

GO A000 <CR>


Hoofdstuk 5. COMMUNICATIEPROTOCOLLEN
====================================

Om  twee  computers met elkaar te laten communiceren moet men afspraken
maken  die  beide  systemen respecteren. Wil men met meerdere computers
communiceren  dan  ontstaat  algauw  de  behoefte  aan een afspraak die
iedereen  naleeft,  zodat  niet  voor  iedere  individuele computer een
andere  manier  van  dataoverdracht  plaats  hoeft  te  vinden. Het zal
duidelijk zijn dat er een grote behoefte zal ontstaan aan een protocol.
Een  standaard  die allen naleven, en het mogelijk maakt om onbekommert
data uit te wisselen.

Bovendien  moet  een  protocol er zorg voor dragen dat de data foutloos
overgedragen  wordt.  Dit  betekend dat er een vorm van foutdetectie en
foutcorrectie  moet plaatsvinden. Ook is het van belang dat de twee met
elkaar verbonden computers synchroon lopen. De ontvangende computer mag
niet sneller lopen dan de zendende. Elk protocol bestuurt de synchroni-
satie door middel van besturingstekens. (bv XON/XOFF bij ascii)

Helaas  is  er niet een (1) wereldstandaard, maar zijn er verschillende
protocollen  die  veel  gebruikt  worden.  Het  gaat hier om asynchrone
datacommunicatie,   synchrone  protocollen  worden  buiten  beschouwing
gelaten.
Bekende  protocollen  zijn  Ascii,  Xmodem  en  Kermit.  Ze  zijn allen
ontwikkeld omdat er behoefte ontstond aan een uniforme codering. Kermit
werd  ontwikkeld  aan  de  Columbia universiteit in New-York. Xmodem is
vervaardigt  door een hobbyist die een eenvoudige mogelijkheid zocht om
data betrouwbaar over te zenden. Vandaar dat men Xmodem vooral aantreft
in  de  hobbysferen,  zoals  bij de HCC-fido's en de vele public-domain
databanken.  Een  vraag die menigeen zich zal stellen is "Wanneer wordt
welk  protocol gebruikt ?". Globaal kan men stellen dat het asciiproto-
col gebruikt wordt voor asciifiles en messages.
	Astrid manual					       Pagina 6


Xmodem  is  ideaal  om  hexfiles van een fido of iedere andere databank
die   Xmodem  accepteert,  binnen  te  halen.  Kermit  word  veel  door
bedrijven,  overheidsinstellingen  en  universiteiten  gebruikt. In het
algemeen  kan  men  zeggen dat men een file het snelst en betrouwbaarst
binnenhaald  met  Xmodem.  Als  Xmodem beschikbaar is, gebruik het dan,
zowel voor ascii- als hexfiles.

Het Ascii protocol
------------------
Een  veelgebruikt  protocol, dat op iedere databank aanwezig is. Het is
een  "domme"  methode,  alleen  geschikt  voor tekstfiles, zonder enige
foutcontrole  en  correctie.  Met  het  XOFF-teken  laat  men de andere
computer weten dat hij moet wachten met zenden. Pas nadat de remote een
XON  ontvangen  heeft mag hij weer data gaan zenden. Dit protocol wordt
dan ook vaak aangeduid met de term wacht/stop-protocol.

Het Xmodem protocol
-------------------
Met  dit  protocol kan men willekeurige data overbrengen in blokken met
een  vaste bloklengte van 128 bytes. Ieder blok wordt voorafgegaan door
een  header  en  een set bloknummers. Het blok wordt afgesloten met een
checksum, die bestaat uit de som van de databytes.

+-------+---------+-------------+--------------+--------------+
| <SOH> | <BLKNR> | <CMPBLKNR>  |  <DATABLOK>  |  <CHECKSUM>  |
+-------+---------+-------------+--------------+--------------+

De  ontvanger  fungeert  als foutdetector en corrector. De foutdetectie
vind  plaats  door  vergelijking van de verwachte header en bloknummers
met  de ontvangen waarden, en door vergelijking van de berekende check-
sum  met  de  ontvangen  checksum. Foutcorrectie gebeurt met de ACK- en
NAKsignalen.  Is  er een fout ontdekt dan zal de ontvanger een NAK naar
de  zender  zenden  om  aan  te geven dat het blok helaas met fouten is
ontvangen.  De  zender  zal dan dat blok nog een keer verzenden. Is het
blok foutloos ontvangen dan wordt een ACK verzonden naar de zender. Als
er tien fouten optreden wordt het transferproces afgebroken.

Het Kermit protocol
-------------------
Evenals  Xmodem verdeeld ook Kermit een file in een aantal datablokken,
ook  wel  pakketjes genaamd. Bij Kermit is de lengte niet constant. Het
eerste  blok dat overgezonden word bevat informatie over de bloklengte,
filesoort (ascii/hex), timeoutime, etc.
De  maximale  bloklengte  is 94. Ieder blok wordt voorafgegaan door een
header  als  synchronisatieteken,  de bloklengte, een bloknummer en het
type  van  het  datablok. (bv: datapakket, initialisatieblok, etc.) Het
blok word afgesloten met een checkbyte.

+-------+---------------+-----------+--------+--------+---------+
| <SOH> | <BLOCKLENGTH> | <BLOCKNR> | <TYPE> | <DATA> | <CHECK> |
+-------+---------------+-----------+--------+--------+---------+

Ook  bij  Kermit treed de ontvangende computer op als foutopspoorder en
verbeteraar.   Het  foutcorrectiemechanisme  bestaat  uit  het  opnieuw
overzenden van hetzelfde pakket als er een fout opgetreden is. Een fout
in  de  dataoverdracht  kan  gevonden  worden als er iets mis is met de
header  (SOH),  de  pakketlengte,  het  pakketnummer, en het checkbyte.
	Astrid manual					       Pagina 7


Om  aan te geven dat er iets mis is gegaan zend de ontvangende computer
een  NAK-pakket  naar  de  remote. Dit is een pakket volgens de normale
syntax,  maar  het  typebyte  geeft  aan dat het niet om een datapakket
gaat,  maar  om  een  pakket dat aanduid dat er een fout is opgetreden.
Een ACK-pakket wordt verstuurd als een pakket goed is ontvangen.

Kermit  is  er  in vele uitvoeringen. De Kermit die is opgenomen in het
Astrid  communicatiepakket  is  een  basic-Kermit.  Dat  wil zeggen dat
alleen   het   basisprotocol   geimplementeerd  is,  en  niet  allerlei
mogelijkheden  als  server/remote  die  van  belang  zijn om een Kermit
zonder menselijke tussenkomst zelfstandig te laten werken.
Welke  Kermit  je  ook  tegenkomt,  hij  kan  altijd  het basicprotocol
verwerken.  Ook  overdracht  van  hexfiles  met  remotes die met 7 bits
werken is mogelijk.

**De  foutcorrectie  bij  Kermit  en  Xmodem is niet waterdicht. Het is
mogelijk  dat  er  toch  een  fout  in sluipt, terwijl het checkbyte de
juiste  waarde heeft. In de praktijk zal dat gelukkig zelden voorkomen.
Immers  $00+$00 levert hetzelfde als $80+$80. Indien er meerdere fouten
optreden,  kan  de  checksum  toch een correcte waarde leveren. Dit is 
inherent met de foutdetectiemethoden van Xmodem en Kermit.

Hoofdstuk 6. DE MODES VAN ASTRID
================================

Astrid kent drie verschillende modes:
- commandmode of mainmode,
- terminalmode,
- up/downloadmode, ook wel transfermode genoemd.

Astrid  komt  na  het  starten  altijd in de mainmode, en er kan alleen
teruggekeert worden naar DOS-65 vanuit de mainmode.
In  de  mainmode  kunnen  zaken  als de transmissieparameters ingesteld
woden.  Ook  disk  i/o  wordt  gestart  vanuit de mainmode. Automatisch
bellen  gebeurt  vanuit de mainmode. Het selecteren van een andere mode
(terminal/transfermode) gaat ook via de mainmode.
In  de  terminalmode  gedraagt de computer zich als een terminal. In de
up/downloadmode  (udomode) vind dataoverdracht van file naar remote, en
vice versa, plaats.

Hoofdstuk 7. DE MENUMODE
========================

Doordat Astrid volledig menugestuurd werkt, is het erg eenvoudig om dit
programma te bedienen. Zelfs iemand die nooit eerder met een communica-
tiepakket  gewerkt  heeft zal er onmiddellijk mee uit de voeten kunnen.
	Astrid manual					       Pagina 8


De mainmode kent de volgende commando's:

Communication 65  V2.1
======================

H> Help
M> Menu
N> New
C> Connect
O> On hook
A> Autodial
T> Transfer parameters
P> Protocolchange
D> Download
U> Upload
L> Linefeed conversion [upload]
R> Redial
Q> Quit E> Exit


	Choice [A,C,D,E,H,L,M,N,O,P,R,U,T,Q] ??


HELP
====
Met  de  "H"toets kan men hulp op het scherm krijgen in de vorm van een
informatiepagina.

MENU
====
Laat alle beschikbare commando's zien.

NEW
===
Zet  alle  geheugenpointers  op  hun  default waarde, maak alle buffers
leeg,  scan  alle  opties, veeg het scherm schoon en print het menu. De
transferparameters worden ongewijzigd gelaten.

CONNECT
=======
Ga  van  commandomode  in de terminalmode. De computer gedraagt zich nu
als terminal.

VERBREEK DE VERBINDING
======================
Met  het  "On  hook" commando word de telefoonverbinding verbroken. Het
DTR  signaal  (D_ata  T_erminal  R_eady) wordt inactief. Werkt uw modem
niet met DTR, dan zult u zelf de verbinding moeten verbreken.

"Connect"  heeft  tot  gevolg dat DTR actief wordt. Zodra een "On hook"
commando  wordt gegeven zal DTR inactief worden. Bij transparent modems
blijft  het  niveau  van  de DTR-lijn ongewijzigd totdat een "C" of "O"
commando  wordt  ingetikt.  Dit  maakt  het mogelijk om te (auto)dialen
zowel  met  DTR  geactiveerd  als  met  DTR in de rusttoestand. Sommige
modems  met  autodial  willen  alleen  maar 'dialen' als DTR actief is,
terwijl  de  meeste modems zonder autodial vereisen dat DTR niet actief
is.
	Astrid manual					       Pagina 9


Dat komt omdat bij die modems DTR het modem on-line schakelt en het
telefoontoestel  (kiezer)  van  de lijn schakelt, zodat het draaien van
een  nummer  onmogelijk is met geactiveerde DTR-lijn. Voor Hayes-modems
zal  DTR  altijd  geactiveerd worden zodra men een "Autodial"instructie
geeft.

Voorbeeld Transparent modem:
Opstarten: mainmode		DTR=rust
Connect				DTR=aktief
Breek: Menu (main)		DTR=aktief
Transferparameters		DTR=aktief
Download			DTR=aktief
Breek: Menu			DTR=aktief
On hook				DTR=rust
Autodial			DTR=rust, na bellen DTR=aktief
Breek				DTR=aktief
Autodial			DTR=actief

Tegelijk met DTR (RS232) wordt ook PB6 (TTL,VIA2) meegeschakeld.

AUTOMATISCH BELLEN
==================
Met  keuze  "A" kan men automatisch het modem een nummer laten draaien.
Uit  de  file Tel.dir wordt een blok gelezen en op het scherm gepresen-
teerd.  Met  de  toetsen  ^J  (volgend  nummer), ^K (vorige nummer), ^Z
(volgende  pagina)  en  ^W  (vorige  pagina) kan men een nummer kiezen.
Door  op  de  spatiebalk  te  drukken  wordt  het  nummer daadwerkelijk
gedraaid.  Eveneens  worden  dan  de gespecificeerde transferparameters
geprogrammeerd. Met de breaktoets keert men terug naar het menu als men
besluit  niet automatisch te bellen. Komt het nummer dat men zoekt niet
voor in de file Tel.dir, dan kan men het ook met de hand intypen, nadat
een  ^M  gegeven  is.  Hier  moet  alleen  het telefoonnummer ingevoerd
worden,  en  geen  transferparameters.  De  transferparameters  blijven
ongewijzigd.

Commando's:
***********
^K = Vorige nummer,
^J = Volgend nummer,
^W = Vorige bladzijde,
^Z = Volgende bladzijde,
sp = Draai geselecteerde nummer, (spatiebalk)
^M = Zelf een nummer intypen,
^[ = Terug naar de mainmode.

Beschikt  uw  modem  niet  over  een  autodialer,  dan  kan men Tel.dir
beschouwen  als  een  elektronische telefoongids, waarin men het nummer
kan  opzoeken.  Het  is  wel  mogelijk  om  de  ACIA en het protocol te
programmeren met de autodialer.

BELLEN VAN HET LAATST GEKOZEN NUMMER
====================================
Het  opnieuw  kiezen  van  het  laatstgeselecteerde nummer wordt in het
Engels aangeduid met de term 'auto-redial'.
Zodra  "R"  ingegeven is zal opnieuw het nummer dat als laatste gekozen
was, gedraaid worden.

	Astrid manual					       Pagina 10


TRANSFERPARAMETERS
==================
De communicatieparameters die men in kan stellen zijn:
a - De transmissiesnelheid; (aantal bits per seconde)
b - het woordformaat; (aantal databits, pariteit, aantal stopbits)
c - duplex; (Full of Half duplex)
d - kanaal. (answer of originate)

Het menu wordt als volgt gepresenteerd:

		      TRANSFER PARAMETERS:
***********************************************************************

			  Full/Half
	1. 2400/2400	     ^
	2. 1200/1200	     |		A. 8N1
	3.  300/300	<-- key -->	B. 7E1
	4. 1200/75	     |
	5. Dos def	     V
 ^[ = Quit	      Originate/Answer		space = confirm

***********************************************************************

Met  de  cursorbesturingstoetsen  kan  men  cyclisch alle mogelijkheden
doorlopen.   De   geselecteerde  parameters  worden  met  inverse-video
gemarkeert.  Met  de  spatiebalk  kan  men  de  gemarkeerde  parameters
daadwerkelijk  instellen.  Wil men de parameters ongewijzigd laten, dan
kan met de breaktoets teruggekeert worden naar het hoofdmenu.

Het  transferparametermenu  bied  de  mogelijkheid  om  veel  gebruikte
communicatieparameters  in  te  stellen. De meest gangbare baudrates en
woordformaten  zijn  opgenomen in de programmeertabel. Komt het nu toch
voor  dat  er  een  'exotische'  waarde ingesteld moet worden, dan moet
keuze  5  (Dos defined) gemaakt worden. Met het hulpprogramma RS232 dat
op de DOS-65 systeemschijf aanwezig is, kan men de parameters op iedere
willekeurige  manier  instellen.  Zodra  men in Astrid de 'dos defined'
keuze maakt, worden de waarden die met het RS232programma gekozen zijn,
gecopieerd  naar  de ACIA. Buiten 'dos defined' vallen Full/Half duplex
en  answer/originate.  Deze  waarden  moeten  nog wel correct ingesteld
worden!
Het  is verstandig om in de login.com een LO RS232.DAT te zetten die bv
als vijfde baudrate gebruikt kan worden. (Default 2400/2400)

PROTOCOLKEUZE
=============
Met  P  kan  men  kiezen tussen Ascii, Xmodem of Kermit als up/download
protocol. Deze keuze is alleen van belang als men iets gaat uploaden of
downloaden.
	Astrid manual				              Pagina 11


DOWNLOAD
========
Ontvang een programma van de remote volgens het geselecteerde protocol,
en zet het op disk onder de opgegeven filenaam.

Het opgeven van de filenaam
---------------------------
De  filenaam  kan  op  exact dezelfde manier ingevoert worden als in de
dos.  Ook de edittoetsen DEL, ^U en ^Y zijn te gebruiken. Door herhaald
<CR> in te tikken, keert men terug naar het mainmenu.


Diskformaat
-----------
De  ontvangen file wordt in grote blokken (ca. 20 Kbyte) op disk gezet.
Als  een  file of eindblok kleiner is dan de bloklengte wordt uiteraard
ook  alleen  dat gedeelte op disk gezet. Het voordeel van deze opzet is
tweeledig:  
           1. De diskdrive hoeft niet continu te werken,
	   2. Tijdbesparing. (=telefoonkostenbesparing)
Xmodem  en  Kermit  kunnen  zelf  vaststellen  of de ontvangen file een
asciifile of een binaire file is.

Algemeen
--------
Het   downloaden   kan  voortijdig  afgebroken  worden  met  ^X  of  de
breaktoets.  Het gedeelte van de file dat ontvangen is (voor een cancel
toets werd ingedrukt) wordt altijd op disk gezet.
Het  downloaden wordt bij Xmodem en Kermit automatisch beeindigt als de
file geheel ontvangen is.
Bij  ascii  download  moet men zelf ingrijpen (^X) om het downloaden te
beeindigen. Dit maakt het mogelijk om een complete sessie op disk op te
slaan.  Erg  handig  als men voor het eerst een bepaalde databank belt.
Naderhand kan alles nog eens rustig bekeken worden.



UPLOAD
======
Verzend een file volgens het geselecteerde protocol.
a - U File <CR> haalt File van disk en verzend die file naar de remote.
b - U  <CR> <CR> kijkt of er nog een file in het geheugen staat, is dit
    het geval, dan word hij verzonden naar de remote. Zoniet, dan wordt
    teruggekeert naar de mainmode.

LINEFEED TOEVOEGING AAN CARRIAGE-RETURN BIJ UPLOAD
==================================================
Er  zijn  remote's  die iedere regel tekst afgesloten willen hebben met
een CRLF. (Carriage return + linefeed, $0D,$0A)
Bij  alle  ascii-files  die naar een fido gezonden worden moet er zowel
een  <CR>  als een <LF> aan het einde van de regel staan. Files die met
DOS-65's  ED gemaakt zijn, bezitten alleen een <CR> aan het eind van de
regel.  Zet  men met de "L"toets de <CR> naar <CRLF> conversie aan, dan
word aan iedere <CR> automatisch een <LF> toegevoegd.
Voor het plaatsen van boodschappen in de fido messagearea's moet men nu
juist weer geen <LF> na de <CR> zenden.
Dit commando heeft geen invloed op Hex-files.
	Astrid manual					      Pagina 12


EXIT
====
Schakelt  het  modem  op  non-actief,  gevolgd  door een terugkeer naar
DOS-65.

QUIT
====
Keer  terug  naar  DOS-65,  maar  laat het modem aan staan. (DTR blijft
actief)  Dit  commando  is  bedoeld om naar dosniveau terug te keren om
daar  een  commando  uit te voeren. Utilities vanaf $800 of $A000 over-
schrijven  het  communicatieprogramma.  


Terugkeren  naar  Astrid  gaat  met  G 1000 of G A000. Keert men na een
Quitcommando  weer  terug  naar  Astrid dan worden de geheugenpointers,
filenaampointers   en   autodialbuffers  ongewijzigd  gelaten.  Ook  de
configuratiefile  Astrid.cfg  wordt niet geladen. Dit betekend dat alle
defaults  exact hetzelfde zijn als voordat het Q commando werd gegeven.


Hoofdstuk 8. DE TERMINALMODE
============================

In  de  terminalmode wordt ieder karakter dat met het toetsenbord wordt
ingetikt  rechtstreeks  doorgesluisd  naar  de host. In full-duplexmode
zend de host het ingetikte karakter terug, en dit door Astrid ontvangen
karakter,  word  geprint.  Bij half-duplex bedrijf wordt ieder karakter
dat  ingetikt  word  direct  geprint  en gelijkertijd verzonden naar de
host.

Dat  'ieder'  karakter van het toetsenbord naar de host word verzonden,
is niet helemaal waar. Er zijn twee uitzonderingen:
1e. De  breaktoets,  die  het  mogelijk  maakt om onder iedere conditie
    terug te keren naar de mainmode. (origineel ^[)
2e. De  macro-entertoets  (2nd),  waarmee  na een keuzetoets een vooraf
    ingevoerd stukje tekst verstuurd kan worden. (origineel ^N)
Het  is  mogelijk om met MConfig vier macro's te definieren. De toetsen
waarmee  men  de  macro's  kan aanroepen zijn ook vrij te programmeren.
De  macro's  mogen  niet genest worden. Alle karakters behalve een '\0'
mogen  voorkomen in de macro. Wil men om de een of andere reden de code
van  de  breaktoets  of  de  macro-entertoets  (2nd) ook naar de remote
verzenden, dan kan men die opnemen in een macro.
In  de  praktijk  is  het  handig  om  je  naam,  toegangswoord  en een
veelgebruikt remote commando op te slaan.

Hoofdstuk 9. DE UDOMODE
=======================

In de up/downloadmode zijn twee toetsen van belang:
1e. De  canceltoets,  (^X)  die  het up/downloadproces afbreekt, en een
    terugkeer  naar de terminalmode forceert. Als men ^X intypt gebeurd
    er het volgende:
    a. Het cancelkarakter word naar de remote verzonden,
    b. Voor download: Save alle data op disk totdat de ^X verzonden
                      werd, sluit alle files.
       Voor upload: Reset alle uploadpointers, en sluit de file.
    c. Spring naar de terminalmode.
	Astrid manual					      Pagina 13


    Er  wordt  naar de terminalmode gesprongen, omdat men daar kan zien
    hoe  de  remote  reageert  op  de  'annuleer'opdracht, en de remote
    verdere  instructies  gegeven kan worden, bv download van een ander
    programma of een log-out.
2e. De  breaktoets. De breaktoets indrukken heeft tot gevolg dat er on-
    voorwaardelijk  teruggekeert  wordt  naar  het hoofdmenu. Uiteraard
    wordt  de  data die zich op dat moment in het opslaggeheugen bevind
    op disk gesaved, voordat Astrid naar het menu teruggekeert.

Samenvatting:  Met  de  toetsen  [A,C,D,E,H,L,M,N,O,P,R,U,T,Q]  kan men
Astrid  verschillende opdrachten laten uitvoeren. Met de breaktoets kan
iedere opdracht abrupt afgebroken worden, en wordt teruggekeert naar de
mainmode.

Hoofdstuk 10. DE STATUSREGEL
============================

De  statusregel  verstrekt steeds relevante informatie over de toestand
waarin het programma verkeert.

+---------------+----------+--------+------+----+--------+-----+----+
| Tijd uu:mm:ss | PROTOCOL | STATUS | BAUD | WF | DUPLEX | O/A | FN |
+---------------+----------+--------+------+----+--------+-----+----+
		Xmodem	 Downloading  xxxx   5N1   F       ORG
		Kermit	 Uploading    2400   6E2   H	   ANS
		Ascii	 Terminal     1200   7O
			 Dialing       300   8
			 Idle		75
			 Main


Het  linkse  deel  van  de  statusregel  geeft de tijd weer, indien het
programma  in  de  mainmode  verkeert, wordt de tijd ook iedere seconde
opnieuw geprint.
Daarna word het protocol aangegeven waarmee data overdracht plaatsvindt
zodra men gaat uploaden of downloaden.
Het  statusdeel  geeft aan in welk programma onderdeel Astrid verkeert.
In  het volgende blok word de transmissiesnelheid van de zender weerge-
geven.  Als  de  baudrate  niet  in  het  keuzemenu voorkomt, worden er
kruisjes geprint.
Achter de baudrate komt het woordformaat dat alle mogelijke combinaties
kan visualiseren. Full- of Halfduplex word afgekort met F voor Full, en
met H vor Half duplex. Of er sprake is van answer of originate laten de
strings  ANS  en  ORG  zien. Het rechterdeel geeft de filenaam weer die
geupload  of  gedownload  word.  Kermit plaatst zelf de filenaam in het
statuslinebuffer.

Tijdens  het selecteren van een telefoonnummer wordt een andere status-
regel  gebruikt.  De  statusregel  is  alleen  uit  te  schakelen in de
filenaam-invoermode met ^^S. Bv: U ^^S <CR> <CR>
	Astrid manual					      Pagina 14


Hoofdstuk 11. VOORBEELDEN UP/DOWNLOAD
=====================================

Ascii download
==============
Ascii  download  van een file wordt toegelicht a.h.v. een voorbeeld van
een  sessie  met  een  HCC-fido.  We bevinden ons in het filegebied, en
kunnen kiezen uit D)ownload of T)ype. Met beiden is het mogelijk om een
ascii-file  binnen  te  halen.  Het onderstreepte (met ==) moet je zelf
invoeren.

-----------------------------------------------------------------------
- PROGRAMMA'S VAN DE MAAND ..........              HOBBY COMPUTERCLUB -
-----------------------------------------------------------------------
UNARC.COM       4352 de-ARChive voor CP/M !
QUARC.COM      10240 Quick UnARC voor MS-dos. Razendsnel !
QUARC.DOC       7523 
-----------------------------------------------------------------------

File Area #3: Algemeen Up- en Download gebied
A)rea-Change  F)iles        T)ype         D)ownload
G)oodbye      U)pload       M)ain-Menu    

File: A F T G U D M or ? for help: D
				   =
A)scii, K)ermit, X)modem, B)atch, T)elink, ? for help
add C for CRC, ie. XC, etc: A
			    =
Filename: QUARC.DOC		     	    <-- Nog geen <CR> geven !!!
	  =========

We geven nog geen <CR> maar gaan terug naar het menu van Astrid, zetten
het protocol op ascii en geven het Downloadcommando, waarna de filenaam
ingevoerd  wordt  en men in de downloadmode beland. Geef nu een <CR> en
het  downloaden wordt gestart. Het leuke van deze methode is, dat alles
op het scherm te volgen is. Men kan meelezen tijdens het downloaden. Om
het downloaden te stoppen, tikt men ^X in.

Een  veelgebruikte toepassing van ascii download is het binnenhalen van
boodschappen   uit  het  berichtengebied.  Omdat  men  op  willekeurige
tijdstippen  de  downloadmode  'aan' kan schakelen gaat dit analoog aan
het binnenhalen van een file. Nadat asciidownload actief is, komt alles
wat op het scherm verschijnt ook in de file.
	Astrid manual					      Pagina 15


ASCII UPLOAD
============
Toepassingen: Het plaatsen van een asciifile in een databank.
	      Het plaatsen van een bericht in een databank.

Hier  een  voorbeeld van het invoeren van een bericht, er van uitgaande
dat  het bericht vooraf is gemaakt en opgeslagen is in de file BERICHT.

 MAIN Commands:
 M)sg-Section       F)ile-Section      
 G)oodbye           S)tatistics        
 A)lle echo fido's  B)ulletin          
 Y)ell              C)hange            
 U)ser-List         E)ditorial+Newmail 
 V)ersion           
 Main: M F G S A B Y C U E V or ? for help: M 
					   ===
 Hier geeft men het comando 'M', 
 waarna het volgende menu op uw scherm verschijnt:
 
 Msg Area #1: Algemeen en Prive berichten
 A)rea-Change      L)ist headers     
 R)ead             E)nter            
 K)ill             I)ndex            
 S)tatistics       G)oodbye          
 M)ain-menu        
 Msg: A L R E K I S G M or ? for help: E
                                      ===

 Hier geeft men de E in daar men een bericht wil invoeren.
 Het volgende zal dan op Uw scherm verschijnen:

 This will be message #XX
 From: 'Uw naam'
 To: 'geadresseerde'
 Private? [y,N]: Y or N(zelf ingeven)
 Subject: onderwerp bericht
 Enter your message, blank line to end.
 Words will wrap automatically
 
  1: 

Het  is  nu  tijd om de computer het werk te laten doen. We keren terug
naar  de  mainmode  van  Astrid en typen U BERICHT <CR>. Om het upload-
proces  te  starten moet nog even een willekeurige toets ingedrukt wor-
den,  en de file Bericht wordt verzonden. Indien hij volledig verzonden
is, verschijnt er:

 Enter-Msg Command:
 L)ist A)bort D)elete I)nsert T)o subJ)ect
 C)ontinue E)dit S)ave 
 D I T J C E S ? : S
		   =
Met het fido-commando S wordt het bericht op de fido-disk gezet.
Het uploaden van een file in het filegebied gaat op dezelfde manier.
	Astrid manual					      Pagina 16


Xmodem up/download
==================
Xmodem  up/download  wordt  volledig  bestuurt  door Astrid. Het is met
Xmodem  dan  ook alleen mogelijk om files te ontvangen of te versturen.
De karakters zijn niet op het scherm zichtbaar.

File Area #3: Algemeen Up- en Download gebied
A)rea-Change  F)iles        T)ype         D)ownload
G)oodbye      U)pload       M)ain-Menu    

File: A F T G U D M or ? for help: D
				   =
A)scii, K)ermit, X)modem, B)atch, T)elink, ? for help
add C for CRC, ie. XC, etc: X
			    =
Filename: TESTFILE.DOC <CR>
	  =================

File TESTFILE.DOC ready to send.

We  keren  met  de  breaktoets terug naar de mainmode van Astrid, geven
daar het D kommando en de filenaam waaronder we de file willen opslaan,
en downloaden start automatisch binnen 10 sec. (meestal direct)

Upload gaat exact op dezelfde manier.

Kermit download
===============
Kermit upload
=============
Kermit is nog niet geinstalleerd in de versies V 2.x.

Hoofdstuk 12. VOORBEELD VAN EEN FIDO-SESSIE
===========================================
Onderstaand  een  paar  voorbeeldjes hoe een sessie met een fido-remote
verloopt.  Deze  voorbeelden  zijn  geregistreerd  mbv  ascii download.
Door  direkt na het bellen de asciidownloadmode te activeren komt alles
wat op het scherm wordt geprint, ook in de file te staan. Dit is vooral
handig  als  men  voor  het eerst een vreemde (nieuwe) remote benadert.
Naderhand  kan men rustig (dwz: zonder telefoonkosten) bekijken wat die
databank  te  bieden  heeft,  en  hoe  je  hem het beste kunt besturen.
Om  telefoonkosten  te drukken, doet men er verstandig aan om, onmidde-
lijk  als  de fido zijn welkomstscherm gaat printen een ^C te geven. Je
kunt dan direct je naam en wachtwoord invoeren. Daarna komt meestal nog
een bulletin, dat kan men met hetzelfde recept afbreken. Door de expert
in te schakelen, worden de menu's verkort geprint.
	Astrid manual					      Pagina 17


DE EERSTE VERBINDING
====================

Your FIRST name: MISTER
Your  LAST name: X
MISTER X? [Y,n]: Y
Wait ...
+-------------------------------------+
| Hallo Nieuwe gebruiker W E L K O M  |
| bij  Fido_Gerard II   500/206       |
+--------------=----------------------+
   Je hebt nu de eerste verbinding,

Heb je jouw naam wel goed ingegeven ?
Dus meerdere lettergrepen gescheiden
door een punt i.p.v. een spatie !!!!!!
 
Vul nu s.v.p. de vragenlijst in dan zal
binnen zeer korte tijd jouw privilege 
verhoogd worden, pas daarna kun je
software downloaden van deze fido.

Where are you calling from? OUTOFSPACE
OUTOFSPACE? [Y,n]: Y
Pick a password: DOS65
DOS65? [Y,n]: Y

Vragenlijst voor nieuwe inloggers.
LET OP !!!!! 
ALLEEN VOLLEDIG INGEVULDE
VRAGENLIJSTEN WORDEN TOEGELATEN
-KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
Achternaam           :
Straatnaam & nummer  :
Postcode             :
Woonplaats:          :
Telefoonnummer       :
----------------------------------------
Welke computer       :
Modem + Baudrates    :
Lid van welke GG     :
Welk interessegebied :
----------------------------------------
Bent U lid van de HCC ? (Niet verplicht)
(1)=Ja , (2)=Nee     :
Lidnummer HCC        :
========================================
Bedankt,we moeten alles even controleren 

Je hebt nu beperkte toegang tot dit
bulletin-board.  (30 minuten maximum) 

Niet VOLLEDIG ingevulde vragenlijsten
worden meteen verwijderd.

Op en of aanmerkingen zijn altijd welkom
Password: ........
	Astrid manual					      Pagina 18


Welkom  MISTER  X dit is jouw eerste verbinding met Fido_Gerard. Helaas
kun  je  nu  niet  veel  op  deze  Fido,  dit  vanwege  het feit dat er
gebruikers  zich  niet  aan de simpele regels willen houden. Sorry voor
het  ongemak,  als  je  de  vragenlijst goed hebt ingevuld dan krijg je
binnen  enkele uurtjes al een hoger privilege en dan kun je alle opties
gebruiken.
                                                        De Sysop.  

Helaas er is vandaag geen post voor MISTER X.


GEAVANCEERD GEBRUIK VAN FIDO
============================
Het  valt  buiten deze handleiding om een complete beschrijving van het
fidonetwerk  te geven. Een komplete gebruiksaanwijzing staat in de HCC-
nieuwbrief (catalogusbijlage) van november 1985. Het is ook mogelijk om
een manual bij de HCC te bestellen, of te downloaden van een fido.

Fido(tm) Version 11w
FidoNet(tm) Net 500 Node 16
!    GELUKKIG 1987 ALLEMAAL   !!    

HobbyComputerClub /^^\      SYSOP
Afd. SITTARD     / OO \      Leo    
NET/NODE        (_   /_)   Reijnen     
500/16          __`@/__\     _  
BAUDRATES      | FIDO  |\    \\
300-300        |  (*)  | \    ))
1200-75        |SITTARD|/  \ //  
1200-1200       -------      /
2400-2400        _//|| _\   /   
                (_/(_|(____/
---------------------------------
Your FIRST name: MISTER
Your  LAST name: X
Mister X? [Y,n]: y
Wait ...
Password: .......
You last called on 28 Dec 86  01:58:54

Your 4th call
            | Total Today Limit  Left
------------+------------------------
Downloaded: |    0     0   200   200 Kbytes
Uploaded:   |    0                   Kbytes
This call:  |    1          35    34 Min.
Per 24 Hrs: |          0   180   180 Min.
------------+------------------------
	Astrid manual					      Pagina 19


Bijlage I: Configuratie V2.1
****************************

Met  het  bijgeleverde  configuratieprogramma  is  het  mogelijk om het
communicatieprogramma  geschikt  te  maken  voor  een  van  de volgende
modems:

1. Hayes modem of Hayes compatibel modem. (zowel splitspeed als
   interspeed)
2. Modem met een interspeeder.
3. Transparant modem (split speed) zonder receiverclock.
4. Transparent modem (split speed) met interne receiverclock.

Ad. 1.
Een  Hayes modem is een intelligent modem dat zelf de baudrate bepaald,
zodra  hij  een  ATstring  ontvangt.  Elk Hayes modem beschikt over een
ingebouwde  autodial faciliteit. Het configuratieprogramma zorgt ervoor
dat de juiste strings naar het modem worden verzonden.

Ad. 2.
Modems  met een interspeeder zetten 75 Baud om naar 1200 Baud, zodat de
ACIA  in  het  computersysteem  altijd  met  dezelfde snelheid zend als
ontvangt.  Zit  er  een  interspeeder op je modem, dan is het niet meer
nodig om een receiverclock aan de ACIA aan te bieden.

Ad. 3.
Hiermee  worden  modems  bedoeld  die op een andere snelheid zenden als
ontvangen.  Het  gaat  dan  altijd  om  de  V23  norm van 1200/75 Baud.
Het   PTT  Vidimodem  en  de  Elektuur polyphemus zijn hier voorbeelden
van.  Bezit  je  een  dergelijk  modem, dan zul je PB7 van VIA 2 moeten
verbinden  met  pen  5 RxC van de ACIA, omdat het receiverclock signaal
opgewekt  wordt  door  Via  2.  Om  enige  vorm  van standaardisatie te
verkrijgen  is  het aan te bevelen om dit als in onderstaand schemaatje
te doen:

=====						     RS 232
    |PB7					  18
V   |-------------------------------------------------*   *--|
I   |						  17	     |
A   |						|-----*	  *--|
    |						|
=====						| chas    conn
						|
=====						|
    |RxC					|
A   |-------------------------------------------|
C   |
I   |
A   |
    |
=====

De signalen PB7 en RxC worden naar buiten gevoerd via het D-chassisdeel
van  de  RS232.  In  de  modemconnector  worden pen 18 en 17 met elkaar
verbonden.  Zodra  de modemconnector ingeplugd is, komt het signaal van
PB7 op de receiverclock ingang van de ACIA.
LET  OP: Voer de draden van pen 17 en 18 niet door naar het modem zelf.
	Astrid manual					      Pagina 20


Je weet maar nooit of er iets op aangesloten zit !
Bezitters  van een modem die naast 1200/75 ook nog 300/300 of 1200/1200
kunnen,  kunnen  de  verbinding  PB7-RxC  rustig laten zitten, want bij
iedere  andere  baudrate  dan  1200/75 wordt PB7 als ingang geschakelt.

Ad. 4.
Er  zijn  modems die zelf het receiverclocksignaal genereren, zodat het
communicatieprogramma  dat  niet  meer hoeft te doen. Een voorbeeld van
een zelfbouwmodem die een receiverclock uitgang heeft, staat beschreven
in  de  6502  kenner  nr.  49,  blz  41  e.v. (gemodificeerd minimodem)
Zorg ervoor dat RxC(ACIA) aan pen 17 v/d RS232 zit. Nu is  het mogelijk
om  via de RS232 kabel het clocksignaal van het modem aan te bieden aan
de ACIA. Controleer wel of het signaal op TTL niveau ligt.


Behalve  het  instellen  van de parameters voor een bepaald type modem,
zorgt het configuratieprogramma ook voor:

- Aanpassing  aan de systeemclock van uw systeem. Default is 1 Mhz. Let
  wel  op  dat bij configuratie voor een hogere frequentie dan 1 Mhz er
  aangenomen  wordt  dat  de  real-time clock gemodificeerd is voor die
  frequentie. Het gaat er om dat Hours, minutes, seconds en Viavra zich
  inderdaad  gedragen  als  resp. uurteller, minutenteller, secondentel
  ler,  en  viavra als teller die elke seconde verlaagt wordt met 1. Is
  dit  niet  het  geval dan zal de time-out time bij Xmodem up/download
   niet correct zijn. (Dit gebeurt mbv VIAVRA)
  
- Tijdmelding op statusregel aan/uit schakelen.
  
- Het zetten van de default waarden. Wilt u opstarten met het asciipro-
  tocol,  7E1,  300/300  ?  Verander eenvoudig deze waarden en voortaan
  wordt er opgestart volgens uw wensen.
  
- Het  definieren  van  de  speciale  toetsen. In te stellen zijn welke
  toets  men  als  breaktoets  wil  gebruiken,  welke  als 2nd macro en
  macrokeuze,  en welke voor cursorsturing. Voor de cursorbesturing kan
  men  het  beste  dezelfde  toetsen  nemen  als  in de Editor gebruikt
  worden.  Zorg   er  wel  voor  dat er geen toetsen worden gekozen die
  noodzakelijk  zijn om een bulletin board te besturen. Het ligt op het
  eerste  gezicht voor de hand om ^C als breaktoets te definieren. Toch
  is  dit  niet  aan  te bevelen omdat veel databanken ook ^C als break
  zien.  Zou men in zo'n geval dan een ^C geven dan wordt teruggespron-
  gen  naar de mainmode van Astrid,  terwijl het de bedoeling was om te
  'quitten'  uit  een  bepaald  programmaonderdeel  van de databank. De
  canceltoets  is  niet  te  veranderen,  omdat  alle databanken ^X als
  cancel waarde accepteren.
  
- Het definieren van vier macro's.
  
- Het definieren van de besturingsstrings voor een Hayes modem.
  
Gebruiksaanwijzing en voorbeelden van configuratie met Mconfig.
==============================================================

Voordat  met de configuratie begonnen wordt is  het verstandig om eerst
een backup te maken van het huidige programma.
Configuratie wordt begonnen met:
	Astrid manual					      Pagina 21


MCONFIG ASTRID <CR>

Het programma meld zich dan met het volgende menu:

CONFIGURATION ASTRID COMMUNICATION PROGRAM
by B. de Bruine (C) xx xxxxx xxxx V2.1


*I* Instructions
*A* show Actual configuration
*C* Configurate for a certain modem/system
*H* change Hayes strings
*M* change Macro strings
*D* change Default parameters
*K* change control-Keys
*Q* Quit to DOS-65
*E* Exit, creating new ASTRID.cfg

                CHOICE [I,A,C,H,M,D,K,Q,E]

Om er in te komen proberen we I(nstructions):

INSTRUCTIONS
============

With * it is possible to skip a part.
Typing <CR> immediately holds the original value.

Input controlcharacters:
a) For control keys only the ascii value must be given.
   f.e: Type M in stead of ^M.
b) In strings a controlchar must be preceeded with
   a '\' mark. f.e: \M = <CR>.


Het programma is opgebouwd uit vijf blokken:
1. Configureren voor een bepaald systeem/modem.
2. Wijzig default parameters.
3. Wijzig speciale toetsen.
4. Wijzig Hayesstrings.
5. Wijzig macrostrings.

Met  "*"  is  het  mogelijk  om  een  blok  over  te  slaan. Wil men de
defaults,  Hayesstrings en macrostrings wijzigen, maar niet de speciale
toetsen,  dan  wordt  een  "*" ingetikt en dat blok wordt overgeslagen.
Wil  men bv. alleen de defaults wijzigen dan kiest men in het menu voor
"D",  en  wordt  alleen dat blok afgehandeld. Keuze "C" is bedoeld voor
configureren  voor de allereerste keer. Hier worden vragen gesteld over
uw  systeem  en  uw  modem.  Aan  de  hand  van uw antwoorden worden de
parameters   berekend  die  noodzakelijk  zijn  voor  uw  configuratie.
Eveneens  worden  alle  andere blokken doorlopen (indien relevant) waar
ook   weer   naar   eigen  wens  veranderingen  aan  te  brengen  zijn.
Wil  men  een  parameter niet veranderen dan moet <CR> ingetikt worden.
	Astrid manual					      Pagina 22


Voorbeeld:
|PROTOCOL |0000 | XMODEM

Kies het protocol waarmee opgestart word:
	A=Ascii
	X=Xmodem
	K=Kermit
	Maak uw keuze [A,X,K] ?

Xmodem is de huidige waarde. Die kan verandert worden door A of K in te
tikken.  Een  <CR> of een X laten het default protocol op Xmodem staan.


Met  keuze "A" kan men alle configuratie mogelijkheden bekijken. Dit is
een  soort luxe hexdump met verklaring. Schrik niet als bv een autodial
vlag  aangeeft dat automatisch bellen niet mogelijk is, terwijl u juist
geprogrammeerd had dat dit wel tot de mogelijkheden behoorde.
Het is heel goed mogelijk dat die vlag voor uw systeemconfiguratie niet
van  belang  is,  en  een dummy waarde aangeeft. "A" wijzigt niets. Het
laat alleen de huidige instelling zien.

Met  "Q"  wordt  MCONFIG  verlaten  zonder dat er een nieuwe Astrid.cfg
gesaved wordt.
Met "E"xit wordt de nieuw Astrid.cfg op disk opgeslagen, geconfigureerd
volgens de gegevens die u ingevoerd heeft.


Toelichting "C"onfiguratie:

Iedere vraag kan beantwoordt worden met een enkele toetsaanslag. bv "1"
voor  de  clockfrequentie  of  "Y"  op  de vraag of er een interspeeder
aanwezig is.   Dus NIET: 1<CR> of Y<CR>!!            <--Fout


CONFIGURATION ASTRID COMMUNICATION PROGRAM
by B. de Bruine (C) 30 may 1987 V2.1


*I* Instructions
*A* show Actual configuration
*C* Configurate for a certain modem/system
*H* change Hayes strings
*M* change Macro strings
*D* change Default parameters
*K* change control-Keys
*Q* Quit to dos-65
*E* Exit, creating new ASTRID.CFG

                CHOICE [I,A,C,H,M,D,K,Q,E]

    ***CONFIGURATION***

What is the clockfrequency of your system ?
CLOCKFREQ:  1,2,3 of 4 MC/S.
[Er kan een keuze gemaakt worden uit bovengenoemde vier waarden.]
Contains your modem an interspeeder ? (Y/N)
[Een interspeeder converteert 75 Bd naar 1200 Bd en vice versa.]
	Astrid manual					      Pagina 23


INTERSPEEDER				SPLIT SPEED
					Is  an  external  receiverclock
					for  the ACIA available ? (Y/N)
					VIA T1 OSC
					EXT. OSC
					[Indien  er geen ext. clock be-
					schikbaar  is,  moet dat clock-
					signaal  van  de VIA  betrokken
					worden. Op PB7 (VIA2) staat dit
					clocksignaal.  Zelf moet men er
					zorg  voor  dragen dat PB7 ver-
					bonden  wordt  met  RxC  van de
					ACIA.  Levert het modem zelf de
					clocksignalen,  dan  kan men de
					vraag bevestigend beantwoorden.
					Er  wordt dan EXT. OSC geprint,
					om aan te geven dat de VIA niet
					als baudrate generator hoeft te
					functioneren.]


Is your modem a Hayes or Hayes compatible modem ? (Y/N)
HAYES MODEM				TRANSPARENT MODEM
Does your  Hayes  modem  need  extra 	Has   your  modem  an  autodial 
initialisation to  set  correct  the	facility   ?   Do  you  have  a 
wordformat  (Y/N)?		 	Bansoft*dialer ?  (Y/N) Support
NO  EXTRA INITIALISATION		your modem RTS-dialing  ? (Y/N)
EXTRA INITIALISATION  [Kunnen gede-	Read  the  manual  for more in-
finieerd worden in de Hayesstrings]	formation about your particular
Do you want  pulsedialing  or tone-	OWN AUTODIALER
dialing ? [P,T,sp] space=default	BANSOFT DIALER
PULSE DIALING				RTS-DIALER 
TONE DIALING				[Hiermee is de dialmethode  ge-
DEFAULT					definieerd. Er zijn dus 3 moge-
[Default  is de dialmethode die het	lijkheden voor tranparant
modem  kent na het opstarten. Mees-     modems.]
tal zal dat pulskiezen zijn.]		

Voorbeeld configuratie:

    ***CONFIGURATION***
What is the clockfrequency of your system ? 1
CLOCKFREQ:  1  MC/S
Contains your modem an interspeeder ? (Y/N) y
INTERSPEEDER
is your modem a Hayes or Hayes compatible modem ? (Y/N) y
HAYES MODEM
Does your Hayes modem need extra initialisation to set
correct the wordformat (Y/N)? y
EXTRA INITIALISATION
Do You want Pulse- or Tonedialing ? [P,T] p
PULSE DIALING
	Astrid manual					      Pagina 24


CURRENT CONFIGURATION:
======================================================
|CLOCK    |0001 | CLOCKFREQ:  1  MC/S
|SPLIT    |00FF | INTERSPEEDER
|HAYES    |0000 | HAYES MODEM
|EXTRA    |0000 | EXTRA INITIALISATION
|EXTOSC   |00FF | VIA T1 OSC
|DIALFLAG |00FF | NO AUTODIALER
|PROTOCOL |0000 | XMODEM
|TIMEFLAG |0000 | SHOW TIME
|ECHO     |00FF | FULL DUPLEX
|ANSORG   |0000 | ORIGINATE
|WORDFOT  |0041 | 8N1
|BAUDPAR  |0004 | 1200/75 BAUD
======================================================
This  means  that   Astrid   now  is  usable  for systems with a clock-
frequency  of  1 mc/s and is configurated for a Hayes modem with inter-
speeder.  Your modem needs EXTRA INITIALISATION for a correct change of
the wordformat. Time is printed.
THE DEFAULTS ARE: XMODEM, FULL DUPLEX, ORIGINATE, 1200/75 BAUD, 8N1. 

Voor meer informatie over automatisch bellen, zie bijlage VI.

Voorbeeld definieren speciale toetsen:

Behalve de macrotoetsen zijn alle andere toetsen controltoetsen.
Deze worden niet als controltoetsen ingevoerd maar als lettertekens. Zo
wordt bv control-N (notatie: ^N) ingevoerd als N.
Het  "^"  teken  wordt  automatisch geprint als er een control karakter
ingevoerd moet worden.
Hieronder staat een lijst met de huidige gedefinieerde toetsen:

CURRENT DEFINED KEYS:
***********************************
CURSOR UP        | ^K | 
CURSOR DOWN      | ^J | 
CURSOR BACK      | ^H | 
CURSOR FORWARD   | ^I | 
BREAK KEY        | ^[ | 
ENTER MACRO KEY  | ^N | 
MACRO KEY 1      |  1 | 
MACRO KEY 2      |  2 | 
MACRO KEY 3      |  3 | 
MACRO KEY 4      |  4 | 
***********************************


Voorbeeld invoeren van tekststrings

Het invoeren van tekststrings wijkt iets af van de andere blokken.
Het is hier niet mogelijk om met een sterretje "*" een blok over te
slaan. Wel kan met een <CR> een string ongewijzigd blijven. Het invoe-
ren van besturingskarakters wijkt ook af. Ieder controlkarakter moet
voorafgegaan worden door een schuin streepje "\". Wil men bv een naam-
string invoeren met CRLF dan zou dat als volgt kunnen gebeuren:
voornaam\Machternaam\M\J
Met <CR> word de string afgesloten en in het geheugen gezet.
	Astrid manual					      Pagina 25


De maximale lengte van de strings zijn opgenomen in onderstaande tabel:
=======================================================================
Stringnaam   Stringlengte	Omschrijving
=======================================================================
Hayes 1	      15 kar. 	 Zet Transmissiesnelheid.
Hayes 2	      15 kar.	 Zet woordformaat op 8N1.
Hayes 3	      15 kar.	 Zet woordformaat op 7E1.
Hayes 4        7 kar.	 Zet modem in originatemode. (AT O of default.)
Hayes 5	       7 kar.    Zet modem in answermode (ATR of ATA (autoans))
Macro 1	      15 kar.	 Vrij te definieren.
Macro 2	      15 kar.	 Vrij te definieren.
Macro 3	      15 kar.	 Vrij te definieren.
Macro 4	      31 kar.	 Vrij te definieren.
=======================================================================

Indien  de  stringlengte  overschreden  wordt volgt een foutmelding. Je
moet  dan  even  wachten,  totdat de te lange string wordt gewist en de
prompt  '>'  verschijnt  om  aan  te  geven dat de string opnieuw inge-
voerd kan worden.

Hieronder een voorbeeld van gedefinieerde tekst strings:

TEXT STRINGS:
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$1 BAUD: AT^M
$2 8N1:  ATS13=0^M
$3 7E1:  ATS13=12^M
$4 ORG:  ^M
$5 ANS:  ATA;^M

MAC1:  user^M
MAC2:  last name^M
MAC3:  password^M
MAC4:  ATDP 04784,2301^M
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

Indien  je  geen Hayes modem hebt hoef je uiteraard de Hayesstrings ook
niet te definieren.



Foutmeldingen:
==============
xxxx not found:             Filenaamfout.   Astrid,  is  niet  geladen.
			    Mogelijk staat het programma op een disk in
 			    een andere drive.
Configuration impossible:   Met  Config V2 zijn alleen de communicatie-
			    programma's  V2.xx te configureren. De con-
			    figuratie  van  de  oudere  versies 1.xx is
			    onmogelijk.
Illegal key:	            Het  is niet toegestaan deze toetswaarde in
                            te voeren.
Same defined keys:          Er  zijn twee speciale toetsen met dezelfde
			    waarde gedefinieerd.
String too long:            De  maximale lengte die een macro of Hayes-
			    string kan bevatten is overschreden.
	Astrid manual					      Pagina 26


Bijlage II: Overzicht configuratievariabelen
********************************************

De configuratievariabelen bepalen met welk modem er gewerkt wordt.
Eveneens laten ze zien wat de defaults (Baudrate, protocol, etc..) zijn
waarmee  opgestart  word.  De  configuratievariabelen  kunnen aangepast
worden met het programma MCONFIG of met de MONitor.

ASTRID V2.2 Configurationpage: $0400-$04FF

0400  41 54 0D 00 00 00 00 00 00 00 00 00 00 00 00 00  AT..............
0410  41 54 53 31 33 3D 30 0D 00 00 00 00 00 00 00 00  ATS13=0.........
0420  41 54 53 31 33 3D 31 32 0D 00 00 00 00 00 00 00  ATS13=12........
0430  0D 00 00 00 00 00 00 00 41 54 41 3B 0D 00 00 00  ........ATA;....
0440  46 69 72 73 74 20 6E 61 6D 65 0D 00 00 00 00 00  First name......
0450  46 61 6D 69 6C 79 2D 6E 61 6D 65 0D 00 00 00 00  Family-name.....
0460  50 61 73 73 77 6F 72 64 0D 00 00 00 00 00 00 00  Password........
0470  4D 61 6E 79 2D 75 73 65 64 2D 73 74 72 69 6E 67  Many-used-string
0480  0D 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................

		;Configuration flags
04B7 20		PUTO	FCC	' '	 ;Pulse- or tonedialing
04C9 01		CLOCK	RES	1,1	 ;Processorspeed 1,2,3 & 4 mhz
04CA FF		SPLIT	RES	1,$FF	 ;Split baud modem 75/1200
04CB 00		HAYES	RES	1,$0	 ;Zero, if smart modem used
04CC 00		EXTRA	RES	1,$00	 ;Autobaud modem initialisation
04CD FF		DIALFLG	RES	1,$FF	 ;Transp. modem: 00=autodial
04CE 00		PROTOCO	RES	1,0	 ;Protocolchoice
04CF 00		TIMFL	RES	1,0	 ;0=update time, <>0 don't
04D0 FF		ECHO	FCB	$FF	 ;Fullduplex = ff {default}
04D1 00		ANSORG	FCB	$0	 ;Originate = 00 {default}
04D2 41		WORDFOT	FCC	'A'	 ;A=8n1, b=7e1 {default}
04D3 04		BAUDPAR	FCB	4	 ;Baudrate {default}
04D6 FF		EXTOSC	RES	1,$FF	 ;00=external ACIA osc (outsid
   		;Ff=via-osc for ACIA (only if split=0)
		;Keycodes menu transfer parameters
04DC 0B		KEYUP	FCB	$0B		;^
04DD 0A		KEYDOW	FCB	$0A		;Lf
04DE 08		KEYBAC	FCB	$08		;Bs
04DF 09		KEYFOR	FCB	$09		;Ht
04E0 1B		KEYBRK	FCB	ESC		;Common breakkey
04E1 17		KEYPUP	FCB	$17		;^w page up
04E2 1A		KEYPDO	FCB	$1A		;^z page down
04E3 000000		RES	3,0		;Futural expansion
		;Keycodes macro expansion
04E6 0E		KEYMAC	FCB	$0E		;^n macro-key (2nd)
04E7 20 3BC0	MKHELP	JSR	PRINT
04EA 31		KEYMAC1	FCC	'1'		;Macro 1
04EB 2C			FCC	','
04EC 32		KEYMAC2	FCC	'2'		;Macro 2
04ED 2C			FCC	','
04EE 33		KEYMAC3	FCC	'3'		;Macro 3
04EF 2C			FCC	','
04F0 34		KEYMAC4	FCC	'4'		;Macro 4
04F1 00			FCB	0
04F2 60			RTS
		;---end configuration page---
	Astrid manual					      Pagina 27


Bijlage III: Lijst met programmeerbare toetsen
**********************************************
04DC 0B		KEYUP	FCB	$0B		;^
04DD 0A		KEYDOW	FCB	$0A		;Lf
04DE 08		KEYBAC	FCB	$08		;Bs
04DF 09		KEYFOR	FCB	$09		;Ht
04E0 1B		KEYBRK	FCB	ESC		;Common breakkey
04E1 17		KEYPUP	FCB	$17		;^w page up
04E2 1A		KEYPDO	FCB	$1A		;^z page down
04E6 0E		KEYMAC	FCB	$0E		;^n macro-key (2nd)
04EA 31		KEYMAC1	FCC	'1'		;Macro 1
04EC 32		KEYMAC2	FCC	'2'		;Macro 2
04EE 33		KEYMAC3	FCC	'3'		;Macro 3
04F0 34		KEYMAC4	FCC	'4'		;Macro 4

Bylage IV: Geheugenindeling.
****************************

Astrid  gebruikt  veel geheugen. Men kan files downloaden met de lengte
van de beschikbare diskcapaciteit. Heeft men een lege 80 Tr DS/DD disk,
dan  is  de  maximale  filelengte 720 kbyte. Files die men wil uploaden
moeten  in  het werkgeheugen passen. D.w.z. dat de file niet groter mag
zijn  dan  ca.  28  kbyte.  Dit is geen beperking, want met de talrijke
DOS-65 utilities kan men een grotere file opsplitsen in kleinere files,
en dan bloksgewijs uploaden.

	Memory map Astrid V2.2
0000 |--------------------------|     0800 |--------------------------|
     |		nu		|          |                          |
     |--------------------------|          |       Tel.dir buffer     |
0090 |				|     1000 |--------------------------|  
     |	  page zero pointers    |          |                          | 
0094 |				|          |       main               |
     |--------------------------|          |         program          |      
     |		nu		|          |       ASTRID *V2.02*     |
0100 |--------------------------|          |                          |
     |				|     3000 |--------------------------|
     |		stack		|          |                          |
     |				|          |                          |
0200 |--------------------------|          |                          |
     |				|          |        storagememory     |
     |	    receiverbuffer	|          |                          |
     |				|          |                          |
0300 |--------------------------|          |                          |
     |				|          |                          |
     |	   transmitterbuffer	|          |                          |
     |				|     9E00 |--------------------------|
0400 |--------------------------|          |  overflowbuffer  (^S)    |
     |	   configuration	|          |     (ascii  only)        |
     |	   variables		|     A000 |--------------------------|
0500 |--------------------------|          |     Helpscreen text      |
     |				|          |     and	              |		
     |				|          |     Autodialer           |
     |		nu		|          |                          |
     |				|     A600 |--------------------------|
     |				|          |          nu              |
0800 |--------------------------|     AA00 |--------------------------|
	Astrid manual                                         Pagina 28


Label table Astrid V2.2: (wijzigingen voorbehouden)
`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'`'
AB        2C63	ACCMD     E735	ACCTL     E734	ACIASR    E131	
ACICMD    E132  ACICTL    E133	ACIINT    18B7	ACK       0006
ACR2      E11B	ADIAL     2693  AHOLD     1074	AKEY      144A	
ANSO      1A6B	ANSORG    04D1	AREG      E130  ARX       2E62	
ASAVE     1056	ASCBRK1   23FE	ASCBRK2   25C9	ASCHECK   2224
ASCOHEX   1043	ASCREC    1015	ASCSEND   1018	ASCSTOR   2E73	
ASCTEST   22B8  ASCUP     2F1F	ASTRID    A000	ATD       04B4	
AUTREV    04D9	AYS       20C4  BANDIAL   A1F1	BAUD      104E	
BAUDPAR   04D3	BAUDTAB   1A65	BBDIAL    A181  BEEP      1B2D	
BEGHI     0030	BEGLO     0000	BLCALC    250A	BLKS      2B41
BLOCKNR   2A5D	BLOCO     2A5E	BRAAK     2CDD	BRCHECK   15EC	
BREAK     104C  BRKINFO   25AF	BRKMENU   25C5	BRKTEST   2E5A	
BRKTIM    2AC0	BUFIN     C029  BYEXT     1040	BYHI      103F	
BYLO      103E	BYTES     2213	CACHE     1818  CAN       0018	
CANC      2CC6	CANFLG    104D	CAPITAL   005F	CDELAY    107A
CDT2H     00F4	CDT2L     0024	CFG1      04D4	CFG2      04D5	
CHECK     1800  CHOICE    132D	CHRGEN    04D7	CHSUM     2A5F	
CKEY      149B	CL1       10AE  CL2       10B3	CL3       10B8	
CL4       10BD	CLEAR21   1B6A	CLEAR23   1B77  CLOCK     04C9	
CLODI     2108	CLOSE     D048	CLOTEL    28C4	CLR       1B56
CLR23     1B64	CLRSTAT   F01B	CLS       1BB7	CLSEC     E718	
CLSTAT    1BC0  CLSTCON   CA2A	CLT       1055	COMBEEP   270E	
COMEM     2E18	COMHAND   2711  COMPLEE   2BF7	CONDIS    0080	
CONEN     0081	CONTR     103C	CONTUP    150D  COPNUM    2916	
CR        000D	CRCO      17EB	CRCOUNT   10A3	CREATE    D036
CREDI     214E	CRFLG     107D	CRLF      C02F	CRTCAR    E140	
CRTCRF    E141  CURLOAD   1B3F	CUROFF    1B9C	CURON     1B97	
CURPX     E704	CURPY     E705  CURSAVE   1B32	CURUP     1B8D	
DCLO      21E2	DDRB      E112	DECTXT    288C  DEL100    A317	
DEL1600   A320	DEL40     A30E	DEL60     A2E8	DELAY     1079
DELVAL    10C6	DELX      A2EE	DESTROY   10AB	DH0       1067	
DIACOM    A363  DIALBUF   04B8	DIALFLG   04CD	DIAPRES   A32F	
DIERR     10AD	DISDLY    1B0B  DKEY      1549	DLOOP     2941	
DLYINT    18FD	DLYINT1   1916	DM0       1066  DOS       1071	
DOSBUF    AA00	DOSCOM    C006	DOSDEF    19FF	DOSKEYI   CB3E
DOSMSIO   18AB	DREAD     D01B	DTRDIS    00FE	DTREN     0005	
DTROFF    1883  DTRON     1878	ECHO      04D0	EFNAME    201F	
EKEY      15F8	EMPTY     2C39  EMPTYM    106A	EN2       1844	
ENDFILE   229F	ENDMEM    009E	ENTER     25E2  EOF       0004	
EOT       0004	EPAR      0064	ERENTRY   2C45	ERMES     D0B7
ERR       A1BE	ERR1      A1C6	ERRDI     A195	ERRORCT   2A62	
ESC       001B  EXECBRK   1958	EXECMAC   1D18	EXSHOW    1E00	
EXSTRI    1070	EXTOSC    04D6  EXTRA     04CC	FACK      2D51	
FF        000C	FIFORM    1069	FIIF      24B2  FILENR    103B	
FINISH    1073	FLL       1041	FNAM      206D	FNAM1     2068
FNAME     200F	FNPNT     103A	FORDOWN   1CD4	FREMODE   00C0	
GET       191F  GETBUF    C02C	GETEV     F009	GETKEY    1935	
GETMOD    1857	GETNAM    20C3  GKEY      17B7	GMOD      17DE	
H0        105F	HALFBL    106D	HAST      1A7C  HAYDIAL   A1E2	
HAYES     04CB	HAYSTR    0400	HDEL      A2F8	HELP      A007
HEXDEC    C044	HEXOUT    C038	HKEY      13D4	HLOOP     1C4A	
HNOUT     C035  HOCAL     1CA2	HOME      1B88	HOUCON    1C5C	
HOUR      1064	HOURS     E782  HT        0009	IER2      E11E	
IGET      1009	IN        C020	INCMEM    231F  INCPOI    22F6	
INCREM    2308	INCTXT    287E	INIVDU    F12C	INTV15    E76C
	Astrid manual                                         Pagina 29


INTV6     E75A	INTV9     E760	INVALID   1794	INVVID    1BB0	
IRQKEY    189F  ISNAK     2D1C	ISWAP     112E	KBRK      18A4	
KERREC    101B	KERSEND   101E  KEYBAC    04DE	KEYBRK    04E0	
KEYBUF    E7B8	KEYDOW    04DD	KEYFOR    04DF  KEYMAC    04E6	
KEYMAC1   04EA	KEYMAC2   04EC	KEYMAC3   04EE	KEYMAC4   04F0
KEYPDO    04E2	KEYPNT    E7B7	KEYPORT   E101	KEYPUP    04E1	
KEYUP     04DC  LASTCLR   1B53	LASTIME   100C	LASTLIN   1B4B	
LEMPTY    226F	LER       1502  LF        000A	LFCONV    107E	
LFMES     267E	LHAST     1A7F	LHOUR     105C  LIN       10A7	
LIN23     1B5C	LKEY      1418	LMINU     105D	LOAD      218A
LOADIT    14CA	LOADTIM   1D0B	LOADXY    1951	LOCFG     107F	
LOOPBCK   2C1D  LOTI2     190B	LOTRAN    177A	LSETEMP   227D	
LSLEEP    003C	M0        105E  MACERR    2606	MACHELP   265B	
MACIND    1077	MACRO     1076	MAINMEN   1234  MARK      2A27	
MARKB     2A08	MARKF     2A21	MARKF1    2A1E	MATCH1    1CA0
MATCHH    1C76	MAXERR    000A	MAXTRAN   00FF	MC1       0440	
MC2       0450  MC3       0460	MC4       0470	MEM       0090	
MEMPTY    2258	MEMSEND   2F2F  MESEMPT   2286	MESFULL   2337	
MESSAGE   29A2	MICAL     1C7B	MIN       1061  MINCON    1C95	
MINLOOP   1C83	MINUTES   E783	MKEY      13FD	MKHELP    04E7
MM        15E4	MOCOM     104F	MOCTR     1050	MODET2    00E3	
MOFF      188E  MON       1897	MONIT     04D8	MOUT      2A38	
MYDI      A371	NAK       0015  NAMB      ABE0	NAMDEF    D122	
NBUF      1026	NEW       1221	NEWNR1    A1FF  NEXPAG    2848	
NKEY      1404	NNR       A1F9	NONAM     207E	NONU      2621
NOPAR     0005	NORVID    1BA9	NOTASC    2253	NR1       A188	
NWNR1     A270  OEF       2A66	OKEY      140B	OLDMEM    2E4F	
OOM       106B	OPEN      D03F  OPENTEL   28A6	OPT1      1F9C	
OPT1200   1F2E	OPT2      1FA4	OPT2400   1F20  OPT300    1F3C	
OPT5      1F70	OPT6      1F75	OPT7      1F7A	OPT75     1F4A
OPT8      1F7F	OPTANS    1FCD	OPTASC    1E83	OPTDIAL   1EF2	
OPTDOWN   1EC0  OPTE      1F84	OPTEMFN   1FD8	OPTFN     1FE8	
OPTFULL   1FAC	OPTHALF   1FB7  OPTKER    1E95	OPTMEN    1F0B	
OPTN      1F94	OPTNR     1F66	OPTO      1F8C  OPTORG    1FC2	
OPTTER    1EA7	OPTTIME   1E44	OPTUP     1ED9	OPTX      1E71
OPTXXXX   1F58	OSC       1ABB	OSCEN     107B	OSCOFF    1ADE	
OUT       C023  OUTCTR    C0CC	OUTIO     F000	OWNDIAL   A367	
OWNKEY    197C	P2        15CD  P3        15D7	PAGE      10A8	
PARCHO    19A9	PARPROG   1006	PFULL     26F1  PKEY      157B	
PO15.25   1E04	PO24.25   1E0C	PO37.25   1E14	PO43.25   1E1C
PO48.25   1E24	PO52.25   1E34	PO55.25   1E3C	PO73.25   1E2C	
POI       0092  POSIC     F024	PRIHOUR   1BF9	PRIMIN    1C26	
PRINT     C03B	PRISEC    1C13  PRITEL    26DA	PRLOC     2AB5	
PRLOCO    2A75	PRNIBL    FF76	PROGAC    1AA6  PROTOCO   04CE	
PROVIA    1AD7	PRREM     2AA9	PRTIO     2A68	PRUCB     2A8D
PTIME     1CED	PURGE     2E47	PUTO      04B7	PXIT      298E	
PXIT1     296E  QCHECK    15F1	QKEY      167B	QUE       1867	
RCANC     2DEB	READ      2C33  READBUF   2C2E	READBYT   2C2B	
RECBUF    0200	RECPNT    1024	REPO      F027  RESPONS   1B1D	
RESTART   10AC	RESTORE   199B	RESTORF   19A0	RESTORT   19A4
RETU      1B92	RKEY      148C	RS232     17A9	RTSDIAL   A262	
RTSEN     0004  RTSHI     A2D2	RTSLO     A2DD	RX        2B15	
S8N1      1A0D	SACIINT   1048  SATRAN    16CB	SAVE      20FE	
SAVETIM   1CFE	SAVEXY    194A	SCAN1     28D6  SCANKEY   1362	
SCANX     26C2	SCREEN    17FD	SCURPX    1053	SCURPY    1054
SDLYINT   104A	SEAMARK   2A0E	SECONDS   E784	SEL1      29CB	
SEL2      29CF  SEL3      29D3	SEL4      29DA	SELECT    26C5	
	Astrid manual                                         Pagina 30


SELEX     2911	SELEX1    290E  SEMI      2DF5	SEN2      1003	
SET       198D	SETASC    1991	SETCUR    1B9F  SETDLY    1AF1	
SETEMP    2266	SETKER    1996	SETMEM    22ED	SETPOI    22E2
SETPROT   15C2	SETTIM    1BCC	SETTXT    2873	SETUP     2E09	
SETX      198B  SHO12     2385	SHO24     236C	SHO3      23A8	
SHO75     23CE	SHOAN     2416  SHODOS    23E5	SHOFU     235A	
SHOHA     2363	SHOIT     2434	SHONO     239E  SHOOR     2408	
SHOPAR    23C4	SHOUR     1065	SHOWOPT   1D43	SKEYMAC   107C
SLEEP     000A	SLEEP1    0002	SLPTIM    2A64	SMEM      2A60	
SMIN      1062  SOH       0001	SOPT      C068	SORRY     263F	
SPAGE     10A9	SPLIT     04CA  SPRO      1D4A	SREAD     D000	
SSTATOG   1051	STAR      25D5	START     10E1  STARX     25D7	
STATOG    E701	STATUS    D063	STELTXT   10A5	STIMFL    1072
STOPRXC   003F	STOPS     2EE6	STORAGE   1052	STORTEL   28D0	
STRAN     1044  STTOTE    2A52	SUM       2BD4	SUSPEND   1075	
SWAP      1639	SYSKEY    196B  SYSSTAT   F021	T1200     01A1	
T12001    01A0	T12002    0341	T12003    04E2  T12004    0683	
T19K2     001A	T19K21    0019	T19K22    0033	T19K23    004D
T19K24    0067	T1CH      E115	T1CHL     E117	T1CL      E114	
T1CLL     E116  T2CH      E119	T2CL      E118	TELBEG    0800	
TELCLOS   10AA	TELEND    1000  TELFINR   10A4	TELINFO   29BD	
TELNAME   1099	TELTXT    0094	TEMP      0096  TERM      14A2	
TERMI     179A	TETOST    2A47	TH0       1063	TIM12H    10C5
TIM12L    10C4	TIM1H     106F	TIM1L     106E	TIM75H    10C3	
TIM75L    10C2  TIMECT    2A63	TIMELAP   17A0	TIMEX     1C39	
TIMFL     04CF	TKEY      16C2  TM0       1060	TOBAD     2DE1	
TOBIG     1042	TODIS     2EF5	TOLAR     2208  TOUTFLG   E738	
TOUTIL    E772	TOUTL     E774	TPA       16C9	TRANBUF   0300
TRANMOV   18E7	TRANPNT   1025	TRANSAV   2A67	TRANSMT   18CC	
TRAPA     234C  TRASH     1708	TRCOM     2D42	TRLOOP    170E	
TRY1      1068	TX        2D2D  UDO       2A65	UKEY      14C3	
UNMARK    2A3C	UPA       106C	UPBLOCK   2E2D  UPCAN     2E00	
UPDATE    2C12	UPTIM     1BDB	USRSTAT   F01E	VERSION   1399
VIA2      E110	VIAVRA    E71B	VIDEO20   FB2C	VIEW      15DA	
VINDIC    139F  VISUAL    1CA5	VT        000B	WAI       0002	
WAIT2     1B22	WORDFOT   04D2  WRIDI     2160	WRITE     D024	
XBREAK    2C8B	XOFF      0013	XON       0011  XONOFF    2F63	
XREC      100F	XRX       2AE4	XSAVE     1057	XSEND     1012
XTEMP     1059	XTEMP2    105A	XTEMP3    105B	XTX       2CF0	
YESASC    224D  YHAST     1078	YO        2002	YSAVE     1058
	Astrid manual                                         Pagina 31


Bijlage V: Automatisch bellen
*****************************

Veel modems hebben de mogelijkheid om automatisch te kunnen bellen. Dit
houd  in  dat  een  modem  een relais (pulskiezen) of een toongenerator
(toonkiezen)  heeft die bestuurd kan worden met de computer. Alleen bij
Hayes  modems  is  sprake  van  standaardisatie.  Ieder Hayes modem kan
bestuurd  worden  met  dezelfde  codes om het modem een nummer te laten
'draaien'.  Vele  andere  modems  bezitten  ook een autodial optie maar
meestal  moet  die  met  speciale  software  ondersteund worden. Astrid
ondersteund  alle  mogelijke  vormen van autodial, onder te verdelen in
vier groepen:

1. Hayes dialer.
2. RTS dialer.
3. Bansoft dialer.
4. Andere dialer.

ad 1: Hayes dialer
Ieder  Hayes  modem  bezit  standaard  een  dialer. Zodra de keuze voor
Hayesmodem  gemaakt  is, is ook meteen de autodialfunctie gedefinieerd.
Met MCONFIG kan men instellen of men puls- of toonkiezen wenst.

ad 2: RTS dialer.
Sommige  modems  bezitten een lijnrelais dat te bedienen is via het RTS
{Request To Send} signaal van de RS232. Dit relais schakelt in overeen-
stemming met de aangeboden pulsen, en kan dus een nummer kiezen.

ad 3: Bansoft dialer.
Het  betreft hier een zelfbouw dialer die toegevoegd kan worden aan een
bestaand  modem die geen autodial mogelijkheid bezit. De hardware staat
beschreven in de Elektuur halfgeleidergids van 1986. (pag 79,
schakelingnr.  29)  en  moet  aangesloten worden op uw computer met een
verbinding  van  PB5  (VIA  2) naar dial-in van de elektuur schakeling.
PB6  wordt  gebruikt  om het modem op/van de telefoonlijn te schakelen.
De  software  voor  deze  schakeling  is  ontwikkeld  door  Bansoft uit
Enschede, en is een onderdeel van het Astridprogramma.

ad 4: Andere dialer.
Dit  vergt  enige  zelfwerkzaamheid  van  de gebruiker. U zult zelf een
programmaatje moeten maken dat de autodialer van uw modem kan besturen.
Het  meeste  werk is echter al gedaan. Het enige wat u hoeft te doen is
het  lezen van het geselecteerde nummer uit DIALBUF en dat om te zetten
naar  geschikte  signalen  die  dan  via  een VIA uitgang naar uw modem
gestuurd  worden.  De  syntax  van  de data opgeslagen in DIALBUF is de
volgende: kkk,aaa\0
met kkk = kengetal (ascii)
      , = pauzeteken (ascii)
    aaa = abonneenummer (ascii)
     \0 = einde string teken ($00)

Voorbeeld: 01180-34336 staat in dialbuf in hex als:
DIALBUF: 30,31,31,38,30,2C,33,34,33,33,36,00
[Let op: Scheidingsteken is een komma!]
	Astrid manual                                         Pagina 32


Het  programma  moet  beginnen  op adres OWNDIAL+3 met de volgend data:

	ORG	OWNDIAL+3

	JMP	MYDIALER
	FCC	'DIAL'
MYDIALER ....werkelijke programma....

Beschikbare geheugenruimte: OWNDIAL+3 - $A9FF.
De  adressen  van  DIALBUF,  OWNDIAL,  e.a.  vind  u  in de labeltabel.
(bijl.  V)  Meestal zal een dergelijke dialer met een pulstrein conform
het te draaien nummer bestuurd moeten worden.
Het  aantal  pulsen komt overeen met het getal dat men wil draaien. Het
getal nul bestaat uit tien pulsen. Een puls moet 60 millisec lang zijn.
(contact  geopend)  Tussen  twee  onderbrekingen in moet het contact 40
milliseconden gesloten zijn.

Wil men een modem on-/offline schakelen dan kan men daarvoor de volgen-
de subroutines gebruiken:
DTRON	Activeert RS232-lijn DTR (+12V)
DTROFF	Maakt de RS232-lijn DTR inactief (-12V)
MON	Maakt PB6-VIA2 actief (TTL 0V)
MOFF	Maakt PB6-VIA2 inactief (TTL +5V)
Het verdiend aanbeveling om eerst goed te bekijken of de software beho-
rende bij de RTS/bansoft dialer ook geschikt is voor uw modem.

Het maken van een file met telefoonnummers voor autodial
--------------------------------------------------------
Met ED kan men een file maken waarin de telefoonnummers van databanken,
medehobbyisten met een modem, e.d. in opgenomen kunnen worden.
De file MOET Tel.dir heten, en moet als volgt opgebouwd worden:
a - Voor ieder telefoonnummer zijn max. 80 karakters beschikbaar.
    (1 regel op het scherm)
b - De syntax van een regel is:
    XYZ kkk-aaa ;Commentaar <CR>
    met X = Baudrate parameter. (moet in kolom 1 staan)
        Y = woordformaat. (moet in kolom 2 staan)
        Z = protocol. (moet in kolom 3 staan)
      kkk = het kengetal.
        - = scheidingsteken/pauze teken. (minteken)
      aaa = het abonneenummer.
        ; = commentmarker, geeft aan dat er commentaar komt.
    
c - Lege regels mogen niet voorkomen.
d - Er is geen speciaal file-sluitteken nodig.
e - Spaties en tabs mogen na kolom 3 geplaatst worden.
   
Hoewel  het  mogelijk  is de file Tel.dir zo uitgebreid te maken tot de
maximale  capaciteit van een diskette, verdiend het aanbeveling om max.
255  pagina's op te slaan. (dat zijn 5000 nummers) De paginateller telt
namelijk maar tot 255 en begint dan weer bij nul. In de praktijk zullen
een a twee pagina's al voldoende zijn.
	Astrid manual                                         Pagina 33


*****************************************************************
* Baudrateparam:    *	Woordformaat:	*	Protokol:	*
*****************************************************************
*  X=1: 2400/2400   *	Y=A: 8N1	*	Z=A: Ascii	*
*  X=2: 1200/1200   *	Y=B: 7E1	*	Z=X: Xmodem	*
*  X=3:  300/300    *	Geen betekenis	*	Z=K: Kermit	*
*  X=4: 1200/75	    *	als X=5.	*	Z=U: Unchanged	*
*  X=5: dos def.    *			*			*
*****************************************************************
Z=U bied de mogelijkheid om het protocol te laten zoals hij was voordat
de autodialer aangeroepen werd.

Voorbeeld van Tel.dir:
4AA 01180-34336 ;FIDO M'BURG
3AX 01180-34336 ;FIDO M'BURG
4AA 05490-62542 ;FIDO ALMELO
5AA 04755-2041 ;FIDO SITTARD
3AX 04755-2041 ;FIDO SITTARD
4AA 04784-2301 ;FIDO GERARD SNOEK I (Banser)
4AA 020-978493 ;GAASPERDAM 24H
4AA 01131-2715 ;FIDO EDDYSOFT (Eddy van Loo : C programma's)
4AA 033-17193  ;Ainex amersfoort Arjen Lentz 22-08
4AA 015-145697 ;BBC_BBS 24H
4AA 02523-76016 ;Gremlin
4AA 020-880622 ;BEEBANK 21-09
3AA 01100-23689 ;BBS De bevelander
3AA 010-52271 ;Erasmus universiteit Rotterdam
4AA 033-755444 ;FIDO AMERSFOORT
4AA 020-154154 ;FIDO AMSTERDAM
4AA 085-430608 ;FIDO ARNHEM
4AA 074-423860 ;CPM GG
4AA 02290-34046 ;FIDO HOORN (MON 68000)

Overwegingen samenstelling Tel.dir
----------------------------------
Het  minteken  is het pauzeteken. Er wordt dan even gewacht voordat het
abonneenummer   gedraait   word.  Voor  nationale  verbindingen  zal  1
pauzeteken  in  alle gevallen voldoen. Is het noodzakelijk om langer te
wachten,  dan  kan  dat  door  meerdere  pauzetekens  op te nemen in de
string. Bijvoorbeeld: 01180---34336. Er wordt nu 3 keer zolang gewacht.

Hoewel het op het eerste gezicht aantrekkelijk lijkt om een alfabetisch
geordende  lijst  samentestellen,  blijkt  in  de praktijk toch dat men
beter  de  meestgebruikte  nummers  op pagina 1 (eerste 20) kan zetten.
Dit  bespaard  veel  zoekwerk,  en  de  hele  file  Tel.dir  hoeft niet
doorgebladert te worden.
Heeft  men  een 300/300 en 1200/75 modem dan is het aantrekkelijk om te
downloaden  met  1200  Baud  en  te  uploaden  met  300  Baud. Neem het
telefoonnummer dan dubbel op in Tel.dir, met beide baudrates.
	Astrid manual                                         Pagina 34


Bijlage VI: RS232
*****************

Aansluitmogelijkheden:

uC			modem

a) Volledige implementatie

2            TXD-->        2
----------------------------
3            RXD<--	   3
----------------------------
20           DTR-->	  20
----------------------------
6            DSR<--	   6
----------------------------
4            RTS-->	   4
----------------------------
5            CTS<--	   5
----------------------------
8            DCD<--	   8
----------------------------
7            GND	   7
----------------------------


b) geen besturingssignalen

2            TXD-->        2
----------------------------
3            RXD<--	   3
----------------------------
20 DTR
--------|
6  DSR  |
--------|
4  RTS
--------|
5  CTS  |
--------|
8            DCD<--	   8
----------------------------
7            GND	   7
----------------------------


c) voor smartmodems (Hayes-compatibles)

2            TXD-->        2
----------------------------
3            RXD<--	   3
----------------------------
4            RTS-->	   4 Mag ik (uC) zenden ?
----------------------------
5            CTS<--	   5 Modem is klaar om te gaan zenden
----------------------------
	Astrid manual                                         Pagina 35


6            DSR<--	   6 Dataset(=modem) ready 
                                  (dwz actief na power up)
----------------------------
7            GND	   7
----------------------------
8 DCD			     Altijd carrier detect als terminal=ready
-----|
20   |       DTR-->	  20 Terminal (uC) is klaar om te communiceren
-----|----------------------
22          RING<--	  22 Binnenkomend telefoontje (AA)
----------------------------

***> !Bij een MODEM mogen RxD en TxD elkaar NOOIT kruisen! <***

Aansluitmethode  c)  verdient  enige  toelichting.  Intelligente modems
geven  foutmeldingen  en  andere  meldingen,  zoals  CONNECT 1200 Baud,
CARRIER DETECT, NO CARRIER, ERROR-COMMAND, etc. De RS232 ontvanger (uC)
accepteert  alleen  data  als DCD actief is. Bij een foutmelding is dit
meestal  niet  het  geval. Vandaar dat DTR (of indien die niet gebruikt
wordt  RTS)  verbonden  moet  worden  met DCD. Bij sommige intelligente
modems  kan  men  methode a) aanhouden omdat die DCD activeren, als het
modem  iets  wil  verzenden via de RS232. (meestal schakelbaar met dip-
switch  op het modem) De software van het communicatieprogramma moet er
voor  zorgen  dat  dergelijke  foutmeldingen niet in het geheugen of op
schijf  komen.  Hoewel  DOS-65 niet voorschrijft of men een male of een
female  D-connector  moet gebruiken, is het aan te bevelen om de RS232c
male,  en  de andere (keyboard, centronics) female te nemen. Er kan dan
nooit  abusievelijk  +12V  of  -12V  op TTL apparatuur komen. Bovendien
hebben  zowel  de IBM-PC als de ATARI-ST een 25 polige male D-connector
als  modemaansluiting.  Heeft  men nu net een female gemonteerd, dan is
dat  ook geen probleem, want genderchangers (f/f, m/m) kan men ook heel
goed kopen op de HCCdagen. Een modem heeft altijd een female connector.

Bijlage VII: Foutmeldingen en waarschuwingen.
*********************************************

* Algemene foutmeldingen:
NOT IMPLEMENTED: Utiliteitsprogramma bestaat niet.
MACRO ERROR:     Verkeerde  macrotoets ingedrukt, macro bestaat niet of
                 de macro is leeg.

* Foutmeldingen disk i/o:
ASTRID.CFG NOT FOUND: File  niet  aanwezig op de systeemdrive S. Dit is
                      de  enige  fout  die  tot  gevolg  heeft dat naar
		      DOS-65 wordt teruggekeert.
TEL.DIR NOT FOUND:    File niet aanwezig op drive S.
FILENAME TOO LONG:    Een   filenaam  mag  uit  maximaal  15  karakters
		      bestaan.
FILENAME NEEDED:      Er moet een filenaam ingevoerd worden.
FILE TOO LARGE:       File  is  te  groot om in het geheugen te zetten.
DISK FULL:            De diskette is vol. Downloading wordt voortgezet.
                      Als  de file in het werkgeheugen past, kan men de
                      data met het doscommando "SAVE" naderhand op disk
                      zetten.  Is  het een file die niet in het werkge-
                      heugen past, dan moet men het downloaden afbreken.
DRIVE x NOT READY:    Boot uw systeem opnieuw op. Save de gedownloade
                      data vanuit DOS-65.
	Astrid manual                                         Pagina 36

* Foutmeldingen up/download algemeen:
FILE NOT ASCII: Als men een hexfile met het asciiprotocol wil uploaden.
MEMORY  EMPTY:    Indien  men wil uploaden, en er is geen file geladen.
TIMEOUT  ERROR:   Lijn is dood, host is op tilt of reageert niet binnen
        	een vastgesteld tijdsinterval.

* Foutmeldingen Xmodem:
NOT SOH: 			    Een  blok  wordt  niet voorafgegaan
				    door een correcte header.
BLOCKCOUNTS NOT EQUAL: 		    Er  wordt  een ander blok ontvangen
				    als verwacht werd.
WRONG BLOCKNUMBER:                  Het  complementbloknummer  is  ver-
				    keerd.
BAD CHECKSUM:                       Het berekende controlebyte klopt
 				    niet met het ontvangen controlebyte.
TOO MANY XMODEM ERRORS ...ABORTING: Als  een  van  bovenvermelde fouten
				    optreed,  word nog tien keer gepro-
				    beert  of  het  alsnog  wil lukken.
				    Lukt het dan nog niet dan wordt het
				    Xmodemproces afgebroken.

* Foutmeldingen dialer:
NUMBER TOO LONG:        Een  telefoonnummer  mag max. 17 karakters lang
			zijn.
INPUT ERROR:            Het telefoonnummer bestaat uit vreemde symbolen.
DIAL ERROR:             Incorrect  nummer/parameters.  Bellen  is  niet
			mogelijk. Deze fout komt voor indien in Tel.dir
			niet   de  voorgeschreven  kolomindeling  wordt
			aangehouden.
S:TEL.DIR NOT FOUND:    File niet aanwezig op drive S.
NO NUMBER SELECTED:     Er is geen telefoonnummer gekozen.
OWN DIALER NOT PRESENT: Autodial faciliteit niet aanwezig.

* Waarschuwingen en meldingen:
MEMORY FULL: 		  Werkgeheugen  is  vol. Na deze melding zal de
			  data  die  zich  in  het  werkgeheugen bevind
			  automatisch  op disk gezet worden, waarna het
			  werkgeheugen  weer  te  gebruiken  is.  (gaat
			  automatisch)
CANCEL, CANCELED BY, 
TRANSFER TERMINATED: 	   Na  het geven van een cancelopdracht door de
                          remote  of  de  local  is  de  dataoverdracht
			  gestaakt.
XOFF SENDED: 		  Warning  die voorkomt bij het ascii protocol,
			  als de host even moet stoppen met zenden.
XON SENDED: 		  Geeft  aan  dat de host weer mag gaan zenden.
			  Bovengenoemde meldingen vereisen geen ingreep
			  van  de  operator.  Alles  wordt  automatisch
                          afgehandeld.
WAITING FOR NAK TO START: Het  Xmodem  uploadproces moet gestart worden
			  door  de  remote met een NAKteken. Zolang dit
                          NAKteken  niet  ontvangen is zal deze melding
                          verschijnen.  Komt  de  NAK  niet  binnen een
			  vastgestelde  tijd  dan  treed er een TIMEOUT
			  error op.
BLOCKNR. XX:              Geeft aan welk blok er geladen/verzonden word.
UP/DOWNLOADING COMPLETED: Up/download is beeindigt.

	Astrid manual                                         Pagina 37


Bijlage VIII: Verschillen Astrid v1.0 met Astrid v2.0
*****************************************************

- Viditel  is  niet  meer  opgenomen  in  v2.0, maar als aparte utility
  uitgevoerd.
- De  codes  voor  de  transferparameters  zijn  gewijzigd,  ook  in de
  autodial  file.  Om  dit  verschil  aan  te  geven  is de naam van de
  'telefoonboek' file gewijzigd in tel.dir.
- Load/save  zijn  verwijdert.  Bij een transfer-error wordt nu in alle
  gevallen het deel dat ontvangen is naar disk geschreven.
- memorymap is gewijzigd.
- Het interspeeder delay wordt automatisch ingeschakeld indien geconfi-
  gureerd voor interspeeder als men op 1200/75 Baud werkt.
- Met  Answer/originate  wordt  de  receiversnelheid omgewisseld met de
  transmittersnelheid
- De  clocksignalen  voor splitspeed levert VIA2 op PB7 !! (was CB1 bij
  v1.0)
- Met een (1) breaktoets kan men alles breken.

 Astrid V2.1:
---------------------------
- Bug laad .cfg file ge-elimineert.
- DTR  blijft  in de gedefinieerde toestand na een "C" of "O" kommando.
- Redial is nu mogelijk met het R-commando
- Indien  een  nummer niet voorkomt in Tel.dir, kan men het zelf intik-
  ken. Hiervoor is het ^M commando gecreeerd in de autodialmode.
- Zowel puls als toonkiezen is mogelijk voor Hayesmodems.
- Macro's kunnen uitsluitend gedefinieerd worden met Mconfig.
- In  tegenstelling  met  V2.0 waar alleen de laatste 2 bits vergeleken
  werden  met  de macrokeuzetoets, wordt nu een volledige 8 bits verge-
  lijking uitgevoerd.
- Bug "rare videoeffecten" verwijdert. (nieuwe consoleroutines)
- Bug  split  speed initialisatie verwijdert. Het datadirectionregister
  staat nu goed geprogrammeerd, zodat PB5,6,7 nu inderdaad functioneren
  zoals beschreven, dit betekend: - Autodial met Elektuurdialer
  				  - PB6 volgt DTR
				  - Clocksignalen op PB7

 Astrid V2.2
 ---------------------
- Foutmeldingen  autodialer  bij verkeerde input, afkomstig uit file of
  toetsenbord.
- Bansoft dialer werkt nu ook goed.
- RTSdialer toegevoegd.

Bijlage IX: Specificaties
*************************

- Werkt op systemen met een clockfrequentie van 1,2,3 of 4 Mhz.
- programmeerbaar voor iedere baudrate tussen 50 en 19.200 Baud.
- Full- en Halfduplex.
- Vijf voorgeprogrammeerde baudrates.
- Clocksignalen voor split-speed 1200 Bd en 75 Bd beschikbaar.
  (19.200 Hz en 1200 Hz op PB7 VIA 2)
- Interspeeder delay 1200/75: 125 msec.
- Terminalemulatie.
- Xmodem, Ascii en Kermit* (alleen v3.0) datatransferprotocollen.
	Astrid manual                                         Pagina 38


- responsetijd intelligent modem: 2 sec.
- Geen handshake met RTS/CTS noodzakelijk.
- Answer/Originate-schakelen  met  RTS wordt niet ondersteund. A/O gaat
  conform het hayes protokol of moet manueel op het modem gebeuren.

BIJLAGE X: Commandotabel.
*************************

Mainmode:
=========
H = Help
M = Print main menu
N = New
C = Go in terminalmode
O = On hook (disconnect)
A = Enter Autodialer
T = Set Transferparameters
P = Select communication protocol
D = Download
U = Upload
L = Enable/disable Linefeedconversion when uploading ascii-files
R = Redial the last selected number
Q = Quit, restartable with G 1000
E = Exit definitely

Terminalmode:
=============
^[ = To mainmode
^N1,2,3,4 = Execute a macro

UDOmode:
========
^X = To terminalmode (cancel up/downloading)
^[ = To mainmode

AUTODIALER:
===========
^K = To previous number,
^L = To next number,
^W = To previous page,
^Z = To next page,
sp = Dial the marked number,
^M