




;FILE LKSN/20/DIA/E
;LK/18 MET RS232 KEYBOARD
;PROGRAMMA VOOR DE LICHTKRANT
;VOOR NIEUWE LK, AANGEGEVEN MET [TR]
*=0
NRB=6 ;AANTAL BORDJES
BPR=18 ;3XAANTAL BORDJES
NRBYTE=126 ;7XBPR
STOT=$200
FIFO=$100 ;TOT $17F
RBC *=*+1 ;ROW BYTE COUNTER
ROC *=*+1 ;ROW COUNTER
BTC *=*+1 ;BYTE COUNTER
BOC *=*+1 ;BOARD COUNTER
SHCE *=*+1 ;SHIFT COUNTER EN@BLE
SHC *=*+1 ;SHIFT COUNTER
SHE *=*+1 ;SHIFT ENABLE
SHEN *=*+1 ;SHIFT ENABLE 2
REN *=*+1 ;RESET ENABLE
NKEN *=*+1 ;NIEUW KARAKTER ENABLE
SNRC *=*+1 ;SERIENUMMER COUNTER
SAVA *=*+1
SAVX *=*+1
SAVY *=*+1
KNE *=*+1 ;KNIPPER ENABLE
PRG *=*+1 ;PROGRAMMA
TIMCO *=*+1
MSEC *=*+1
SECOND *=*+2
MIN *=*+4
SET1 *=*+4
SET2 *=*+4
SET3 *=*+4
SET4 *=*+4
TIMIND *=*+2
BUF *=*+4
CHIND *=*+2
STOIND *=*+2 ;START OF TEKST
SPC *=*+1 ;SPEC.COUNT
SETIND *=*+2
SETFLG *=*+1
DPL *=*+1
DPH *=*+1
IND *=*+1 ;INPUT DISABLE
TEL *=*+2 ;TELLER VOOR WAIT
KP *=*+2 ;KARAKTER POINTER
SAVKP *=*+2 ;SAVE KARAKTER POINTER
MP *=*+2 ;MEMORY POINTER
LST *=*+8 ;LAST KARAKTER
LSTIND *=*+2
KARM *=*+7 ;KARAKTER MEMORY
SRM *=*+NRBYTE ;SR MEMORY
VELOC *=*+1
COMREG *=*+1
CONREG *=*+1
NUMBIT *=*+1
INPBIT *=*+1
INPBYT *=*+1
PARITY *=*+1
BITCNT *=*+1
STBFLG *=*+1
SINDEX *=*+1
EINDEX *=*+1
STATUS *=*+1
T2LR *=*+1
T2HR *=*+1
REST *=*+10
 
*=$9000
DRB *=*+1
DRA *=*+1
DDRB *=*+1
DDRA *=*+1
T1L *=*+1
T1CH *=*+1
T1LL *=*+1
T1LH *=*+1
T2L *=*+1
T2H *=*+1
SR *=*+1
ACR *=*+1
PCR *=*+1
IFR *=*+1
IER *=*+1
 
*=$3000
RSET
SEI
CLD
LDX #0
OPN DEY
BNE OPN
DEX
BNE OPN
LDX #$FF
TXS
LDA #2
STA PCR
LDA #$58 ;T1 FREE RUNNING
STA ACR ;SHIFT OUT CONTROL 02
LDA #$C2 
STA IER ;TIMER1 INTERUPT ENABLE
LDA #$70 ;PB4 OUTPUT (STROBE)
STA DDRB
LDA #$10
STA DRB
LDA #$28 ;1200, 7 BITS
STA CONREG
LDA #$60 ;EVEN PARITEIT
STA COMREG
LDX #9 ;CALCULATE NUMBER OF BITS
LDA #$20
BIT CONREG
BEQ *+3
DEX
BVC *+4
DEX
DEX
STX NUMBIT
LDA #1
STA STBFLG
LDA #0
STA SINDEX
STA EINDEX
STA STATUS
STA SETFLG
LDA VELOC
CMP #10
BCC V1
LDA #8
STA VELOC
V1
LDA PRG
BEQ PRG2
CMP #4
BCC PRG3
PRG2 LDA #1
STA PRG
PRG3
JSR SETSCT
JSR CLSRM
LDY #0
STY TIMCO
STY SPC
STY TIMIND+1
LDX #10
RS0 LDA REST,X
CMP TEXT,X
BNE RS1
DEX
BPL RS0
;ALLES OK
JMP RS4
RS1
LDA #1
STA PRG
LDX #21
LDA #0
RS11
STA SECOND,X
DEX
BPL RS11
STA STOT
STA $400
STA $600
LDX #10
RS3 LDA TEXT,X
STA REST,X
DEX
BPL RS3
RS4
LDA PRG
CMP #4
BNE RS4B
RS4A
JSR UIT
JMP R1
RS4B
JSR TST ;START OF TEXT
JSR N3
LDY #0
LDA (KP)Y
BNE RS5
LDX PRG
DEX
TXA
ASL A
TAX
LDA TEXTAB,X
STA MP
LDA TEXTAB+1,X
STA MP+1
LDA KP
STA LSTIND
LDA KP+1
STA LSTIND+1
RS2 LDA (MP)Y
STA (LSTIND)Y
BEQ RS2B
CMP #$FF
BEQ RS2B
CMP #$D
BEQ RS2A
INC LSTIND
BNE *+4
INC LSTIND+1
RS2A INC MP
BNE *+4
INC MP+1
JMP RS2
RS2B TYA
STA (LSTIND)Y
JSR COPLST
JMP RS4
TEXTAB .WOR TEXT,TEXT2,TEXT3
RS5
LDA #NRBYTE-1
STA BTC
LDA #7
STA SHC
STA ROC
LDA #0
STA SHEN
STA SHCE
STA SHE
STA IND
JSR PUTRNR
LDA T1L ;RESET INTERUPT FLAG
CLI
JSR GOS
R1 JSR SPREAD
CMP #$30
BCC R2
CMP #$3A
BCS R2
AND #$F
STA VELOC
JSR SETSCT ;SET SCAN TIME
LDA #0
R2
CMP #'P
BEQ STOP2
CMP #'T
BEQ STOP2
CMP #'@
BEQ STOP2
LDX PRG
CPX #4
BEQ R1
CMP #'S
BNE R1
JMP STOP
STOP2
PHA
JSR HALT
PLA
JMP STOP1
 
;SET SCAN TIME 1 T/M 0 IN ACCU
SETSCT
ASL A
TAX
LDA SCTIME,X
STA T1L
LDA SCTIME+1,X
STA T1CH
RTS
 
;CLEAR SR MEMORY
CLSRM
LDX #NRBYTE
LDA #0
ST1
STA SRM-1,X
DEX
BNE ST1
JMP OFF
 
STOP
JSR HALT
JSR READ
STOP1
CMP #'T
BNE STP03
LDA #<MIN
JSR SHCH
;SHOW AND CHANGE TIME
JMP STOP1
STP03
CMP #'P
BNE STP04
JSR CLSRM
PRG8
JSR READ
CMP #$31
BCC PRG8
CMP #$35
BCS PRG8
AND #$F
STA PRG
JMP RS4
STP04
CMP #'@
BNE STP05
LDX PRG
DEX
LDA SETTAB,X
JSR SHCH
JMP STOP1
SETTAB
.BYT <SET1,<SET2,<SET3,<SET4
STP05
LDX PRG
CPX #4
BNE STP06
JMP RS4A
STP06
CMP #'G
BNE STP07
JSR CLSRM
LDA #0
TAY
STA (STOIND)Y
JMP RS4
STP07
CMP #6
BNE STP08
JSR SNR1
JMP STOP
STP08
CMP #' 
BNE STP1
JSR SHIKAR
JSR PUTRNR
JSR NEWKAR
JMP STOP
STP1
CMP #8
BNE STP2
JSR SHKABA
JMP STOP
STP2
CMP #$7F
BNE STP3
JSR DEL
JMP STOP
STP3
CMP #'I
BNE *+5
JMP INSERT
CMP #'N
BEQ NTEXT
CMP #$D
BEQ GO
JMP STOP
 
HALT LDA #0
STA IND
STA SHE
HALT1 LDA SHEN
BNE HALT1
RTS
 
GO
JSR GOS
JMP R1
GOS
LDA #0
STA TIMCO
LDA #1
STA SHE
STA IND
INC SHC
RTS
 
;SHOW AND CHANGE TIME
SHCH
STA TIMIND
STA CHIND
LDA #0
L
