VOCABULARY EDITOR IMMEDIATE EDITOR DEFINITIONS 

DECIMAL

512 CONSTANT TEMP
0 VARIABLE CUR
0 VARIABLE INSERT

: !CURSER 20 EMIT 0 + SWAP 0 + EMIT EMIT ;
: DISPL-I-ON  63 1 !CURSER ." INSERT-ON " ;
: DISPL-I-OFF  3 0 DO 62 I !CURSER 14 SPACES LOOP ;
: CUR>CHAR-LINE  CUR @ C/L /MOD ;
: .CUR  CUR>CHAR-LINE 5 + >R 9 + R> !CURSER ;
: DISPL-LINE 9 OVER 5 + !CURSER C/L * TEMP + C/L TYPE ;
: DISPL-SCR  16 SWAP DO I DISPL-LINE LOOP ;
: GET-SCR  SCR @ 16 0 DO I OVER (LINE) TEMP I C/L 
            * + SWAP CMOVE LOOP DROP ;

: SETUP  CLS 10 1 !CURSER  ." FORTH SCREEN EDITOR "
          9 3 !CURSER ." SCR# " SCR ? 
           16 0 DO 5 I OVER + !CURSER I 2 .R LOOP 
            0 INSERT ! 0 22 !CURSER ;

: MODE  INSERT @ 0= DUP INSERT ! 
         IF DISPL-I-ON ELSE DISPL-I-OFF THEN .CUR ;

: MESS     ." 00-JAN-87 TWB " ;
: HOME      9 5 !CURSER 0 CUR ! ;
: 1-REGEL ' MESS 3 + TEMP 51 + 13  CMOVE 0 DISPL-LINE HOME ;
: CLEAR  TEMP 1024 BLANKS 0 DISPL-SCR HOME ;

: LEFT  CUR>CHAR-LINE DROP 0 > IF -1 CUR +! 8 EMIT 
              ELSE 7 EMIT THEN ;

: RIGHT  CUR>CHAR-LINE DROP 63 < IF 1 CUR +! .CUR 
              ELSE 7 EMIT THEN ;

: UP  CUR>CHAR-LINE SWAP DROP 0 > IF -64 CUR +! 11 EMIT
              ELSE 7 EMIT THEN ;

: DOWN  CUR>CHAR-LINE SWAP DROP 15 < IF 64 CUR +! 10 EMIT 
              ELSE 7 EMIT THEN ;

: I-LINE CUR>CHAR-LINE SWAP DROP DUP C/L * TEMP + DUP 
          DUP C/L + OVER 1024 TEMP + SWAP - <CMOVE C/L 
           BLANKS DISPL-SCR .CUR ;

: D-LINE  CUR>CHAR-LINE SWAP DROP DUP C/L * TEMP + DUP C/L + 
            SWAP OVER 1024 TEMP + SWAP - CMOVE 960 TEMP + C/L 
             BLANKS DISPL-SCR .CUR ;

: H-LINE  CUR>CHAR-LINE SWAP DROP DUP C/L * TEMP + PAD 1+ C/L DUP 
            PAD C! CMOVE ;

: R-LINE  CUR>CHAR-LINE SWAP DROP DUP PAD 1+ SWAP C/L * TEMP 
            + C/L CMOVE DISPL-LINE .CUR ;

: <ERASE  CUR>CHAR-LINE SWAP DROP DUP C/L * TEMP + DUP CUR @
           TEMP + SWAP - DUP IF BLANKS DISPL-LINE .CUR
            ELSE DROP DROP DROP THEN ;

: ERASE>  CUR>CHAR-LINE SWAP DROP DUP CUR @ TEMP + DUP ROT 1+
           C/L * TEMP + SWAP - BLANKS DISPL-LINE .CUR ;

: D-CHAR  CUR @ TEMP + DUP 1+ SWAP CUR>CHAR-LINE SWAP DROP DUP 
           >R 1+ C/L * TEMP + 1 - DUP >R OVER - CMOVE BL R> C! R>
            DISPL-LINE  .CUR ;

: NEXT-LINE  CUR>CHAR-LINE SWAP DROP DUP 15 < IF 1+ C/L * CUR !
              .CUR ELSE 7 EMIT DROP THEN ;

: CHAR CUR @ TEMP + INSERT @ IF DUP DUP 1+ CUR>CHAR-LINE SWAP
        DROP 1+ C/L * TEMP + OVER - <CMOVE C! ELSE C! THEN
         CUR>CHAR-LINE >R 63 < IF 1 CUR +! ELSE 7 EMIT 
          THEN R> DISPL-LINE .CUR ;

: SAVE  SCR @ B/SCR * OFFSET @ + DUP B/SCR + SWAP DO TEMP I B/SCR 
             MOD B/BUF * + I BUFFER B/BUF CMOVE UPDATE LOOP FLUSH ;

: COMMAND BEGIN KEY DUP 32 < OVER 127 > OR 0= IF DUP CHAR THEN
                                    DUP 21 - WHILE CASE
           11 OF H-LINE    ENDOF
           15 OF I-LINE    ENDOF
           06 OF D-CHAR    ENDOF
           04 OF RIGHT     ENDOF
           05 OF UP        ENDOF
           10 OF ERASE>    ENDOF
           22 OF MODE      ENDOF
           13 OF NEXT-LINE ENDOF
           14 OF R-LINE    ENDOF
           09 OF D-LINE    ENDOF
           01 OF LEFT      ENDOF
           24 OF DOWN      ENDOF
           12 OF CLEAR     ENDOF
           20 OF SAVE      ENDOF
           08 OF HOME      ENDOF  ENDCASE REPEAT DROP ;

: E  EDITOR  DEPTH IF SCR ! THEN SETUP GET-SCR 0 DISPL-SCR
                                        HOME COMMAND CLS FORTH ;

: EC EDITOR  DEPTH IF SCR ! THEN SETUP CLEAR 
                           1-REGEL COMMAND CLS FORTH ;

FORTH DEFINITIONS DECIMAL
LATEST       12 +ORIGIN !  ( TOP NFA )
HERE         28 +ORIGIN !  ( FENCE )
HERE         30 +ORIGIN !  ( DP )
' EDITOR 6 + 32 +ORIGIN !  ( VOC-LINK )
HERE  FENCE ! 
