

VERANDERINGEN DOS2.1.


Functie veranderingen
---------------------
De seek functie heeft nu de volgende mogelijkheden:

 - 1 seek forward from beginning of file
 - 2 seek forward from current position
 - 3 seek backward from current position
 - 4 seek backward from end of file

Alle andere functies zijn hetzelfde gebleven.


Filenaam verandering
--------------------
Door de uitbreiding met meer directories kan een directory achter de
drivespecificatie opgegeven met `@/' of `A/' t/m `G/'. `@/' is de
standaard directory, deze wordt met initialiseren aangemaakt. De
andere directories worden automatisch gemaakt als daarop een file
gecreerd wordt. De filespec ziet er b.v. zo uit `0:A/test'. Wil men
het `/' karakter in de filenaam hebben, dan moet dit vooraf gegaan
worden door het escape karakter `\'. Voor de beschrijving van system
en user drive/directory zie de handleiding over het commando `ASN'.

Commando's
----------
Het permanente commando `R file' vanaf de systeem drive is verwijdert.
Het `RUN' commando mag nu afgekort worden tot de letter `R'.

Het `DIR' commando mag afgekort worden tot `D'. Tevens is bij dit
commando de optie `-/' om alle directories op de disk te laten zien.

Het is mogelijk om twee files aan de printer spooler aan te bieden.
De tweede file wordt geprint als de eerste file beeindigd is. Aan de
tweede file zijn geen nieuwe opties op te geven, deze file neemt de
opties over van de opties zoals die voor de eerste file gelden.

Het is mogelijk om indirecte commando's tot twee niveaus diep te
gebruiken. Indien er getracht wordt een derde niveau commando te
starten dan wordt de file met commandos op het tweede niveau
gesloten. Verder is er de mogelijkheid om argumenten aan de
indirecte files mee te geven.

Enkele kenmerken van indirecte commando's:
- argumenten worden van elkaar gescheiden door spaties. Meer dan
  twee argumenten worden er niet opgeslagen.
- de totale lengte van de twee argumenten is beperkt tot 24
  karakters.
- argumenten worden alleen door de start van het eerste niveau of
  met het laatste commando van een niveau 1 commando gedefinieerd.
- een niet bestaand argument is een leeg argument.
- argumenten worden geadresseerd door het karakter na `&'. Dit mogen
  alleen de karakters `1' of `2' zijn, alle andere karakters worden
  opgenomen in het commando.

Bijvoorbeeld: Er is de volgende file test:

; file test
type &1
type &2
type &1.mac t.&1.mac
type &1 &2
type &&test1
; einde file

Het commando `test test1 test2' voert dus de volgende commando's uit:

type test1
type test2
type test1.mac t.test1.mac
type test1 test2
type &test1

Is het commando `test test1' dan is het resultaat:

type test1
type

Met een foutmelding bij het tweede type commando omdat er geen filenaam
gespecificeerd is. Tevens wordt dan de indirecte file gesloten.

Stel er is ook een file make die er als volgt uitziet:

; file make
test &1 &2
test test2 test3
; einde make

dan doet het commando `make test1 test2' dit:

test test1 test2
type test1		enz. en
test test1 test2
type test1		omdat er alleen niveau 1 argumenten
			meegegeven kunnen worden.

Is de file make echter:

; file make
test &1 &2
test test3 test4

dan gebeurt er dit:

test test1 test2
type test1		enz. maar het volgende is anders
test test3 test4
type test3

Het is dus mogelijk om met het laatste commando nieuwe argumenten
mee te geven.

Opmerking: denk erom dat het aantal files dat gelijktijdig open kan
zijn beperkt is. Met een indirectie van 2 niveaus, 2 spooler files en
een assemler die een aantal files tegelijk moet openen, zorgt ervoor
dat het absolute maximum van 6 files snel bereikt is.

