; file prtsc.mac
; printscreen for DOS65

	org	$a000

hotkey	set	$01		;^A
total	set	24*80
priout	set	$f88c		;print accu in ASCII on printer		
start	set	$e7ad		;pointer to video ram
vduram	set	$e800		;video ram area

print1	set	$c03b		;print string until <null>
inch1	set	$c2f3

	org	$a000
prtsc	jsr	print1
	fcc	'Printscreen overlay installed.\r',0
	rts

	org	$c09a		;overlay dos65
	jsr	input

	org	$e4b0

input	jsr	inch1
	bcs	input
	cmp	#hotkey		;printscreen requested ?
	beq	1.f
	rts			;else return

1	jsr	prtscr
	jmp	input

prtscr	jsr	crlf		;start with crlf
	lda	#0		;reset position counter
	sta	poscnt
	sta	cnt
	sta	cnt+1
	lda	start		;copy pointer
	sta	pol
	lda	start+1
	sta	poh
1	jsr	fetch		;fetch byte from video memory
	bpl	2.f		;if in range $00 .. $7f
	lda	#$20		;else replace by space
	bne	3.f		;always
2	cmp	#$20		;greater than or equal to space ?
	bcs	3.f
	lda	#$20		;else replace by space
3	jsr	priout		;print it
	inc	poscnt		;adjust position counter
	lda	poscnt		;reached end ?
	cmp	#80		
	bne	4.f		;not yet
	lda	#0		;reset
	sta	poscnt		;position counter
	jsr	crlf		;and perform crlf
4	inc	pol		;adjust work pointer
	bne	5.f
	inc	poh
	lda	poh
	cmp	#vduram+$0800>>8	;check overflow
	bne	5.f
	lda	#vduram>>8
	sta	poh
5	inc	cnt
	bne	6.f
	inc	cnt+1
6	lda	cnt+1		;done all?
	cmp	#total>>8
	bne	1.b
	lda	cnt
	cmp	#total&255
	bne	1.b
	jsr	crlf		;end with crlf
	rts


fetch	fcb	#$ad		;code for lda absolute
pol	fcb	0		;self modifying
poh	fcb	0
	fcb	$60		;code for rts	

crlf	lda	#10
	jsr	priout
	lda	#13
	jmp	priout

poscnt	res	1
cnt	res	2

	end	prtsc
