{$X+} {$G+} {$D-} {$R-} {$F+} {$C5200}
program fastedit(input,output,datafile);
{fast data editor for lsq and graph programs}
const nmax=501;

type string=packed array [1..11] of char;

var  X,Y                   :array[1..nmax] of real;
     n,ntot,nins           :integer;
     datafile              :text;
     b                     :boolean;
     filename              :string;
     validfname            :boolean;
     ipc,ipc1              :char;
     ipi                   :integer;
     carryon               :boolean;
     lineflag              :boolean;
     linecount,pagen       :integer;
     newreq                :boolean;
     xt,yt                 :real;
     ok                    :boolean;

procedure tab (x,y :integer);
begin;
 write (chr(9));
end;

procedure getkey(var ipc:char);
var  ip:integer;
begin;
 read(ipc);
end;

procedure bell;
begin
 write(chr(7))
end;

procedure inverse;
begin;
 write(chr(27),'i');
end;

procedure not_inverse;
begin;
 write(chr(27),'n');
end;

procedure clearline;
begin;
 write(chr(13));
 write('                                                              ',
      '              ');
 write(chr(13));
end;

function ival(s:string) : integer;
begin
end;

function rval(s:string) : real;
begin
end;

procedure get_name(var s:string;var b:boolean);
var    i, k                   :integer;
       f                      :boolean;
       c                      :char;

begin;
write('name ?');
i:=3;
s:='L.         ';
f:=false;
 repeat
   repeat
   read(c);
   k:=ord(c);
   until ((k>27) and (k<128)) or (k=13);
  case k of
  127:if i>3 then 
      begin;
      i:=i-1;
      s[i]:=' ';
      write(chr(127):1);
      end;
  13 :f:=true
  else {case} if i<11 then
   begin;
    s[i]:=chr(k);
    i:=i+1;
    write(chr(k):1);
   end;
  end; {case}
 until f=true;
 if i>3 then b:=true else b:=false;

end;


function getnum(var s:string; dp:boolean):boolean;
var i       :integer;
    ipc     :char;
    dotflag :boolean;
    b       :boolean;

begin
 s:='           ';
 i:=0;
 dotflag:=false;
repeat
 repeat
   getkey(ipc);
   if ipc in ['.','+','-',chr(127),chr(13),'0'..'9'] then 
          b:=true else b:=false;   
   if (ipc='.') then b:=dp;
   if b=false then bell;
 until b=true;

if ipc='.' then if (i>0) and (dotflag=false) and (i<11) then 
       begin
        i:=i+1;
        s[i]:='.';
        write('.');
        dotflag:=true;
       end
       else bell;
 if ipc in ['+','-'] then
        begin
         if i=0 then
         begin
          i:=i+1;
          s[i]:=ipc;
          write(ipc:1);
         end
         else bell;
        end;

 if ipc in ['0'..'9'] then if i<11 then
           begin
            i:=i+1;
            s[i]:=ipc;
            write(ipc:1);
           end
           else bell;

 if ipc=chr(127) then if i>0 then
            begin
             if s[i]='.' then dotflag:=false;
             s[i]:=' ';
             write(chr(127):1);
             i:=i-1;
            end
            else bell;

   until ipc=chr(13);
    if i=0 then b:=false;
    if ( ((s[1]='+') or (s[1]='-')) and (s[2]='.') ) then b:=false;
    if i>0 then if s[i]='.' then b:=false;
    getnum:=b;
 end;

function getrl(var r:real):boolean;
var  s:string;
begin
 if getnum(s,true)=true then
 begin
  r:=rval(s);
  getrl:=true
 end
 else getrl:=false;
end;

function getint(var i:integer):boolean;
var s:string;
begin
 if getnum(s,false)=true then
 begin
  i:=ival(s);
  getint:=true
 end
 else getint:=false;
end;
 
  
  
begin;
repeat {unconditional loop}
 validfname:=false;
 newreq:=false; 
 not_inverse;
 writeln('-- FAST EDITOR --');
 writeln;
 writeln;
 repeat {bad file name loop}
  inverse;
  write('K=Keyboard entry   F=File entry');
  not_inverse;
 repeat
     getkey(ipc);
 until ipc in ['K','k','F','f'];
  clearline;
  ntot:=0;
  b:=true;
  if ipc in ['F','f'] then
  begin;
   get_name(filename,b);
   writeln;
   writeln;
   if b=false then writeln('-- Bad file name --') 
   else
   begin
     validfname:=true;
     reset(datafile{,filename});
     {ntot is 0}

    repeat {find start of numerical data}
     readln(datafile,ipc1);
    until ipc1='@';

    repeat {read data}
      ntot:=ntot+1;
      readln(datafile,X[ntot],Y[ntot]);
    until eof(datafile)=true;      

     writeln(ntot:4,' points read');
   end;
   writeln;
   writeln;
  end;
 until b=true; {valid file or fresh data option}

repeat {new loop}
  inverse;
  write('A=Add  D=Delete  E=Edit  I=Insert  L=List  N=New  R=Remove  S=Save',
              '  P=Print');
  not_inverse;
 repeat
   getkey(ipc);
 until ipc in ['E','e','A','a','S','s','l','L','D','d','I','i',
              'P','p','R','r','n','N'];
  clearline;
  case ipc of
  'S','s': begin;
            if validfname then
            begin
             bell;
             write('Filename = ');
             for n:=3 to 11 do write(filename[n]);
             write(' Y/N ');
             b:=true;

            repeat
              getkey(ipc1);
            until ipc1 in ['Y','y','N','n'];

             if ipc1 in ['N','n'] then 
             begin
              writeln;
              writeln;
              get_name(filename,b);
             end;
            end
           else get_name(filename,b);

            writeln;
            writeln;
            validfname:=b;
            if b=false then writeln('-- Not saved --')
            else
            begin
             rewrite(datafile{,filename});
             writeln(datafile,'@'); {start of data character}
             for n:=1 to ntot do
             begin;
              writeln(datafile,X[n],Y[n]);
             end;
             writeln('-- Saved --');
            end;
           end;

  'A','a': begin;
          repeat
            writeln('Point number ',ntot+1:1);
            write('  X = ');
            ok:= getrl(X[ntot+1]);
            if ok=true then
            begin
             write('  Y = ');
             ok:=getrl(Y[ntot+1]);
            end;
            writeln;
            if ok=true then ntot:=ntot+1 else bell;
          until ok=false;
            end;

  'E','e': begin;
            if ntot>0 then 
            begin
             writeln;
             write('Number = ');
             ok:=getint(n);
             if ok=true then ok:=(n>0) and not(n>ntot);
             if ok=true then
             begin;
              writeln;
              write('  X = ');
              ok:=getrl(xt);
             end;
             if ok=true then
             begin
              write('  Y = ');
              ok:=getrl(yt);
             end;
             if ok=true then
             begin
              X[n]:=xt;
              Y[n]:=yt;
             end
             else bell;
             writeln;
            end; 
           end;

  'L','l': begin
            linecount:=0;
            n:=0;
            lineflag:=true;
            if ntot=0 then writeln('-- Empty --');
            while (n<ntot) and (lineflag=true) do
            begin;
             linecount:=linecount+1;
             n:=n+1;
             writeln(n:3,'  X = ',X[n]:8:3,'  Y = ',Y[n]:8:3);
             if (linecount=17) and (ntot>n+5) then
             begin
               linecount:=0;
               inverse;
               write('Press space bar to continue');
               not_inverse;
               getkey(ipc1);
               clearline;
               if ipc1<>' ' then lineflag:=false;
             end;
            end;
           end;
           
  'D','d':begin;
           write('Delete what number? ');
           ok:=getint(nins);
           if ok then ok:=(nins>0) and (nins<=ntot);
           if ok then
           begin
            ntot:=ntot-1;
            for n:=nins to ntot do
            begin
             X[n]:=X[n+1];
             Y[n]:=Y[n+1];
            end;
           writeln;
           writeln;
           write('-- ',nins:2,' Deleted --');
          end
          else bell;
          writeln;
         end;

  'I','i':begin  {Insert}
           write('Insert before what number? ');
           ok:=getint(nins);
           if ok=true then ok:=(nins>0) and (nins<=ntot);

            while ok=true do
            begin
             writeln;
             write(nins:1,':  X = ');
             ok:=getrl(xt);

             if ok=true then
             begin
              write('  Y = ');
              ok:=getrl(yt);
             end;

             writeln;

             if ok=true then
             begin
              for n:=ntot downto nins do 
              begin
               X[n+1]:=X[n];
               Y[n+1]:=Y[n]
              end;
              ntot:=ntot+1;
              X[nins]:=xt;
              Y[nins]:=yt;
              nins:=nins+1;
             end;

            end; {While}
           bell;
          end;

  'N','n':begin
            if ntot>0 then writeln('-- Warning existing data will be lost --');
            writeln;
            inverse;
            write('New Y/N ');
            not_inverse;
            bell;
           repeat
             getkey(ipc1);
           until ipc1 in ['Y','y','N','n'];
            clearline;
            if ipc1 in ['Y','y'] then newreq:=true;
          end;

  'P','p':begin  {printer listing}
            n:=0;
            {oscli('fx5,1');}
            if ntot=0 then writeln('-- Empty --');
            linecount:=0;
            pagen:=1;
            inverse;
            write('Printer listing: Y=Yes');
            not_inverse;
            getkey(ipc1);
            clearline;
            if ipc1 in ['Y','y'] then 
            begin
              carryon:=true;
               while (n<ntot) and (carryon=true) do
               begin;
                write(chr(2));
                if linecount=0 then 
                begin
                 if validfname=true then write('File = ',filename);
                 writeln('  page ',pagen:1);
                 writeln;
                 writeln;
                end;
                n:=n+1;           
                linecount:=linecount+1;
                writeln(n:3,'  X = ',X[n]:8:3,'  Y = ',Y[n]:8:3);
                if (linecount>59) and (ntot-n>4) then
                begin
                 write(chr(12));
                 linecount:=0;
                 pagen:=pagen+1;
                end;
                write(chr(3));
{                ipi:=inkey(1);
                if ipi>0 then
                begin
                  inverse;
                  write('Q=Quit  Spacebar=continue');
                  not_inverse;
                 repeat
                   getkey(ipc1);
                 until ipc1 in ['Q','q',' '];
                  clearline;
                  carryon:=(ipc1=' ');
                end;  }
               end;
              write(chr(2),chr(12),chr(3));
             end;
            end;

  'R','r':begin
          if ntot>0 then
          begin;
            inverse;
            write('Remove last entry Y=Yes');
            not_inverse;
            getkey(ipc);
            clearline;
            writeln;
            if ipc in ['Y','y'] then
            begin;
             ntot:=ntot-1;
             writeln;
             writeln('-- Entry deleted --');
            end;
           end;
         end;

    end; {case}
   writeln;
  until newreq=true; {new loop}
 until false; {main loop}
end.
