program scales(input,output);

type tstring2=packed array[1..2] of char;
     tnotes=packed array[1..30] of tstring2;

var   flatnotes,sharpnotes : tnotes;
      n     : integer;
      Vsharp : boolean;

procedure writenote(k : integer);
begin
  if k>12 then k:=k-12;
  if Vsharp then write(sharpnotes[k],' ')
            else write(flatnotes[k],' ');
end;

procedure major(k : integer);
begin
  writenote(k);
  writenote(k+2);
  writenote(k+4);
  writenote(k+5);
  writenote(k+7);
  writenote(k+9);
  writenote(k+11);
end;

procedure major1(k : integer);
begin
  write('               ');
  Vsharp:=true;
  major(k);
  write('   ');
  Vsharp:=false;
  major(k);
  writeln
end;

begin

  sharpnotes[1]:='C ';
  sharpnotes[2]:='C#';
  sharpnotes[3]:='D ';
  sharpnotes[4]:='D#';
  sharpnotes[5]:='E ';
  sharpnotes[6]:='F ';
  sharpnotes[7]:='F#';
  sharpnotes[8]:='G ';
  sharpnotes[9]:='G#';
  sharpnotes[10]:='A ';
  sharpnotes[11]:='A#';
  sharpnotes[12]:='B ';

  flatnotes[1]:='C ';
  flatnotes[2]:='Db';
  flatnotes[3]:='D ';
  flatnotes[4]:='Eb';
  flatnotes[5]:='E ';
  flatnotes[6]:='F ';
  flatnotes[7]:='Gb';
  flatnotes[8]:='G ';
  flatnotes[9]:='Ab';
  flatnotes[10]:='A ';
  flatnotes[11]:='Bb';
  flatnotes[12]:='B ';

  page;
  writeln;
  writeln;
  writeln('               =============== MAJOR SCALES ==============');
  for n:=1 to 12 do major1(n)

end.
