;DOS65 operating system source files:
;
;File : TMP.BIN
;
	lib	syshavi.MAC
	opt	lis
	opt	nopag
;
;Maximum memory usage:
;
;	C000 - C9FF
;
;
;Execution address
;
COLD	equ	LC000
;
;work memory
wmem	equ	$aa00
;
;Zero page addresses
;
Z00	equ	$00
Z01	equ	$01
varb	equ	$E0
sysb	equ	$E2
tslb	equ	$E4
t1	equ	$F0
t2	equ	$F2
t3	equ	$F4
tepo	equ	$F8
rbg	equ	tepo
opp	equ	$FA
rln	equ	opp
tcn	equ	$FC
cbp	equ	tcn
opt	equ	$FE
mode	equ	$FF
;
;
;Absolute addresses
;
X0105	equ	$0105
X0106	equ	$0106
;
inbuf	equ	$AA00
ifd	equ	$AA50
ofd	equ	$AA51
iocfl	equ	$AA52
lffl	equ	$AA53
doser	equ	$AA54
xio	equ	$AA56
yio	equ	$AA57
ipoin	equ	$AA58
opoin	equ	$AA5A
hdx	equ	$AA5B
cjmp	equ	$AA5C
cmdvec	equ	$AA5E
eopt	equ	$AA60
efd	equ	$AA61
efd2	equ	$AA62
ecml	equ	$AA63
ibf	equ	$AA80
obf	equ	$AAA0
prfd	equ	$AAE0
fd	equ	$ABB3
csufl	equ	$ABD0
iopoin	equ	$ABDC (4)
namb	equ	$ABE0
fdrive	equ	$ABEE
incon	equ	$CA00
outcon	equ	$CA03
inpri	equ	$CA06
outpri	equ	$CA09
inser	equ	$CA0C
outser	equ	$CA0F
break	equ	$CA1E
clstcon equ	$CA2A
brkset	equ	$CA2D
pbel	equ	$CA33
pdel	equ	$CA36
inihw	equ	$CC05
sread	equ	$D000
sread1	equ	$D003
swrite1 equ	$D00C
fseek	equ	$D012
fseek1	equ	$D015
read	equ	$D01B
read1	equ	$D01E
write	equ	$D024
write1	equ	$D027
create	equ	$D036
create1 equ	$D039
open	equ	$D03F
open1	equ	$D042
close	equ	$D048
close1	equ	$D04B
status	equ	$D063
status1 equ	$D066
setfiln equ	$D09F
svzp	equ	$D0AE
rszp	equ	$D0B1
setnex	equ	$D0B4
ermes	equ	$D0B7
prfile	equ	$D0BD
;
;
	org	$C000
;
LC000	jsr	colds
	jmp	warm1
	jmp	cmnd1
	jmp	cmnd2
intwarm jmp	intwarm1	entry after ^C
	jmp	sync1
	fcb	dosmod
	fcb	0,0
delchar fcc	$7F
	fdb	wmem
	fdb	irqvec
	fdb	brkvec
	fdb	$200
	fdb	$A000
in	jmp	in1
out	jmp	out1
inecho	jmp	inecho1
bufin	jmp	bufin1
getbuf	jmp	getbuf1
crlf	jmp	crlf1
spa	jmp	spa1
hnout	jmp	hnout1		hex nibble in A out
	jmp	hexout1 	print A in hex
print	jmp	print1		print string after call upto 0
	jmp	aschex1 	A ascii --> hex
	jmp	loupch1 	A to upper case, If eoln Z=1
	jmp	hexdec1 	A hex to dec
	jmp	dechex1
inputx	jmp	inputx1 	get fgrom device x
outputx jmp	outputx1	put to device x
	jmp	inch1		char from input file
	jmp	outch1		A to output file
	jmp	inopn1		open input file for read
	jmp	outcre1 	create output file
inclo	jmp	inclo1		close input file
outclo	jmp	outclo1 	close output file
seter	jmp	seter1		set error flag, doser
	jmp	setlffl1	set terminal lf flag
sopt	jmp	sopt1		-option parameter scan
spar	jmp	spar1		+options to page 0
;
;*************************************************
;	  Standard i/o routines
;*************************************************
;get character
in1	jsr	inch1
	bcs	in1
	rts
;
;get line
bi52	jsr	delb		delete buffer
bi51	dey			until begin
	bpl	bi52
bufin1	ldy	#$00
bi10	dey			entry
	bmi	bi16		delete
	jsr	delb
	jmp	bi4
bi1	jsr	in1
bi2	cpy	#$4F
	bcs	bi15
	sta	inbuf,y 	store it
	jsr	outp		output it
bi16	iny	
	cpy	#72		> 72
	bcc	bi4
bi15	jsr	pbel
bi4	jsr	in1
	cmp	#$16		^V get next
	beq	bi1
	cmp	delchar 	delete
	beq	bi10
	cmp	#$15		^U next from buffer
	beq	bi51
	cmp	#$19		^Y print buffer
	bne	LC0BD
LC0AE	cpy	#$48		max 72
	bcs	bi4
	jsr	getbuf1
	beq	bi4
	jsr	outp
	iny			next
	bne	LC0AE
LC0BD	cmp	#$0D		start command?
	bne	bi2
	sta	inbuf,y 	get first char
	lda	inbuf
;
;new line
crlf1	pha
	lda	#$0D		CR
	bne	LC106
;
outp	jsr	ctrchk		control character?
	bcs	out1
	pha
	lda	#'^		print ^
	jsr	out1
	pla
	pha
	eor	#$40
	bne	LC11B
ctrchk	cmp	 #$7F
	beq	LC11F
	cmp	#$20
	rts
;
delb	lda	inbuf,y 	get and delete char
	jsr	ctrchk		control?
	bcs	LC0EF
	jsr	pdel		delete ^
LC0EF	jmp	pdel
;
outbf	sta	inbuf,y
	cpy	#$4F
	bcs	LC0FA
	iny
LC0FA	bit	eopt
	bmi	LC116
	bvs	LC116

outan1	pha
	cmp	#$0D
	bne	LC11B
LC106	jsr	outch1
	inc	lffl		set lf flag after cr
	lda	#$0A
	jsr	outch1		reset it
	dec	lffl
	clc
	pla
LC116	rts
;
inecho1 jsr	in1
;
;print character
out1	pha
LC11B	jsr	outch1
	pla
LC11F	clc
	rts
;
spa1	pha			print space
	lda	#$20
	bne	LC11B
prax	cmp	#$00
	beq	prax1
	jsr	hnout1
	txa
	bcc	hexout1
prax1	txa
hnout1	cmp	 #$10
	bcc	nibout
;
;print hex
hexout1 pha
	lsra
	lsra
	lsra
	lsra
	jsr	nibout
	pla
	and	#$0F
nibout	cmp	 #$0A
	bcc	LC146
	adc	#$06
LC146	adc	#$30
	bcc	out1
priner	jsr	 seter1
;
;print string following call
print1	pha
	txa
	pha
	lda	tepo
	pha
	lda	tepo+1
	pha
	tsx
	lda	X0105,x 	return address
	sta	tepo
	lda	X0106,x
	sta	tepo+1
pria	jsr	tincr
	beq	LC16B		terminate with null
	jsr	outan1
	bcc	pria
LC16B	tsx
	lda	tepo
	sta	X0105,x
	lda	tepo+1
	sta	X0106,x
	pla
	sta	tepo+1
	pla
	sta	tepo
	pla
	tax
	pla
	rts
;
seter1	dec	 doser		set error flag
	rts
;
tincr	ldx	#$F8
incr	inc	Z00,x
	bne	LC18C
	inc	Z01,x
LC18C	lda	[Z00,x]
	rts
;
ascdh	bit	mode
	bmi	LC19B
;
;Ascii to hex
aschex1 cmp	#$47
	bcs	LC1A3
	cmp	#$41
	bcs	LC1A4
LC19B	eor	#$30
	cmp	#$0A
	bcc	LC1A3
	eor	#$30
LC1A3	rts
;
LC1A4	sbc	#$37
	clc
	rts
;
;decimal to hex
hexdec1 stx	  hdx
	clc
	tax
	beq	LC1B8
	lda	#$00
	sed
LC1B2	adc	#$01
	dex
	bne	LC1B2
LC1B7	cld
LC1B8	ldx	hdx
	rts
;
dechex1 stx	hdx
	ldx	#$FF
	sec
	sed
LC1C3	inx
	sbc	#$01
	bcs	LC1C3
	txa
	bcc	LC1B7
;
bufkey1 iny
bufkey	lda	 [tcn],y
	cmp	#$20
	beq	LC1E6
;
;lower to upper case
loupch1 cmp	#$61
	bcc	LC1E0
	cmp	#$7B
	bcs	LC1E0		check eoln
	eor	#$20
	rts
;
getbuf1 lda	inbuf,y
LC1E0	cmp	#$00
	beq	LC1E6
	cmp	#$0D
LC1E6	clc
	rts
;
setcbp	sty	 tcn		get string address
	sta	tcn+1
	ldy	#$00
	jsr	calposp
	ldy	#$FF
LC1F3	iny
sechar	lda	 [tcn],y
	cmp	#$20
	beq	LC1F3
	bne	LC1E0
;
;parameter option scanning
spar1	stx	mode	bit7:decimal, bit6 +option
	sec		bit5: no clear
	bcs	LC202
sopt1	clc
LC202	php
	jsr	setcbp		options => X
	plp
	pla
	sta	opp		return address
	sta	tepo
	pla
	sta	opp+1
	sta	tepo+1
LC211	jsr	tincr		new return address
	bne	LC211
	lda	tepo+1
	pha
	lda	tepo
	pha
	lda	[tcn],y
	bcc	LC26B		-options
;
;scan parameters
	sty	tepo
	sty	tepo+1		clear parameters
	bit	mode		mode
	bvc	LC230
	cmp	#'+		check +option
	beq	LC22F
	inc	mode		flag no parameter
	dey
LC22F	iny
LC230	sec
LC231	ror	tepo+1		clear parameter
	ldx	#$FA
	jsr	incr		set next
	beq	LC265		until last
	tax			set page 0 X
	lda	#$20
	and	mode		clear current param
	bne	LC245		no
	sta	Z00,x
	sta	Z01,x
LC245	lda	mode		scan enabled
	lsra
	bcc	LC253
	dey
LC24B	iny
	clc
	bcc	LC231		continue
;
LC24F	jsr	inshf
	iny
LC253	jsr	bufkey		while no terminator
	beq	LC231
	jsr	ascdh		and hex
	bcc	LC24F
	cmp	#',		parameter terminator
	beq	LC24B
;
	lda	#$16		error data
	sec
	rts
;
LC265	ldx	tepo
	stx	mode
	bcc	calposp 	calc next
;
;scan options
LC26B	sty	opt
	cmp	#'-
	beq	LC28D
	bne	LC292
LC273	sta	tepo+1
	tya
	tax
	ldy	#$00
LC279	iny
	lda	[opp],y
	beq	LC2A5		error
	eor	tepo+1
	bne	LC279		test option table
	sec
LC283	rora			shift bit in A
	dey
	bne	LC283		until Y equal start
	ora	opt		set bit in opt
	sta	opt
	txa
	tay
LC28D	jsr	bufkey1 	get next char
	bne	LC273
LC292	ldx	opt
;
;skip spaces and calculate new address
calposp jsr	sechar
	tya			calc address
	clc
	adc	tcn
	tay	
	lda	tcn+1
	adc	#$00
	sty	tcn
	sta	tcn+1
	rts	
;
LC2A5	lda	#$15		option error
	sec	
	rts	
;
;shift and add to current parameter
inshf	pha			save
	lda	tepo		test first number
	bit	tepo+1
	bne	LC2BA
	ora	tepo+1		set mask bit
	sta	tepo
	lda	#$00
	sta	Z00,x
	sta	Z01,x
LC2BA	lda	Z01,x		get *1
	pha	
	lda	Z00,x
	asl	Z00,x		set *4
	rol	Z01,x
	asl	Z00,x
	rol	Z01,x
	bit	mode
	bmi	LC2D1
	pla			get *4
	lda	Z01,x
	pha	
	lda	Z00,x
LC2D1	clc			calc *5 or *8
	adc	Z00,x
	sta	Z00,x
	pla	
	adc	Z01,x
	sta	Z01,x
	asl	Z00,x		set *10 or *16
	rol	Z01,x
	clc	
	pla			add
	adc	Z00,x
	sta	Z00,x
	bcc	LC2E9
	inc	Z01,x
LC2E9	rts	
;
;input
rdfvid	jmp	incon
rdfpri	jmp	inpri
rdfaci	jmp	inser
inch1	bit	doser		test error
	bmi	rdfvid		console
	stx	xio		save x
	ldx	ifd
	jsr	rdf15
	jmp	outch2
;
;device input
inputx1 cpx	#$04
	bcc	rdf15
	sty	yio
	jsr	sread1
	jmp	rdf17
;
rdf15	cpx	#$01
	bcc	rdfvid		console
	beq	rdfpri		printer
	cpx	#$03
	bcc	rdfaci		serial
	beq	LC368		dummy
	sty	yio		file
	ldy	ipoin		end of input buffer
	cpy	#$20
	bne	LC33D
	lda	#ibf&255	set up input buffer
	jsr	setiop		read in temp input buffer
	jsr	read1
	bcc	LC335
	cmp	#$04		empty file?
	bne	LC344		no
LC335	ldy	iopoin+2	save end
	sty	ipoin+1
	ldy	#$00
LC33D	cpy	ipoin+1 	test end
	bcc	LC34C
	lda	#$04
LC344	pha	
	jsr	cloi10		close input file
	pla	
	sec			set error flag
	bcs	rdf17
LC34C	lda	ibf,y		get char
	iny	
	sty	ipoin		set to next char
rdf17	ldy	yio
	rts	
;
;output
LC357	bit	lffl		test -T in >p command
	bpl	LC35F
	jsr	wtfvid
LC35F	jmp	outpri
wtfvid	jmp	outcon
LC365	jmp	outser
LC368	lda	#$00
LC36A	clc	
	rts	
;
outch1	bit	 doser		error?
	bmi	wtfvid		console output
	stx	xio
	ldx	ofd
	jsr	wtf15
outch2	ldx	xio
	rts	
;
;device output
outputx1 cpx	#$01
	beq	LC35F		printer
	cpx	#$04
	bcc	wtf15
	sty	yio
	jsr	swrite1
	jmp	wtf17
wtf15	cpx	#$01
	bcc	wtfvid		console
	beq	LC357		printer/console
	cpx	#$03
	bcc	LC365		serial
	beq	LC36A		dummy
	sty	yio		file
	tay	
	lda	#$41		filter and newline
	bit	lffl
	bpl	LC3AC		no console
	php	
	tya	
	jsr	wtfvid
	plp	
LC3AC	beq	LC3C2
	cpy	#$20		space
	bcc	LC3B6
	cpy	#$7F
	bcc	LC3C2
LC3B6	cpy	#$09		tab
	beq	LC3C2
	cpy	#$0D		cr
	beq	LC3C2
	tya			not to file
	clc	
	bcc	wtf17
LC3C2	tya	
	ldy	opoin
	sta	obf,y		save in output buffer
	iny	
	cpy	#$20		test end
	bcc	LC3E2
	pha	
	jsr	setop		save to file
	jsr	write1
	bcc	LC3DF		no error
	tay			set error on stack
	pla	
	tya	
	pha	
	jsr	cloo10		close  output
	sec	
LC3DF	ldy	#$00
	pla	
LC3E2	sty	opoin		set up pos. in o/p buf
wtf17	ldy	yio
	rts	
;
setop	lda	#obf&255	set up output buffer
setiop	sta	iopoin		set up begin buffer
	lda	#obf>>8
	sta	iopoin+1
	sty	iopoin+2	set buffer length
	ldy	#$00
	sty	iopoin+3
	ldy	#iopoin&255	set up A, Y
	lda	#iopoin>>8
	rts	
;
;************************************************
;	 command < input redirect
;************************************************
seifil	ldx	#$81
;
;input redirect
inopn1	jsr	cloi50		close current input file
	cpx	#$04
	bcc	LC464
	jsr	open1
	bcs	9.f
	lda	#$20		set char count to end
	sta	ipoin
	jsr	setnex
	bcc	LC464		setup IFD
;
;************************************************
;	 command >, >> and >p output redirect
;************************************************
seoprt	ldx	#$01		printer
	bne	LC422
seafil	ldx	#$91		append output file
	bne	LC422
seofil	ldx	#$E1		create output file
LC422	stx	mode
	jsr	sopt
	fcc	'TF',0		terminal filter
	bcs	9.f
	stx	lffl
	ldx	mode
;
;redirect output
outcre1 jsr	cloo50		close current output file
	cpx	#$04		set io pointers
	bcc	LC47D
	cpx	#$91
	beq	LC442
	jsr	create1
	jmp	LC44C
LC442	jsr	open1		open r+
	bcs	9.f
	lda	#$04
	jsr	fseek1		seek end
LC44C	bcs	9.f
	lda	#$00		char count to 0
	sta	opoin
	jsr	setnex
	bcc	LC47D		set up OFD
;
;close input redirectf
inclo1	ldx	ifd		close input file
	cpx	#$04
	bcc	LC462		no file
cloi10	jsr	close1
LC462	ldx	#$00
LC464	stx	ifd		set up IFD
9	rts	
;
;close output redirect
outclo1 ldx	ofd		close output file
	cpx	#$04
	bcc	LC47B
	ldy	opoin
	jsr	setop		save current buffer
	jsr	write1
cloo10	jsr	close1
LC47B	ldx	#$00
LC47D	stx	ofd		set up ofd
	rts	
;
setlffl1 sta	lffl
	rts	
;
;
;************************************************
;	 main program
;************************************************
;
colds	ldx	#$00		clear buffers and init
	txa	
LC488	dex	
	sta	inbuf,x
	sta	wmem+$FC,x	not date
	bne	LC488
	jsr	inihw		hardware and console
	jsr	print
	fcc	'DOS65 2.01\r',0
	rts
;
intwarm1 ldx	#$80		^C break?
	jsr	sync10		no close spool files
	jsr	print
	fcc	'^C\r',0
warm1	ldx	#$FF		reset stack
	txs	
	jsr	exe7		continue with exec file
	jsr	cmdin
	jmp	warm1
;
cmdin	lda	cmdvec+1
	beq	LC4C4
	jmp	[cmdvec]
LC4C4	jsr	print
	fcc	'$',0		prompt loads here
	nop
	nop
	nop	
	jsr	bufin
	jmp	cmnd0
;
LC4D2	lda	efd2		error reading file
	beq	LC546
	jsr	cloe1		close level 2
LC4DA	ldy	#$00
LC4DC	ldx	efd2		level 2
	bne	LC4E6
	ldx	efd
	beq	9.b		return
LC4E6	jsr	inputx		get char
	bcs	LC4D2		if error or eof
	cmp	#'&		command line argument
	bne	LC510
	jsr	inputx		arg select (1 or 2)
	bcs	LC4D2
	ldx	#$FF
	cmp	#'1
	beq	2.f
	cmp	#'2
	bne	LC510
LC4FE	inx	
	lda	ecml,x		skip first argument
	bne	LC4FE
2	inx	
	lda	ecml,x		copy from exec cml
	beq	LC4DC
	jsr	outbf
	jmp	2.b
LC510	jsr	outbf
	cmp	#$0D		eoln - start command
	bne	LC4DC
	ldy	#$00
	jsr	status1
	cmp	#$04		eof code
	bne	cmnd0
	jsr	cloe1		close file in advance
cmnd0	ldy	#inbuf&255
	lda	#inbuf>>8
cmnd1	jsr	cmnd2		execute command
exe7	lda	eopt		no i/o close
	bne	LC532
	jsr	cloiof		close i/o redirect
LC532	jsr	cloerr		close i/o/e if error
	lda	#$E1		enable ^S, Q, C, Z
	jsr	clstcon
	ldy	#intwarm&255	reset ^C vector
	lda	#intwarm>>8
	jsr	brkset
	jsr	break		user break
	bcc	LC4DA
LC546	jsr	cloiof		close i/o
;
;close command / indirect files
cloe	jsr	cloe1
cloe1	ldy	#$01		close execute file
LC54E	ldx	efd,y
	bne	LC557
	dey	
	bpl	LC54E
	rts	
;
LC557	lda	#$00
	sta	efd,y		clear fd
	asl	eopt
	jmp	close1
;
cloerr	jsr	rszp		restore zero page for sure
	bit	doser		error?
	bpl	9.f		no
cloioe1 ldx	#$00		sync entry
	stx	iocfl		reset redirect level
	stx	doser		reset flag
	jsr	cloe		close ascii commands
cloiof	asl	iocfl		decr level i/o
	bcs	9.f		delay i/o close
	jsr	cloi50
;
;close > saving A,Y,X
cloo50	pha	
	tya	
	pha	
	txa	
	pha	
	jsr	outclo
cloo51	pla	
	tax	
	pla	
	tay	
	pla	
	clc	
9	rts	
;
;close < saving A, Y, X
cloi50	pha	
	tya	
	pha	
	txa	
	pha	
	jsr	inclo
	jmp	cloo51
sgpfl	sec	
	ror	iocfl		increment level
LC59B	rts	
;
;
;************************************************
;	 command <>
;************************************************
LC59C	jsr	comf1		execute jump
	bcs	ermese
cmnd2	jsr	setcbp		command interpretation
	ldx	#$00		set to first entry comtb
	beq	LC5D0
ermese	jsr	 seter
	jmp	ermes
;
LC5AE	jsr	sechar
	beq	LC59B		no command
	cmp	#';
	beq	LC59B		comment line
	dey	
LC5B8	inx	
	jsr	bufkey1 	next char
	cmp	comtb,x
	bne	LC5D0		not equal
	dec	mode		dec ness. length
	bne	LC5B8
LC5C5	jsr	bufkey1 	check other not ness. char
	beq	LC5EF		eoln
	inx	
	cmp	comtb,x 	compare next char
	beq	LC5C5
LC5D0	dex	
LC5D1	inx	
	lda	comtb,x 	end mark
	bpl	LC5D1
	sta	opt		command mode flags
	asl	opt
	inx	
	ldy	comtb,x 	jump address
	sty	tepo
	inx	
	ldy	comtb,x
	sty	tepo+1
	ldy	#$00		reset line pointer
	and	#$0F
	sta	mode		length
	bne	LC5AE		if not last
;
LC5EF	jsr	calposp
	ldx	#$00
	bit	opt		command flags
	stx	opt		default option clear
	bvs	LC59C
	bpl	comf1		no zero page save
	jsr	svzp
comf1	jmp	[tepo]		execute command
;
comtb	fcb	$82		length command
	fdb	go11		jump address
	fcc	'LCMD'
	fcc	$E2
	fdb	sgpfl
	fcc	'<>'
	fcb	$E2 
	fdb	cloi50
	fcc	'<T'
	fcc	$E2
	fdb	cloo50
	fcc	'>T'
	fcb	$e1
	fdb	seifil
	fcc	'<'
	fcb	$e1
	fdb	seofil
	fcc	'>'
	fcb	$e2
	fdb	seafil
	fcc	'>>'
	fcb	$E2
	fdb	seoprt
	fcc	'>P'
	fcb	$81
	fdb	go
	fcc	'GO'
	fcb	$84
	fdb	syncc
	fcc	'SYNC'
	fcb	$84
	fdb	stat
	fcc	'STAT'
	fcb	$C3		save zp
	fdb	type
	fcc	'SEE'
	fcb	$C5
	fdb	chmode
	fcc	'CHMODE'
	fcb	$C1
	fdb	dir
	fcc	'DIR'
	fcb	$C1
	fdb	exec
	fcc	'@'
	fcb	$C1
	fdb	run
	fcc	'RUN'
	fcc	$c2
	fdb	save
	fcc	'SAVE'
	fcb	$C2
	fdb	load
	fcc	'LOAD'
	fcb	$C0		end of table
	fdb	comrns		jump command
;
;************************************************
;	 command : STAT
;************************************************
stat	ldx	#$04
stat2	ldy	#$00
	jsr	status1
	bcs	LC683
	jsr	prax1
	jsr	print
	fcc	' open\r',0
LC683	inx
	cpx	#$0A
	bcc	stat2
	rts	
;
;************************************************
;	 command SYNC [-N]
;************************************************
sync1	ldx	#$00		external entry
	beq	sync10
syncc	jsr	sopt
	fcc	'P',0
	bcs	LC6E3
sync10	stx	hdx
	jsr	cloioe1 	close i/o/e files
	ldx	#$04
LC69C	ldy	#$01		2 print fds
LC69E	txa	
	eor	prfd,y
	beq	LC6A9
	dey	
	bpl	LC69E
	bmi	LC6B1
LC6A9	bit	hdx		printfile close
	bmi	LC6B4
	sta	prfd,y
LC6B1	jsr	close1
LC6B4	inx	
	cpx	#$0A
	bcc	LC69C
LC6B9	rts	
;
LC6BA	cmp	#$04		eof
	bne	LC6E3
	jsr	close
	inc	mode
	lda	#$FA		next file
type	ldx	#$81
	jsr	open
	bcs	LC6DB
LC6CC	jsr	sread
	bcs	LC6BA
	jsr	outan1		auto newline
	jsr	break
	bcc	LC6CC
	bcs	LC704
LC6DB	cmp	#$12		no filespec
	bne	LC6E3
	ldy	mode		1st file
	bne	LC6B9
LC6E3	sec	
	jmp	ermese
;
;
;************************************************
;	 command CHMODE
;************************************************
chmode	jsr	sopt
	fcc	'RWD',0
	bcs	LC6E3
	ldx	#$10
	jsr	open
	bcs	LC6E3
	ldy	#$01
	lda	[varb],y
	and	#$1F
	ora	opt
	ldy	#$02
	jsr	status		put and set file changed flag
LC704	jmp	close
;
;************************************************
;	 command DIR [-/[
;************************************************
dir	jsr	sopt
	fcc	'/',0		all directories
	bcs	LC6E3
	jsr	setfiln 	set name
	bcs	LC6E3
	bit	opt
	bpl	LC71C
	and	#$E3
LC719	sta	fdrive
LC71C	lda	#$80
	sta	tcn
	lda	#$F8
LC722	ldx	#$01
	jsr	open
	tax	
	beq	dir2
	cmp	#$13
	bne	LC6E3
;
dir2	asl	tcn
	bcc	LC77A
	lda	mode
	bne	LC752
	inc	mode
	jsr	print
	fcc	'\rDisk:',0
	lda	#$20
	ldy	#$3F
LC746	iny	
	jsr	out
	lda	[sysb],y	floppy name
	bne	LC746
	bit	opt
	bpl	LC755
LC752	txa	
	bne	LC79A		empty
LC755	lda	fdrive
	and	#$1C
	beq	LC773
	jsr	print
	fcc	'\rDirectory: ',0
	lsra	
	lsra	
	ora	#$40
	jsr	out
LC773	lda	#$80
LC775	sta	tcn+1
	jsr	crlf
;
;print filename
LC77A	txa	
	bne	LC797
	lda	#$08
	asl	tcn+1
	bcs	LC775
	jsr	prfile		print rom directory
LC786	jsr	spa		fill until
	iny	
	cpy	#$13
	bcc	LC786
	jsr	break		break?
	lda	#$F9		next file
	bcc	LC722		continue
	lsr	opt
LC797	jsr	crlf
LC79A	bit	opt
	bpl	LC7AA
	asl	mode
	bcs	LC7AA
	lda	fdrive
	adc	#$04
	jmp	LC719
LC7AA	jsr	crlf
	ldy	#$28		s.acnt
	lda	[sysb],y
	tax	
	beq	LC7B5
	dex	
LC7B5	stx	tcn
	ldx	#$00		clear count
	stx	tcn+1
	ldy	#$60		s.bmap
LC7BD	lda	[sysb],y	sector free?
LC7BF	asla
	pha
	bcc	LC7CF
	sed	
	txa	
	adc	tcn
	tax	
	lda	tcn+1
	adc	#$00
	sta	tcn+1
	cld	
LC7CF	pla	
	bne	LC7BF
	iny	
	bne	LC7BD
	lda	tcn+1
	jsr	prax
	jsr	print
	fcc	' blocks free.\r',0
	rts
;
;Ascii command level and argument scan
LC7ED	lda	 efd2
	beq	LC7F9
	txa	
	pha	
	jsr	cloe1		close second level
	pla	
	tax	
LC7F9	lsr	opt
	ror	eopt		set command bit
	lda	efd
	bne	LC82A
	stx	efd		level 1
	jsr	setnex		save argument in ecml
	jsr	setcbp
	ldx	#$00
	jsr	LC815		scan 2 arguments
	jsr	sechar		skip spaces
LC814	inx	
LC815	jsr	bufkey
	beq	LC824		argument terminated
	lda	[tcn],y
	sta	ecml,x
	iny	
	cpx	#$1B		max exec buffer
	bcc	LC814
LC824	lda	#$00		null terminate
	sta	ecml,x
	rts	
LC82A	stx	efd2
	rts	
;
;*************************************************
;	  command @ file : get input from file
;************************************************
exec	ldx	#$81
	bne	LC83F
;
;*************************************************
;	  COMMAND arguments
;************************************************
comrns	ldx	#$81		command
	stx	opt
	stx	csufl
	ldx	#$88
	bne	LC83F
;
;*************************************************
;	  COMMAND RUN file
;************************************************
run	ldx	#$84		open for read and execute
LC83F	jsr	open
	ldy	#$00
	sty	csufl
	bcs	LC898
	ldy	#$04
	lda	[tslb],y
	and	#$03
	cmp	#$01
	beq	LC7ED
	jsr	ld1
	cmp	#$04
	bne	LC891
	jsr	rszp
	jsr	setnex
	ldx	t3+1
	beq	LC887
	bit	opt
	bpl	LC870
	stx	cjmp+1
	ldx	t3
	stx	cjmp
LC870	jmp	[t3]
;
;*************************************************
;	  command LCMD
;************************************************
go11	ldx	cjmp+1
	beq	LC887
	jmp	[cjmp]
;
;*************************************************
;	  command GO address
;************************************************
go	jsr	LC9F1
	bcs	LC887
	cpx	#$80
	bcc	LC887
	fcc	$6C
	beq	LC887
LC887	lda	#$16
	jsr	priner
	fcc	'To?\r',0
LC891	rts
;
;*************************************************
;	  command SAVE [-AB] file beg,end[,start]
;************************************************
save	jsr	sopt
	fcc	'AB',0
LC898	bcs	LC8C3
	jsr	filpar
	bcs	LC8C3
	cpx	#$C0
	bcc	LC8F6
	jsr	insvld
	bcc	LC8F6
	asl	opt
	lda	#$F8
	bcc	LC8BE
	ldx	#$92
	jsr	open
	bcs	LC8C3
	lda	#$04
	jsr	fseek
	bcs	LC8ED
	bcc	LC8D2
LC8BE	ldx	#$E0
	jsr	create
LC8C3	bcs	LC8F0
	jsr	svmset
	bit	opt
	bpl	LC8E7
	ldy	#$F4
	lda	#$02
	bne	LC8D6
LC8D2	ldy	#$F8
	lda	#$01
LC8D6	jsr	outputx
	bcs	LC8ED
	lda	0,y
;
	iny
	cpy	#$F7
	beq	LC8D2
	cpy	#$FD
	bne	LC8D6
LC8E7	jsr	isv4
	jsr	write
LC8ED	jmp	LC93C
LC8F0	jmp	ermese
LC8F3	jsr	close
LC8F6	jmp	LC887
;
;*************************************************
;	  command LOAD file [beg[,end]]
;************************************************
load	jsr	filpar		get name and start addr
	bcs	LC8F0
	ldx	#$80		open for read
	lda	#$F8
	jsr	open
	bcs	LC8F0
ld1	jsr	sv35		get start and run addr
	bit	mode
	bmi	LC91E
	ldy	#$01
	lda	[varb],y
	and	#$03		binary
	beq	LC91E
	eor	#$02
	beq	LC947
	lda	t1+1
	beq	LC8F3
LC91E	bvs	LC926
	lda	#$FE
	sta	t2
	sta	t2+1
LC926	jsr	insvld		set up readpointers
	bcc	LC8F3		error mem
	jsr	read
	bcs	LC937		error
	jsr	sread		test eof
	bcs	LC937
	lda	#$01
LC937	cmp	#$04		empty file
	beq	LC941
	sec	
LC93C	bcc	LC941
	jsr	ermese
LC941	pha	
	jsr	close
	pla	
	rts	
;
;binary load
LC947	jsr	inputx
	bcs	LC937		empty?
	ldy	#$F8
	cmp	#$01		memaddress
	beq	LC958
	ldy	#t3
	cmp	#$02		startaddress
	bne	LC8F3		no
LC958	jsr	inputx
	bcs	LC937		err
	sta	0,y
	iny	
	cpy	#t3+2
	beq	LC947
	cpy	#rln+2		length
	bne	LC958
	jsr	isv4
	jsr	read
	bcc	LC947
	bcs	LC937
;
;get or store file address
getadr	ldy	#$10		put or get addresses
	ldx	#$F0
	bit	mode		test load address
	jsr	geadr
	ldx	#t3
	lda	#$00
geadr	php	
	jsr	gea1
	plp	
gea1	bcc	LC993
	lda	#$00		put to tsl
	bit	opt		binary
	bmi	LC98F
	lda	Z00,x
LC98F	sta	[tslb],y
	bcs	LC999
LC993	bmi	LC999		get from tsl
	lda	[tslb],y
	sta	Z00,x
LC999	iny	
	inx	
	rts	
;
svmset	lda	 mode		set execute
	cmp	#$E0
	bcs	LC9AA
	ldy	t1		set default
	sty	t3
	ldy	t1+1
	sty	t3+1
LC9AA	ldy	#$01
	lda	[varb],y
	and	#$FC
	bit	opt
	bpl	LC9B6
	ora	#$02
LC9B6	sta	[varb],y
	sec	
sv35	jsr	getadr		put addreses in TSL block
	ldx	fd
	rts	
;
;calculate memory range
insvld	lda	 t1		set up read write pointers
	sta	rbg
	lda	t1+1
	sta	rbg+1
	sec			calc bytesc
	lda	t2
	sbc	rbg
	sta	rln
	lda	t2+1
	sbc	rbg+1
	sta	rln+1
	inc	rln		rln incr length
	bne	isv4
	inc	rln+1
	bne	isv4
	sec			set C ok
isv4	ldy	#rbg&255
	lda	#rbg>>8
	rts	
;
;filename and parameters
filpar	jsr	setfiln 	first filename
	bcs	LC9FA
	txa	
	bne	LC9EE
	sta	namb		clear name buffer
LC9EE	jsr	setnex
LC9F1	ldx	#$00
	jsr	spar
	fcb	t1,t2,t3,0
LC9FA	rts	
;

