/* File		test.c */

#define sk_bof 1	/* seek from begin of file */
#define sk_fwd 2	/* seek forward */
#define sk_bwd 3	/* seek backwards */
#define sk_eof 4	/* seek from end of file */

#define ERROR -1
#define EOF -1

direct int count;
direct char buf[20];
direct int ibuf[5];
direct int iibuf[200];	/* does not fit, moved to absolute memory */
direct char *ptr;

int cnt;

extern char errno;	/* last dos65 error number */

main(argc,argv)
int argc,*argv;
{
	char line[80];
	char time[5];	/* seconds are not yet available */
	char c, *s, *fname1, *fname2;
	int fp1, fp2;

/* some tryouts for direct page addressing */

	count = buf[3];
	cnt = count;
	count = cnt;
	ptr = buf;
	c = errno;

/* print current date and time */

	stime (time);
	s = "???janfebmaraprmayjunjulaugsepoctnovdec";
	printf ("date = %2d-%3.3s-19%02d, time = %2d:%02d\n",
		time[2], &s[3*time[1]], time[0], time[3], time[4]);

/* append ascii file1 to ascii file2 */

	if (--argc > 0) fname1 = *++argv;
	else fname1 = "file1.txt";
	if (--argc > 0) fname2 = *++argv;
	else fname2 = "file2.txt";

	if (!(fp2 = fopen (fname2, "r+"))) {
		printf ("Cannot open destination file %s\n", fname2);
		exit (-1);
	}

/* seek to end of file zero bytes backwards */
/* Note that the seek is limited to 64K byte */

	if (seek (fp2, sk_eof, 0) == ERROR) {
		puts ("seek error in destination file");
		fclose (fp2); exit (-1);
	}
	if (!(fp1 = fopen (fname1, "r"))) {
		printf ("Cannot open source file %s\n", fname1);
		fclose (fp2); exit (-1);
	}
		
	while (fgets (line, 80, fp1))
		if (fputs (line, fp2) == ERROR) {
			printf ("error writing to destination file\n");
			fclose (fp1); fclose (fp2); exit (-1);
		}
	fclose (fp2); fclose (fp1);

	puts ("Enter character or EOF");
	while ((c=getchar()) != EOF)
	{
		switch (c)
		{
		case '\n': printf ("return"); break;	/* switch */
		case 'a': printf ("a"); continue;	/* while */
		}
		break;
	}
	exit (1);
}
